function varargout = dist_coulomb(varargin)
% DIST_COULOMB M-file for dist_coulomb.fig

gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @dist_coulomb_OpeningFcn, ...
                   'gui_OutputFcn',  @dist_coulomb_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end


% --- Executes just before dist_coulomb is made visible.
function dist_coulomb_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to dist_coulomb (see VARARGIN)
global gapp %global variable shared among all instances of matslise
i = 1;
number_set=false;
while i < length(varargin)
switch varargin{i}
    case 'S'
        S = varargin{i+1};
        set(handles.S_edit,'String',S);
    case 'R'
        R = varargin{i+1};
        set(handles.R_edit,'String',R);
    case 'l'
        l = varargin{i+1};
        set(handles.l_edit,'String',l);
    case 'xmax'
        xmax = varargin{i+1};
        set(handles.max_edit,'String',xmax);
    case 'tol'
        set(handles.tol_edit,'String',varargin{i+1});
    case 'info'
        s=strrep(varargin{i+1},'                        ','\n');
        while strfind(s,'\n\n')
            s=strrep(s,'\n\n','\n');
        end
        s=strrep(s,'\n',sprintf('\n'));
        set(handles.problemInfo_edit,'String',s);
    case 'parameterName'
        set([handles.parameterName_edit,handles.parameter_text],'Enable','On');
        set(handles.parameterName_edit,'String',varargin{i+1}); 
    case 'parameterValue'
       set(handles.parameter_checkbox,'Value',get(handles.parameter_checkbox,'Max'));
       set([handles.parameterValue_edit,handles.parameterValue_text],'Enable','On');
       set(handles.parameterValue_edit,'String',varargin{i+1});    
   case 'result_pot'
       set(handles.pot_edit,'String',varargin{i+1});
   case 'Name'
       name = varargin{i+1}; %name of the current problem
       if isfield(gapp,'names')
        name = test_names(name);
        gapp.names = [gapp.names;{name}];
       else
          gapp.names ={name};
       end
       set(hObject,'Name',name);
       handles.name = name;  
   case 'Number_problem'
             handles.number_matslise = varargin{i+1};
             number_set=true;     
end
i = i+2;
end
if ~isfield(handles,'name')
  name=inputdlg('Enter a name for the new problem.','Input Name');
   if isempty(name)
       name='Untitled';
   else
       name = name{1};
   end
   if isfield(gapp,'names')
          name = test_names(name);
          gapp.names = [gapp.names;{name}];
   else
          gapp.names ={name};
   end
   handles.name = name;
   set(handles.dist_coulomb,'Name',handles.name);
end
if ~number_set
  if isfield(gapp,'number_problems')
    gapp.number_problems = gapp.number_problems+1; %number of instances of matslise
  else
    gapp.number_problems = 1;
  end
  handles.number_matslise = gapp.number_problems; %number representing current instance of matslise
end
handles.showBasicPartition = false;
set(handles.stop_button,'Enable','off');
fill_potential_field(handles);
% Choose default command line output for dist_coulomb
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = dist_coulomb_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%----------------------------------------------------------------------
%-----------------------Create functions-------------------------------
%----------------------------------------------------------------------

function l_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function S_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function R_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function method_popup_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function tol_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function parameterValue_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function problemInfo_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function info_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function max_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function pot_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function parameterName_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


%----------------------------------------------------------------------
%-----------------------Callback functions-----------------------------
%----------------------------------------------------------------------


% --- Executes on button press in construct_button.
function construct_button_Callback(hObject, eventdata, handles)
global gapp
if isfield(gapp,'eigenvalue_window') && length(gapp.eigenvalue_window)>=(handles.number_matslise) && ishandle(gapp.eigenvalue_window(handles.number_matslise))
    try
       delete(gapp.eigenvalue_window(handles.number_matslise));
    catch
    end
end
stop = 0;
save stop.mat stop;
try
syms x;
set(handles.stop_button,'Enable','on');
set([handles.construct_button,handles.exit_button,handles.plotpotential_button],'Enable','off');
set(handles.info_edit,'String','Busy...');
drawnow
S = get(handles.S_edit,'String');
R = get(handles.R_edit,'String');
l = get(handles.l_edit,'String');
if isempty(S) || isempty(R) || isempty(l)
   error('Error!!! : You should fill in all the input fields before pressing the Construct-button.')
end
parameter_range = false;
try
     if get(handles.parameter_checkbox,'Value') == get(handles.parameter_checkbox,'Max')
      pn = get(handles.parameterName_edit,'String');
      pns = eval_parameterNames(pn);
      pp = get(handles.parameterValue_edit,'String');
      if isempty(pp)
        error('Error!!! : You must enter a numeric value or vector as parametervalue');
      end
      pp = eval_parameterValues(pp);
      if ~isa(pp{1},'sym')
        if isnan(pp{1}) 
          error('Error!!! : You must enter a numeric value or vector as parametervalue');
        end
      end
      S = sym(S);
      R = sym(R);
      l = sym(l);
      for i=1:length(pp)
        if length(pp{i}) > 1
            if parameter_range
                error('Error!!! : Only one of the parametervalues is allowed to be a vector!')
            end
            parameter_range = true;
            range_p = pp{i};
            range_n = pns(i);
            continue;
        else
          if  ~isempty(findsym(sym(S))) && ~isempty(findstr(char(S),char(pns(i))))
            S = sym(subs(S,pns(i),pp{i}));
          end
          if ~isempty(findsym(sym(R))) && ~isempty(findstr(char(R),char(pns(i))))
            R = sym(subs(R,pns(i),pp{i}));
          end
          if ~isempty(findsym(sym(l))) && ~isempty(findstr(char(l),char(pns(i))))
            l = sym(subs(l,pns(i),pp{i}));  
          end
        end
       end
        S = char(S);
        R = char(R);
        tmp=abs(imag(l));
        l = char(l);
        pot = ['((' l ')*((' l ')+1))/(x^2)+(' S ')/x+('  R ')'];
        if ~parameter_range && ~(double(tmp)>0) 
            pot = char(eval(sym(pot)));
        else 
            pot0=pot;
            pot = char(simplify(sym(pot)));
            if strfind(pot,'csgn');
                pot = pot0;
            end
        end
        set(handles.pot_edit,'String',pot);
        drawnow;
    else
      pot = ['((' l ')*((' l ')+1))/(x^2)+(' S ')/x+('  R ')'];
      pot = char(eval(sym(pot)));
      set(handles.pot_edit,'String',pot);
      drawnow;
    end
catch
      errordlg(lasterr);
      set(handles.pot_edit,'String','');
end
tol = str2double(get(handles.tol_edit,'String'));
rmax = str2double(get(handles.max_edit,'String'));
if isnan(l)
    error('Error!!! : You must enter a numeric value for l')
end
if isnan(tol)
    error('Error!!! : You must enter a numeric value for tol')
end
if tol < 1e-14
     h = warndlg(['This tolerance can''t be achieved within the floating-point relative accuracy' ...
         ' of the MATLAB-environment. The tolerance has been set to 1e-14.']);
     movegui(h,'onscreen');
     tol = 1e-14;    
end
if isnan(rmax)
    error('Error!!! : You must enter a numeric value for xmax')  
end
if rmax < 0
    error('Error!!! : You must enter a positive value for xmax') 
end
if get(handles.parameter_checkbox,'Value') == get(handles.parameter_checkbox,'Max')
   if ~parameter_range
        l = str2num(l);
   end
else  
        l = eval(l);
end
if ~parameter_range
    schrodi = false;
    if strcmp(S,'0') && l == 0 
        schrodi = true;
        problem = schrod(pot,0,rmax,1,0,1,0);
        class=get(problem,'classification');
        switch class.category
          case {3,7,4,5,6}
            class.infostring =[class.infostring 'Sorry, the problem can''t be solved using MATSLISE!'];
          otherwise
            [handles.cpm,stat] = cpm16_14(problem,tol);            
        end
    else 
       t=cputime; 
       problem = distorted_coulomb(l,S,R,rmax);
       class=get(problem,'classification');
       switch class.category
        case {3,7,4,5,6}
            class.infostring =[class.infostring 'Sorry, the problem can''t be solved using MATSLISE!'];
        otherwise
           coul_time=cputime-t;
           [handles.cpm,stat] = cpm16_14(problem,tol); 
           stat.coul_time=coul_time;
       end
    end
    if isinf(rmax) 
      set(handles.info_edit,'String','Ready');
    else
      s = '';  
      if ~schrodi
        s = sprintf('CPU-time for the Distorted Coulomb construction: %4.2f s',stat.coul_time);
        s = sprintf('%s\n-------------------------------------------------------------------\n',s);
      end
      s = sprintf('%sNumber of intervals in the partition: %d',s,stat.number_intervals_bp);
      s = sprintf('%s\nNumber of function-evaluations ( in V(x) ): %d',s,stat.nfev);
      s = sprintf('%s\nCPU-time for calculating the partitions: %4.2f s',s,stat.part_time);
      set(handles.info_edit,'String',s);
    end
    switch class.category
        case {1,2,10,8,9}
            gapp.eigenvalue_window(handles.number_matslise) = eigenvalues_window('CPM',handles.cpm,...
            'problem',problem,'Name',handles.name,'number_matslise',handles.number_matslise);
            movegui(gapp.eigenvalue_window(handles.number_matslise),'north');
    end
    h=msgbox(class.infostring,'Classification Information','replace');
 else %parameter_range
    if isfield(handles,'cpm')
       handles = rmfield(handles,'cpm');
    end
    for i=1:length(range_p)
        set(handles.info_edit,'String',['Constructing cpm for ' char(range_n) ' = ' num2str(range_p(i))]);
        drawnow;
        if ~isempty(findsym(sym(S)))
           Sp = sym(subs(sym(S),range_n,range_p(i)));
           Sp = char(Sp);
        else
           Sp =S;
        end
        if ~isempty(findsym(sym(R)))
           Rp = sym(subs(sym(R),range_n,range_p(i)));
           Rp = char(Rp);
        else
            Rp = R;
        end
        if ~isempty(findsym(sym(l)))
           lp = sym(subs(sym(l),range_n,range_p(i)));
           lp = eval(lp);
        else
           lp = eval(l);
        end
        problem(i) = distorted_coulomb(lp,Sp,Rp,rmax);
        if strcmp(Sp,'0') && lp == 0 
          pot = char(get(problem(i),'V'));
          prob = schrod(pot,0,rmax,1,0,1,0);
          [handles.cpm(i),stat] = cpm16_14(prob,tol); 
        else
          handles.cpm(i) = cpm16_14(problem(i),tol); 
        end
    end
    set(handles.info_edit,'String','Ready');
    gapp.eigenvalue_window(handles.number_matslise) = param_eigenvalues_window('CPM',handles.cpm,'parameterName',...
        char(range_n),'parameterValues',range_p,'Name',handles.name,'number_matslise',handles.number_matslise);
    movegui(gapp.eigenvalue_window(handles.number_matslise),'north');
    s='';
    n=sprintf('\n');
    for i=1:length(range_p)   
        class(i)=get(problem(i),'classification');
        switch class(i).category
         case {3,7,4,5,6}
              class.infostring =[class.infostring 'Sorry, this problem can''t be solved using MATSLISE!'];
        end
        cat(i)=class(i).category;
        ss=strrep(class(i).infostring,[n n],n);
        s=[s 'For ' char(range_n) ' = ' num2str(range_p(i)) ':' n ss];
        s=[s n ];
    end
    if length(range_p)<5
          h=msgbox(s,'Classification Information','replace');
    else 
        s=['For ' char(range_n) ' = ' num2str(range_p(1)) ':'];
        s=[s n strrep(class(1).infostring,[n n],n)];
        s2=['For ' char(range_n) ' = ' num2str(range_p(end)) ':'];       
        s2=[s2 n strrep(class(end).infostring,[n n],n)];
        s=[s n s2];
        h=msgbox(s,'Classification Information','replace');
   end
    guidata(hObject,handles)
  end
  if ~parameter_range && handles.showBasicPartition
    if isfield(gapp,'partition_plot') && length(gapp.partition_plot)>=(handles.number_matslise) && ishandle(gapp.partition_plot(handles.number_matslise))
        try
          delete(gapp.partition_plot(handles.number_matslise));
        catch
        end
    end
    pot = get(problem,'V');
    a = get(get(handles.cpm,'schrod'),'min');
    b = get(get(handles.cpm,'schrod'),'max');
    if isinf(b)
      error('Error!!! : The partition of an infinite problem can''t be shown at this stage. (uncheck the "Show partiton" option)');
    end
    bp = get(handles.cpm,'bp');
    x = [a, a+cumsum(bp.h)];
    gapp.partition_plot(handles.number_matslise) =  partition_plot_window('Name',handles.name,...
      'V',char(pot),'a',a,'b',b,'x_bp',x,'Vbar',bp.V0,'imatch',bp.imatch);
  end
catch
    hlp=strfind(lasterr,'Error!!! : ');
    if isempty(hlp)
       errordlg(lasterr,'Error','modal');
    else
       msg=lasterr; 
       errordlg(msg(hlp(1)+11:end),'Error','modal');
    end
    set(handles.info_edit,'String','Ready');
end
set(handles.stop_button,'Enable','off');
set([handles.construct_button,handles.exit_button,handles.plotpotential_button],'Enable','on');
guidata(hObject,handles)

% --- Executes on button press in exit_button.
function exit_button_Callback(hObject, eventdata, handles)
close(handles,true);

% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.dist_coulomb)

% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
close(handles,true);

% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
%Opens helpitem about the distorted Coulomb problem
HelpPath = which('dist_coulomb.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','distorted_coulomb.html');
web(HelpPath);


% --------------------------------------------------------------------
function Matslise_help_item_Callback(hObject, eventdata, handles)
%Opens help about matslise
HelpPath = which('dist_coulomb.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'helpfiles','matslise.html');
web(HelpPath);

% --------------------------------------------------------------------
function OpenItem_Callback(hObject, eventdata, handles)
%Open a problem which was saved earlier
d = pwd;
try
HelpPath = which('regular_schrodinger.m');
[pathstr,name,ext] = fileparts(HelpPath);
cd(pathstr)
cd predefined_problems
catch
end
try
[filename, pathname] = uigetfile( ...
{'*.mat','MAT-files (*.mat)'}, 'Select the problem to open');
if isequal([filename,pathname],[0,0])
    cd(d);
    return;
end
file=fullfile(pathname,filename);
if exist(file) == 2
    S = load(file);
else
    cd(d);
    errordlg('The file doesn''t exist','Error','modal');
    return;
end
[pathstr,fname,ext]=fileparts(filename);
if strcmp(S.type,'regular-schrodinger')
    pos1=get(handles.dist_coulomb,'Position');
    close_problem(handles.number_matslise);
    delete(handles.dist_coulomb)
    if S.parameter
       h=regular_schrodinger('V',S.V,'a',S.a,'b',S.b,'a0',S.a0,'a1',...
        S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'parameterName',...
        S.parameterName,'parameterValue',S.parameterValue,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
       h=regular_schrodinger('V',S.V,'a',S.a,'b',S.b,'a0',S.a0,'a1',...
        S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    pos2=get(h,'Position');
    set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
    movegui(h,'onscreen');
elseif strcmp(S.type,'sturm-liouville')
    pos1=get(handles.dist_coulomb,'Position');
    close_problem(handles.number_matslise);
    delete(handles.dist_coulomb)
    if S.parameter
      h=sturm_liouville('p',S.p,'q',S.q,'w',S.w,'a',S.a,'b',S.b,...
      'a0',S.a0,'a1',S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,...
      'parameterValue',S.parameterValue,'parameterName',S.parameterName,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
      h=sturm_liouville('p',S.p,'q',S.q,'w',S.w,'a',S.a,'b',S.b,...
      'a0',S.a0,'a1',S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    pos2=get(h,'Position');
    set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
    movegui(h,'onscreen');
elseif strcmp(S.type,'distorted-coulomb')
    pos1=get(handles.dist_coulomb,'Position');
    close_problem(handles.number_matslise);
    delete(handles.dist_coulomb)
    if S.parameter
      h=dist_coulomb('S',S.S,'R',S.R,'l',S.l,'tol',S.tol,...
      'xmax',S.xmax,'parameterValue',S.parameterValue,'parameterName',S.parameterName,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
      h=dist_coulomb('S',S.S,'R',S.R,'l',S.l,'tol',S.tol,...
      'xmax',S.xmax,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    pos2=get(h,'Position');
    set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
    movegui(h,'onscreen');
end
catch
    errordlg(lasterr,'Error','modal');
end
cd(d);

% --------------------------------------------------------------------
function RegularSchrodingerItem_Callback(hObject, eventdata, handles)
% Open a new regular Schrodinger problem
pos1=get(handles.dist_coulomb,'Position');
close(handles,false);
h=regular_schrodinger;
pos2=get(h,'Position');
set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
movegui(h,'onscreen');

% --------------------------------------------------------------------
function SturmLiouvilleItem_Callback(hObject, eventdata, handles)
% Open a new Sturm-Liouville problem
pos1=get(handles.dist_coulomb,'Position');
close(handles,false);
h=sturm_liouville;
pos2=get(h,'Position');
set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
movegui(h,'onscreen');

% --------------------------------------------------------------------
function DistortedCoulombItem_Callback(hObject, eventdata, handles)
%Open a new distorted Coulomb problem
pos1=get(handles.dist_coulomb,'Position');
close(handles,false);
h=dist_coulomb;
pos2=get(h,'Position');
set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
movegui(h,'onscreen');

%---------------------------------------------------------------------
function S_edit_Callback(hObject, eventdata, handles)
fill_potential_field(handles);

%---------------------------------------------------------------------
function R_edit_Callback(hObject, eventdata, handles)
fill_potential_field(handles);

%---------------------------------------------------------------------
function l_edit_Callback(hObject, eventdata, handles)
fill_potential_field(handles);

% --- Executes on button press in parameter_checkbox.
function parameter_checkbox_Callback(hObject, eventdata, handles)
if get(hObject,'Value') == get(hObject,'Max')
    set([handles.parameterValue_edit,handles.parameterValue_text,...
        handles.parameterName_edit,handles.parameter_text],'Enable','On');  
else
     set([handles.parameterValue_edit,handles.parameterValue_text,...
        handles.parameterName_edit,handles.parameter_text],'Enable','Off');  
    set(handles.parameterValue_edit,'String','');
    set(handles.parameterName_edit,'String','');
end

%----------------------------------------------------------------------
function parameterValue_edit_Callback(hObject, eventdata, handles)
fill_potential_field(handles);

% --- Executes on button press in stop_button.
function stop_button_Callback(hObject, eventdata, handles)
stop = 1;
save stop.mat stop;


% --- Executes on button press in plotpotential_button.
function plotpotential_button_Callback(hObject, eventdata, handles)
global gapp
fill_potential_field(handles);
try
set([handles.stop_button,handles.construct_button,handles.exit_button,handles.plotpotential_button],...
    'Enable','off');
set(handles.info_edit,'String','Busy...');
drawnow;
if isfield(gapp,'potential_plot') && length(gapp.potential_plot)>=handles.number_matslise && ishandle(gapp.potential_plot(handles.number_matslise))
    try
      delete(gapp.potential_plot(handles.number_matslise));
    catch
    end
end
V = get(handles.pot_edit,'String');
a = 0;
b = get(handles.max_edit,'String');
if isempty(V) || isempty(b)
    error('The input is not correct: please fill in all the fields correctly.');
end
parameter_range = false;
if get(handles.parameter_checkbox,'Value') == get(handles.parameter_checkbox,'Max')
  syms x;
  pp = get(handles.parameterValue_edit,'String');
  if isempty(pp)
      error('You must enter a numeric value or vector as parametervalue');
  end
  pp = eval_parameterValues(pp);
  if ~isa(pp{1},'sym')
    if isnan(pp{1}) 
      error('You must enter a numeric value or vector as parametervalue');
    end
  end
  pn = get(handles.parameterName_edit,'String');
  pns = eval_parameterNames(pn);
  for i=1:length(pp)
    if length(pp{i}) == 1
      b = sym(subs(sym(b),pns(i),pp{i}));
    else
      parameter_range = true;
      range_p = pp{i};
      range_n = pns(i);
    end
  end
end
if ~parameter_range
    b = eval(b); 
    gapp.potential_plot(handles.number_matslise) = potential_plot_window('Name',handles.name ,...
         'a',min(0.1,b-1e-2),'b',b,'V',V);
else
    b=char(b);
    if isempty(findsym(sym(b))) || isinf(str2num(b))
        noParamInAorB = true;
    else
        noParamInAorB = false;
    end
    for i=1:length(range_p)  
      Vp{i} = [char(eval(subs(sym(V),range_n,range_p(i)))) '+0*x'];
      bp(i) = eval(sym(subs(sym(b),range_n,range_p(i))));
      ap(i) = 0.1;
    end
     gapp.potential_plot(handles.number_matslise) = potential_plot_window('Name',handles.name ,...
         'a',ap,'b',bp,'V',Vp,'parameterName',char(range_n),'parameterValues',range_p,'Vparam',char(V),...
         'noParamInAorB',noParamInAorB);
end
catch
    errordlg(lasterr,'Error','modal')
end
set([handles.construct_button,handles.exit_button,handles.plotpotential_button],...
    'Enable','on');
set(handles.info_edit,'String','Ready...');


% --------------------------------------------------------------------
function SaveItem_Callback(hObject, eventdata, handles)
    % save the problem
d = pwd;
try
HelpPath = which('regular_schrodinger.m');
[pathstr,name,ext] = fileparts(HelpPath);
cd(pathstr)
cd predefined_problems
catch
end
try
[FileName,PathName,FilterIndex]=uiputfile({'*.mat','MAT-files (*.mat)'},'Save problem as ...',handles.name);
if strcmp(FileName,'0') || strcmp(PathName,'0') || FilterIndex == 0
    cd(d);
    return;
end
S = get(handles.S_edit,'String');
if isempty(S)
    error('You should fill in all the fields');
end
R = get(handles.R_edit,'String');
if isempty(R)
    error('You should fill in all the fields');
end
l = get(handles.l_edit,'String');
if isempty(l)
    error('You must enter a value for l');
end
xmax = get(handles.max_edit,'String');
if isempty(xmax)
    error('You must enter a numeric value for xmax');
end
tol = get(handles.tol_edit,'String');
if isempty(tol) 
    error('You must enter a positive numeric value for tol');
end
info = get(handles.problemInfo_edit,'String');
parameter = false;
if get(handles.parameter_checkbox,'Value') == get(handles.parameter_checkbox,'Max')
  parameter = true;  
  parameterValue = get(handles.parameterValue_edit,'String');
  parameterName = get(handles.parameterName_edit,'String');
  if isempty(parameterValue) || isempty(parameterName)
      error('You should fill in the parameterfields');
  end
end
file=fullfile(PathName,[FileName]);
type = 'distorted-coulomb';
if parameter 
    save(file,'type','S','R','l','xmax','tol','parameter','parameterValue','parameterName','info');
else
    save(file,'type','S','R','l','xmax','tol','parameter','info');
end
catch
    errordlg(lasterr,'Error','modal');
end
cd(d);


%---------------------------------------------------------------------
function pvs = eval_parameterValues(s)
% used to distinguish between the parameter values
syms x;
chopped = 'tst';
i = 1;
remainder = s;
while any(remainder)
  [chopped,remainder] = strtok(s,',');
  if chopped(1) == '[' && any(remainder)
    [chopped2,remainder] = strtok(remainder,']');
    chopped = [chopped chopped2 ']'];
    pvs{i} = eval(chopped);
    if remainder == ']'
      remainder = '' ;   
    else
      remainder=remainder(2:end);
    end
  else
    pvs{i} = eval(chopped);
  end  
  i = i+1;
  s = remainder;
end

%-------------------------------------------------------------------
 function pns = eval_parameterNames(s)
 %used to distinguish between the parameter names
 remainder = s;
 pns =[];
 while any(remainder)
   [chopped,remainder] = strtok(remainder,',');
   pns = [pns,sym(chopped)];
end

%--------------------------------------------------------------------
function fill_potential_field(handles)
% try to fill in the "resulting potential function" field
S = get(handles.S_edit,'String');
R = get(handles.R_edit,'String');
l = get(handles.l_edit,'String');
if isempty(S) || isempty(R) || isempty(l)
    return;
end
syms x;
try
    if get(handles.parameter_checkbox,'Value') == get(handles.parameter_checkbox,'Max')
      pn = get(handles.parameterName_edit,'String');
      pns = eval_parameterNames(pn);
      pp = eval_parameterValues(get(handles.parameterValue_edit,'String'));
      S = sym(S);
      R = sym(R);
      l = sym(l);
      range = false;
      for i=1:length(pp)
        if length(pp{i}) > 1
            range = true;
          continue;
        else
          if  ~isempty(findsym(sym(S))) && ~isempty(findstr(char(S),char(pns(i))))
            S = sym(subs(S,pns(i),pp{i}));
          end
          if ~isempty(findsym(sym(R))) && ~isempty(findstr(char(R),char(pns(i))))
            R = sym(subs(R,pns(i),pp{i}));
          end
          if ~isempty(findsym(sym(l))) && ~isempty(findstr(char(l),char(pns(i))))
            l = sym(subs(l,pns(i),pp{i}));  
          end
        end
       end
        S = char(S);
        R = char(R);
        tmp=abs(imag(l));
        l = char(l);
        pot = ['((' l ')*((' l ')+1))/(x^2)+(' S ')/x+('  R ')'];
        if ~range && ~(double(tmp)>0)
          pot = char(eval(sym(pot)));
        else %double(tmp)>0
          pot0=pot;
          pot = char(simplify(sym(pot)));
          if strfind(pot,'csgn')
              pot =pot0;
          end
        end
        set(handles.plotpotential_button,'Enable','on');
        set(handles.pot_edit,'String',pot);
        drawnow;
    else
      pot = ['((' l ')*((' l ')+1))/(x^2)+(' S ')/x+('  R ')'];
      pot = char(eval(sym(pot)));
      set(handles.pot_edit,'String',pot);
      set(handles.plotpotential_button,'Enable','on');
      drawnow;
    end
catch
      set(handles.pot_edit,'String','');
end

%----------------------------------------------
function close(handles,quest)
global gapp
if quest
selection = questdlg(['Close ' get(handles.dist_coulomb,'Name') '?'],...
                     ['Close ' get(handles.dist_coulomb,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end
end
close_problem(handles.number_matslise);
delete(handles.dist_coulomb)
gapp.number_problems = gapp.number_problems-1;
if gapp.number_problems == 0
    clear_gapp;
end

% --------------------------------------------------------------------
function ShowPartition_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'Checked'),'off')
  set(hObject,'Checked','on');
  handles.showBasicPartition = 1;
else
  set(hObject,'Checked','off');  
  handles.showBasicPartition = 0;
end
guidata(hObject,handles)


% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
About_msgbox;


% --- Executes when user attempts to close dist_coulomb.
function dist_coulomb_CloseRequestFcn(hObject, eventdata, handles)
close(handles,true);





