function varargout = eigenfunction_plot(varargin)
% EIGENFUNCTION_PLOT M-file for eigenfunction_plot.fig

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenfunction_plot_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenfunction_plot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenfunction_plot is made visible.
function eigenfunction_plot_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenfunction_plot (see VARARGIN)
stop = 0;
save stop.mat stop;
set(handles.info_edit,'String','Busy...');
drawnow;
i = 1;
handles.showRoots=false;
while i < length(varargin)
switch varargin{i}
    case 'CPM'
        handles.cpm = varargin{i+1};
    case 'eigenvector'
        handles.current_eigenvector = varargin{i+1};
    case 'eigenvalue'
        handles.eigenvalue = varargin{i+1};
    case 'index'
        handles.index = varargin{i+1};
    case 'status'
        status = varargin{i+1};
    case 'halfrangereduction'
        handles.halfrange_reduction = varargin{i+1};
    case 'Name'
        handles.name = varargin{i+1};
        set(handles.eigenfunction_plot,'Name',[handles.name ': eigenfunction ' num2str(handles.index)]);
    case 'number_matslise'
        handles.number_matslise = varargin{i+1};
end
i = i+2;
end
sch = get(handles.cpm(1),'schrod');
if isa(sch,'distorted_coulomb')
    V=get_eigenfunction(handles.cpm,handles.eigenvalue,2);
    len = floor(V.x(end)-get(sch,'min'));
else
    len = floor(get(sch,'max')-get(sch,'min'));
end
if ~isfield(handles,'current_eigenvector') 
   if isa(sch,'transformed_slp') 
      points = 59 + ceil(handles.index/5)*25 + len; 
      %slp:less points to save time, because performing the liouville-transformation takes also a lot of time
   else
      if isa(sch,'distorted_coulomb')
         points = 69 + (handles.index+1)*30 + floor(len*0.3);
      else
         points = 69 + ceil(handles.index/4)*25 + len;
      end
   end
   points=min(points,2000);
      if handles.halfrange_reduction
             if mod(handles.index,2)==0
                  [EV,status] = get_eigenfunction(handles.cpm(1),handles.eigenvalue,points); 
                  EV.x = [-(EV.x(length(EV.x):-1:2)) EV.x];
                  EV.y = [EV.y(length(EV.y):-1:2) EV.y]./sqrt(2);
                  EV.yprime = [EV.yprime(length(EV.yprime):-1:2) EV.yprime]./sqrt(2); 
             else
                  [EV,status] = get_eigenfunction(handles.cpm(2),handles.eigenvalue,points); 
                  EV.x = [-(EV.x(length(EV.x):-1:2)) EV.x];
                  EV.y = [EV.y(length(EV.y):-1:2) -EV.y]./sqrt(2);
                  EV.yprime = [EV.yprime(length(EV.yprime):-1:2) -EV.yprime]./sqrt(2); 
             end
             handles.current_eigenvector = EV;
       else
             [handles.current_eigenvector,status] = get_eigenfunction(handles.cpm,handles.eigenvalue,points);
       end
end
if status == 1
    warndlg('The normalisation may not have succeeded.')
end
handles.eigenvector=handles.current_eigenvector;
handles.min = handles.current_eigenvector.x(1);
set(handles.a_edit,'String',num2str(handles.min));
handles.max = handles.current_eigenvector.x(end);
set(handles.b_edit,'String',num2str(handles.max));
set(handles.points_edit,'String',length(handles.current_eigenvector.x));
handles.color = 'b';
handles.Markers = false;
%handles.marker = '.';
handles.lineType = '-';
handles.lineWidth = 1.5;
axes(handles.eigenvectorAxes);
set(handles.info_edit,'String','Ready');
set([handles.plot_button,handles.close_button,handles.values_button],'Enable','on');
set([handles.points_edit,handles.a_edit,handles.b_edit,handles.points_text,handles.interval_text,handles.to_text],'Enable','on');
drawnow;
guidata(hObject, handles);
handles.phandles=plot_eigenvector(handles);
% Choose default command line output for eigenfunction_plot
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = eigenfunction_plot_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%----------------------------------------------------------------------
%----------------------Create functions--------------------------------
%----------------------------------------------------------------------
function a_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function points_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function b_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function info_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%----------------------------------------------------------------------
%----------------------Callback functions------------------------------
%----------------------------------------------------------------------

% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
if isfield(handles,'eigenvectorDataWindow') && ishandle(handles.eigenvectorDataWindow)
  delete(handles.eigenvectorDataWindow)
end
delete(handles.eigenfunction_plot)

% --- Executes on button press in plot_button.
function plot_button_Callback(hObject, eventdata, handles)
set([handles.plot_button,handles.close_button,handles.values_button],'Enable','off');
set([handles.points_edit,handles.a_edit,handles.b_edit,handles.points_text,handles.interval_text,handles.to_text],'Enable','off');
a = str2double(get(handles.a_edit,'String'));
b = str2double(get(handles.b_edit,'String'));
if isnan(a) || isnan(b)
    errordlg('You must enter a numeric value','Bad Input','modal')
elseif (a < handles.min && abs(a - handles.min) > 0.001) || (b > handles.max && abs(b - handles.max) > 0.001)
    errordlg(sprintf('The X-interval must be a subinterval of the interval [%d , %f]',handles.min,handles.max),...
        'Bad Input','modal');
else
    set(handles.info_edit,'String','Busy...');
    drawnow
    if abs(b - handles.max) <= 0.001
        b = handles.max;
    end
    if abs(a - handles.min) <= 0.001
        a = handles.min;
    end
    p = str2double(get(handles.points_edit,'String'))-1;
    if isnan(p)
        errordlg('Number of points must be a numeric value','Bad Input','modal')
    else
      try
          if handles.halfrange_reduction 
              if a==-b
             if mod(handles.index,2)==0
                 [EV,status] = get_eigenfunction(handles.cpm(1),handles.eigenvalue,0,b,ceil(p/2)); 
                  EV.x = [-(EV.x(length(EV.x):-1:2)) EV.x];
                  EV.y = [EV.y(length(EV.y):-1:2) EV.y]./sqrt(2);
                  EV.yprime = [EV.yprime(length(EV.yprime):-1:2) EV.yprime]./sqrt(2); 
             else
                 [EV,status] = get_eigenfunction(handles.cpm(2),handles.eigenvalue,0,b,ceil(p/2));
                  EV.x = [-(EV.x(length(EV.x):-1:2)) EV.x];
                  EV.y = [EV.y(length(EV.y):-1:2) -EV.y]./sqrt(2);
                  EV.yprime = [EV.yprime(length(EV.yprime):-1:2) -EV.yprime]./sqrt(2); 
             end
             handles.current_eigenvector = EV;
              else
                  error('You selected halfrange reduction for this problem: please take a symmetric interval [-b,b].')
              end
          else
              [handles.current_eigenvector,status] = get_eigenfunction(handles.cpm(1),handles.eigenvalue,a,b,p);
         end
      catch
          set([handles.plot_button,handles.close_button,handles.values_button],'Enable','on');
          set([handles.points_edit,handles.a_edit,handles.b_edit,handles.points_text,...
                handles.interval_text,handles.to_text],'Enable','on');
          set(handles.info_edit,'String','Ready');
          errordlg(lasterr,'Error','modal');
          return;
      end
      handles.phandles = plot_eigenvector(handles);
      if status == 1
         warndlg('The normalisation may not have succeeded. The solution may be incorrect.')
      elseif max(abs(handles.current_eigenvector.y)) < 0.05
          warndlg('The normalisation may not have succeeded.');
      end
   end
   set(handles.info_edit,'String','Ready');
end
set([handles.plot_button,handles.close_button,handles.values_button],'Enable','on');
set([handles.points_edit,handles.a_edit,handles.b_edit,handles.points_text,...
        handles.interval_text,handles.to_text],'Enable','on');
guidata(hObject, handles);

% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.eigenfunction_plot)


% --------------------------------------------------------------------
function OpenNewItem_Callback(hObject, eventdata, handles)
%open plot in new window
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigenvector(handles,ahandle,true);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');
plot_eigenvector(handles);


% --------------------------------------------------------------------
function red_Callback(hObject, eventdata, handles)
% color -> red
handles.color = 'r';
off = [handles.yellow,handles.blue,handles.black,handles.green,handles.magenta,handles.cyan];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function green_Callback(hObject, eventdata, handles)
% color -> green
handles.color = 'g';
off = [handles.yellow,handles.blue,handles.red,handles.black,handles.magenta,handles.cyan];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function blue_Callback(hObject, eventdata, handles)
% color -> blue
handles.color = 'b';
off = [handles.yellow,handles.black,handles.red,handles.green,handles.magenta,handles.cyan];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function cyan_Callback(hObject, eventdata, handles)
% color -> cyan
handles.color = 'c';
off = [handles.yellow,handles.blue,handles.red,handles.green,handles.magenta,handles.black];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function magenta_Callback(hObject, eventdata, handles)
% color -> magenta
handles.color = 'm';
off = [handles.yellow,handles.blue,handles.red,handles.green,handles.black,handles.cyan];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function yellow_Callback(hObject, eventdata, handles)
% color -> yellow
handles.color = 'y';
off = [handles.black,handles.blue,handles.red,handles.green,handles.magenta,handles.cyan];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function black_Callback(hObject, eventdata, handles)
% color black
handles.color = 'k';
off = [handles.yellow,handles.blue,handles.red,handles.green,handles.magenta,handles.cyan];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function plus_Callback(hObject, eventdata, handles)
% marker ->plus-sign
handles.marker = '+';
off = [handles.asterisk,handles.square,handles.triangle,handles.pentagram,handles.point,...
        handles.circle,handles.diamond,handles.cross,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function circle_Callback(hObject, eventdata, handles)
% marker ->circle
handles.marker = 'o';
off = [handles.asterisk,handles.plus,handles.triangle,handles.pentagram,handles.point,...
        handles.square,handles.diamond,handles.cross,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function asterisk_Callback(hObject, eventdata, handles)
% markers -> asterisk
handles.marker = '*';
off = [handles.square,handles.plus,handles.triangle,handles.pentagram,handles.point,...
        handles.circle,handles.diamond,handles.cross,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function point_Callback(hObject, eventdata, handles)
% markers -> point
handles.marker = '.';
off = [handles.asterisk,handles.plus,handles.triangle,handles.pentagram,handles.square,...
        handles.circle,handles.diamond,handles.cross,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function cross_Callback(hObject, eventdata, handles)
%markers -> cross
handles.marker = 'x';
off = [handles.asterisk,handles.plus,handles.triangle,handles.square,handles.point,...
        handles.circle,handles.diamond,handles.pentagram,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function square_Callback(hObject, eventdata, handles)
% markers -> square
handles.marker = 's';
off = [handles.asterisk,handles.plus,handles.triangle,handles.pentagram,handles.point,...
        handles.circle,handles.diamond,handles.cross,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function diamond_Callback(hObject, eventdata, handles)
% markers -> diamond
handles.marker = 'd';
off = [handles.asterisk,handles.plus,handles.triangle,handles.square,handles.point,...
        handles.circle,handles.pentagram,handles.cross,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function triangle_Callback(hObject, eventdata, handles)
%markers -> triangle
handles.marker = 'v';
off = [handles.asterisk,handles.plus,handles.pentagram,handles.square,handles.point,...
        handles.circle,handles.diamond,handles.cross,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function pentagram_Callback(hObject, eventdata, handles)
% markers -> pentagram
handles.marker = 'p';
off = [handles.asterisk,handles.plus,handles.triangle,handles.square,handles.point,...
        handles.circle,handles.diamond,handles.cross,handles.Nomarker];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = true;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function Nomarker_Callback(hObject, eventdata, handles)
% no marker
off = [handles.pentagram,handles.asterisk,handles.plus,handles.triangle,handles.square,handles.point,...
        handles.circle,handles.diamond,handles.cross];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.Markers = false;
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);


% --------------------------------------------------------------------
function solidLine_Callback(hObject, eventdata, handles)
% set line style -> solid line
handles.lineType = '-';
off =[handles.dottedLine,handles.dashedLine,handles.dashdot,handles.NoLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function dashedLine_Callback(hObject, eventdata, handles)
% set line style -> dashed line
handles.lineType = '--';
off =[handles.dottedLine,handles.dashdot,handles.solidLine,handles.NoLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function dottedLine_Callback(hObject, eventdata, handles)
% set line style -> dotted line
handles.lineType = ':';
off =[handles.dashdot,handles.dashedLine,handles.solidLine,handles.NoLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);;

% --------------------------------------------------------------------
function NoLineItem_Callback(hObject, eventdata, handles)
% set line style -> no line
handles.lineType = 'none';
off =[handles.dashdot,handles.dashedLine,handles.solidLine,handles.dottedLine];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function dashdot_Callback(hObject, eventdata, handles)
% set line style -> dashdot line
handles.lineType = '-.';
off =[handles.dottedLine,handles.dashedLine,handles.solidLine,handles.NoLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
handles.phandles=plot_eigenvector(handles);
guidata(hObject, handles);

% --------------------------------------------------------------------
function width0_5_Callback(hObject, eventdata, handles)
% set line width
handles.lineWidth = 0.5;
handles.phandles=plot_eigenvector(handles);
off =[handles.width3,handles.width2,handles.width2_5,handles.width1,handles.width2_5,...
        handles.width1_5];
set(off,'Checked','off');
set(hObject,'Checked','on');
guidata(hObject, handles);

% --------------------------------------------------------------------
function width1_Callback(hObject, eventdata, handles)
% set line width
handles.lineWidth = 1;
phandles.phandles=plot_eigenvector(handles);
off =[handles.width3,handles.width2,handles.width2_5,handles.width2_5,handles.width0_5,...
        handles.width1_5];
set(off,'Checked','off');
set(hObject,'Checked','on');
guidata(hObject, handles);

% --------------------------------------------------------------------
function width1_5_Callback(hObject, eventdata, handles)
% set line width
handles.lineWidth = 1.5;
handles.phandles=plot_eigenvector(handles);
off =[handles.width3,handles.width2,handles.width2_5,handles.width1,handles.width0_5,...
        handles.width2_5];
set(off,'Checked','off');
set(hObject,'Checked','on');
guidata(hObject, handles);

% --------------------------------------------------------------------
function width2_Callback(hObject, eventdata, handles)
% set line width
handles.lineWidth = 2;
handles.phandles=plot_eigenvector(handles);
off =[handles.width3,handles.width2_5,handles.width2_5,handles.width1,handles.width0_5,...
        handles.width1_5];
set(off,'Checked','off');
set(hObject,'Checked','on');
guidata(hObject, handles);

% --------------------------------------------------------------------
function width2_5_Callback(hObject, eventdata, handles)
% set line width
handles.lineWidth = 2.5;
handles.phandles=plot_eigenvector(handles);
off =[handles.width3,handles.width2,handles.width2_5,handles.width1,handles.width0_5,...
        handles.width1_5];
set(off,'Checked','off');
set(hObject,'Checked','on');
guidata(hObject, handles);

% --------------------------------------------------------------------
function width3_Callback(hObject, eventdata, handles)
% set line width
handles.lineWidth = 3;
handles.phandles=plot_eigenvector(handles);
off =[handles.width2_5,handles.width2,handles.width2_5,handles.width1,handles.width0_5,...
        handles.width1_5];
set(off,'Checked','off');
set(hObject,'Checked','on');
guidata(hObject, handles);

% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.eigenfunction_plot)

% --------------------------------------------------------------------
function BasicPartition_Callback(hObject, eventdata, handles)
% show meshpoints of the partition (red dots)
if strcmp(get(handles.BasicPartition,'Checked'),'off')
   set(handles.BasicPartition,'Checked','on');
   handles.phandles = plot_eigenvector(handles);
   guidata(hObject, handles);
else
   set(handles.BasicPartition,'Checked','off');
   plot_eigenvector(handles);
end
guidata(hObject,handles);

% --------------------------------------------------------------------
function SquareItem_Callback(hObject, eventdata, handles)
% show square of the eigenfunction
if strcmp(get(hObject,'Checked'),'off')
   set(hObject,'Checked','on');
   handles.phandles = plot_eigenvector(handles);
   guidata(hObject, handles);
else
   set(hObject,'Checked','off');
   handles.phandles=plot_eigenvector(handles);
end
guidata(hObject,handles);

% --- Executes on button press in values_button.
function values_button_Callback(hObject, eventdata, handles)
% show x,-, y- and y'-values
global gapp
if isfield(gapp,'eigenvectorDataWindow') && length(gapp.eigenvectorDataWindow)>=handles.number_matslise && ishandle(gapp.eigenvectorDataWindow(handles.number_matslise))
    delete(gapp.eigenvectorDataWindow(handles.number_matslise));
end
gapp.eigenvectorDataWindow(handles.number_matslise) = eigenvector_data('x',handles.current_eigenvector.x,...
    'y',handles.current_eigenvector.y,'yp',handles.current_eigenvector.yprime);
guidata(hObject,handles);


% --------------------------------------------------------------------
function saveItem_Callback(hObject, eventdata, handles)
% save figure 
[fileName,path,filterindex] = uiputfile({'*.fig','MATLAB figures (*.fig)';...
        '*.jpg','JPEG images (*.jpg)';'*.eps','EPS files (*.eps)';...
        '*.eps','EPS Color files (*.eps)';'*.eps','EPS Level 2 files (*.eps)'
        '*.eps','EPS Level 2 Color files (*.eps)';...
        '*.ai','Adobe Illustrator files (*.ai)';...
        '*.bmp','bitmap files (*.bmp)';'*.tif','TIFF images (*.tif)';...
        '*.tif','TIFF no compression images (*.tif)';...
        '*.emf','Enhanced Metafiles (*.emf)';'*.pbm','Portable bitmap files (*.pbm)';...
        '*.png','Portable Network Graphics files (*.png)'},...
    'Save plot as');
if strcmp(fileName,'0') || strcmp(path,'0') || filterindex == 0
    return;
end
file=fullfile(path,fileName);
filters ={'fig','jpg','eps','epsc','eps2','epsc2','ai','bmp','tif','tiffn','emf','pbm','png'};
s=char(filters(filterindex));
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigenvector(handles,ahandle,true);
saveas(fhandle,file,s);


% --------------------------------------------------------------------
function CopyItem_Callback(hObject, eventdata, handles)
% copy figure to clipboard
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigenvector(handles,ahandle,true);
set(fhandle,'Position',[-100 -100 30 25]);
set(fhandle,'Visible','on');
print -dmeta; 
delete(fhandle);
plot_eigenvector(handles);

% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
% opens helpfiles
HelpPath = which('eigenfunction_plot.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','eigenfunction_plot.html');
web(HelpPath);

% --------------------------------------------------------------------
function AboutItem_Callback(hObject, eventdata, handles)
HelpPath = which('eigenfunction_plot.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'/helpfiles/matslise.html');
web(HelpPath);

%---------------------------------------------------------------------
function phandles = plot_eigenvector(handles,varargin)
if isempty(varargin)
    ahandle = handles.eigenvectorAxes;
else
    ahandle = varargin{1};
end
z = zeros(1,length(handles.current_eigenvector.x));
if handles.Markers
        phandles = plot(handles.current_eigenvector.x,handles.current_eigenvector.y,'LineWidth',handles.lineWidth,...
        'Color',handles.color,'Marker',handles.marker,'LineStyle',handles.lineType,'Parent',ahandle);
else
        phandles = plot(handles.current_eigenvector.x,handles.current_eigenvector.y,'LineWidth',handles.lineWidth,...
        'Color',handles.color,'LineStyle',handles.lineType,'Parent',ahandle);
end
axis tight
v = axis;
s = sprintf('Eigenfunction associated with eigenvalue %d = %6.10f',handles.index,handles.eigenvalue);
set(get(ahandle,'XLabel'),'String','x','FontSize',10);
set(get(ahandle,'YLabel'),'String','y','FontSize',10);
set(get(ahandle,'YLabel'),'Rotation',0.0);
p=get(get(ahandle,'YLabel'),'Position');
ticks = (handles.current_eigenvector.x(end)-handles.current_eigenvector.x(1))/100;
set(get(ahandle,'YLabel'),'Position',[p(1)-1.5*ticks p(2) p(3)]);
set(get(ahandle,'Title'),'String',s,'FontSize',10);  
set(get(ahandle,'Title'),'FontSize',8)
set(ahandle,'FontSize',8);
hold on
set(ahandle,'Xgrid','on');
set(ahandle,'Ygrid','on');
if strcmp(get(handles.BasicPartition,'Checked'),'on') %&& length(varargin) <= 1
   if handles.halfrange_reduction
      if mod(handles.index,2) == 0
          V = get_eigenfunction(handles.cpm(1),handles.eigenvalue);
          V.x = [V.x];
          V.y = [V.y]./sqrt(2);
          V.yprime = [V.yprime]./sqrt(2); 
      else
          V = get_eigenfunction(handles.cpm(2),handles.eigenvalue);
          V.x = [V.x];
          V.y = [-V.y]./sqrt(2);
          V.yprime = [-V.yprime]./sqrt(2); 
      end
      basic_eigenvector = V;
   else
      basic_eigenvector = get_eigenfunction(handles.cpm,handles.eigenvalue);
   end
   [y,i] = max(basic_eigenvector.y);
   x = basic_eigenvector.x(i);
   yc = y;
   % take care that two eigenfunctions have the same sign:
   if handles.current_eigenvector.x(floor(length(handles.current_eigenvector.x)/2)) > x
       ii = 1;
       ie = floor(length(handles.current_eigenvector.x)/2);
   else
       ii = floor(length(handles.current_eigenvector.x)/2);
       ie = length(handles.current_eigenvector.x);
   end
   for i=ii:ie-1
       if x == handles.current_eigenvector.x(i)
           yc = handles.current_eigenvector.y(i);
           break;
       end
       if x > handles.current_eigenvector.x(i) &&  x < handles.current_eigenvector.x(i+1) 
           yc = (handles.current_eigenvector.y(i) + handles.current_eigenvector.y(i+1))/2;
           break;
       end
   end
   if sign(y) ~= sign(yc)
       basic_eigenvector.y = basic_eigenvector.y .*(-1);
   end
   plot(basic_eigenvector.x,basic_eigenvector.y,'ro','MarkerFaceColor','r','MarkerSize',5,'Parent',ahandle);
   %plot(basic_eigenvector.x,zeros(1,length(basic_eigenvector.y)),'ro','MarkerFaceColor','r','MarkerSize',5,'Parent',ahandle);
   bp=get(handles.cpm(1),'bp');
   if ~isa(get(handles.cpm(1),'schrod'),'transformed_slp')
    xm=get(get(handles.cpm(1),'schrod'),'min')+sum(bp.h(1:bp.imatch));
    if isa(get(handles.cpm(1),'schrod'),'distorted_coulomb')
       for i=1:length(basic_eigenvector.x)
         if(abs(basic_eigenvector.x(i)-xm)<1e-12)
           plot(xm,basic_eigenvector.y(i),'-go','MarkerFaceColor','g','MarkerSize',6,'Parent',ahandle);
           break;
        end
       end
    else
       plot(xm,basic_eigenvector.y(bp.imatch+1),'-go','MarkerFaceColor','g','MarkerSize',6,'Parent',ahandle);
    end
   end
    if handles.halfrange_reduction
      plot([0 0 0 0 0],[0 basic_eigenvector.y(bp.imatch) basic_eigenvector.y(1) 10 -10],'-g','Parent',ahandle);
    end
   axis(v);
end
if strcmp(get(handles.SquareItem,'Checked'),'on') %&& length(varargin) <= 1
    yy=handles.current_eigenvector.y.^2;
    if handles.color ~= 'r'
      phandles = [phandles;plot(handles.current_eigenvector.x,yy,'r','LineWidth',...
          handles.lineWidth,'Parent',ahandle)];
    else
      phandles =[phandles; plot(handles.current_eigenvector.x,yy,'b','LineWidth',...
           handles.lineWidth,'Parent',ahandle)];
    end
    v=[v(1) v(2) min(min(yy),v(3)) max(max(yy),v(4))];
    axis(v);
end
hold on;
if handles.showRoots
    phandles=[phandles; plot(handles.roots.x,handles.roots.y,'gd','MarkerFaceColor','g','MarkerSize',5,'Parent',ahandle)];
end
hold off;



% --------------------------------------------------------------------
function NormItem_Callback(hObject, eventdata, handles)
try
set(handles.info_edit,'String','Calculating norm...');
drawnow;
distorted=isa(get(handles.cpm(1),'schrod'),'distorted_coulomb');
corr=0;
if ~isa(get(handles.cpm(1),'schrod'),'transformed_slp')
       ortho = calculate_norm(handles.eigenvector);
       if abs(1-ortho)>0.1
          ortho = calculate_norm(handles.current_eigenvector);
       end
else %slp
       wfie = get(get(handles.cpm(1),'schrod'),'w');
       x = handles.eigenvector.x;
       w = [];
       for s=1:length(x)
              w = [w wfie(x(s))];
       end
       ortho=calculate_norm_slp(handles.eigenvector,w);
end
   set(handles.info_edit,'String',['<y_' num2str(handles.index) ' | y_' num2str(handles.index) '> = ',...
           sprintf('%1.4f',ortho) ]);
catch
     errordlg(lasterr,'Error','modal');
     set(handles.info_edit,'String','Ready');
end

%-----------------------------------------------------
function ortho=calculate_norm(eigv)
x=eigv.x;
y1=eigv.y;
y2=eigv.y;
if isnan(y1(1)) 
    x = x(2:end);
    y1 = y1(2:end);
    y2 = y2(2:end);
end
h = x(2:end)-x(1:length(x)-1);
y1l = y1(1:length(y1)-1);
y1r = y1(2:end);
y2l = y2(1:length(y2)-1);
y2r = y2(2:end);
ortho = sum(0.5*h.*(y1l.*y2l + y1r.*y2r));

%-----------------------------------------------------
function ortho=calculate_norm_slp(eigv,w)
x=eigv.x;
y1=eigv.y;
y2=eigv.y;
if isnan(y1(1)) 
    x = x(2:end);
    y1 = y1(2:end);
    y2 = y2(2:end);
    w = w(2:end);
end
h = x(2:end)-x(1:length(x)-1);
y1l = y1(1:length(y1)-1);
y1r = y1(2:end);
y2l = y2(1:length(y2)-1);
y2r = y2(2:end);
if size(y1,2)==1
    w = w';
end
wl = w(1:length(w)-1);
wr = w(2:end);
ortho = sum(0.5*h.*(y1l.*y2l.*wl + y1r.*y2r.*wr));



% --------------------------------------------------------------------
function rootsItem_Callback(hObject, eventdata, handles)
set([handles.plot_button,handles.close_button,handles.values_button],'Enable','off');
set([handles.points_edit,handles.a_edit,handles.b_edit,handles.points_text,handles.interval_text,handles.to_text],'Enable','off');
set(handles.info_edit,'String','Busy...');
drawnow;
%ik kan hier soms beter current_eigenvector nemen (number of roots voor
%eigenwaarde 31 expon)
if abs(handles.current_eigenvector.x(1)-handles.eigenvector.x(1))<1e-7 && abs(handles.current_eigenvector.x(end)-handles.eigenvector.x(end))<1e-7 && length(handles.current_eigenvector.x)>length(handles.eigenvector.x)
    eigv=handles.current_eigenvector;
else 
    eigv=handles.eigenvector;
end
if length(eigv.x)<300
  l=max(min(eigv.x(2:length(eigv.x)-1)-eigv.x(1:length(eigv.x)-2))/100,1e-8);
elseif length(eigv.x)<500
  l=max(min(eigv.x(2:length(eigv.x)-1)-eigv.x(1:length(eigv.x)-2))/50,1e-8);  
else
  l=max(min(eigv.x(2:length(eigv.x)-1)-eigv.x(1:length(eigv.x)-2))/20,1e-8);  
end
while (eigv.x(end)-eigv.x(1))/l > 1e6
    l=l*2;
end
points=str2double(get(handles.points_edit,'String'));
try
l=min((eigv.x(end)-eigv.x(1))/points,l);    
x=eigv.x(1):l:eigv.x(end);
catch
    l=max(min(eigv.x(2:length(eigv.x)-1)-eigv.x(1:length(eigv.x)-2))/10,1e-5);
    x=eigv.x(1):l:eigv.x(end);
end
y=spline(eigv.x,eigv.y,x);
t=y(3:length(y)-1).*y(2:length(y)-2);
tmp=find(abs(t)>1e-15);
t=[ones(1,tmp(1)-1) t(tmp(1):tmp(end))];
tmp=find(t<=0);
roots=length(tmp);
handles.roots.x=x(tmp+1);
handles.roots.y=y(tmp+1);
if roots > handles.index
  y=eigv.y;
  x=eigv.x;
  t=y(2:length(y)).*y(1:length(y)-1);
  tmp=find(abs(t)>1e-15);
  [s1,s2]=size(t);
  if s1==1
    t=[ones(1,tmp(1)-1) t(tmp(1):tmp(end))];  
  else
    t=[ones(1,tmp(1)-1) t(tmp(1):tmp(end))'];
  end
  tmp=find(t<=0);
  roots=length(tmp);    
  handles.roots.x=(x(tmp+1)+x(tmp+2))./2;
  handles.roots.y=zeros(length(tmp));
end
handles.showRoots=true;
handles.phandles = plot_eigenvector(handles);
handles.showRoots=false;
if roots < handles.index
    msgbox(['Number of roots found: ' num2str(roots) '. The number of points should be increased in order to localize all roots'],'Roots');
    set(handles.info_edit,'String',['Number of roots: ' num2str(roots)]);
else
    s='';
    if length(handles.roots.x)>0
      if handles.roots.x(end)<4
        s=': [';
        for i=1:length(handles.roots.x)-1
          s=[s sprintf('%4.3f, ',handles.roots.x(i))];
        end
        s=[s sprintf('%4.3f]',handles.roots.x(end))];         
      else
        s=': [';
        for i=1:length(handles.roots.x)-1
          s=[s sprintf('%4.2f, ',handles.roots.x(i))];
        end
         s=[s sprintf('%4.2f]',handles.roots.x(end))];
      end
      set(handles.info_edit,'String',['Number of roots: ' num2str(roots) s]);
  else
      set(handles.info_edit,'String','No roots found');
  end
end
set([handles.plot_button,handles.close_button,handles.values_button],'Enable','on');
set([handles.points_edit,handles.a_edit,handles.b_edit,handles.points_text,handles.interval_text,handles.to_text],'Enable','on');
guidata(hObject,handles);

