function varargout = eigenfunctions_oneplot(varargin)
% EIGENFUNCTIONS_ONEPLOT M-file for eigenfunctions_oneplot.fig
%      EIGENFUNCTIONS_ONEPLOT, by itself, creates a new EIGENFUNCTIONS_ONEPLOT or raises the existing
%      singleton*.
%
%      H = EIGENFUNCTIONS_ONEPLOT returns the handle to a new EIGENFUNCTIONS_ONEPLOT or the handle to
%      the existing singleton*.
%
%      EIGENFUNCTIONS_ONEPLOT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EIGENFUNCTIONS_ONEPLOT.M with the given input arguments.
%
%      EIGENFUNCTIONS_ONEPLOT('Property','Value',...) creates a new EIGENFUNCTIONS_ONEPLOT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before eigenfunctions_oneplot_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to eigenfunctions_oneplot_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help eigenfunctions_oneplot

% Last Modified by GUIDE v2.5 09-Dec-2004 16:23:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenfunctions_oneplot_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenfunctions_oneplot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenfunctions_oneplot is made visible.
function eigenfunctions_oneplot_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenfunctions_oneplot (see VARARGIN)
i=1;
handles.squares=false;
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
         case 'y'
               handles.y = varargin{i+1};
         case 'x'
               handles.x = varargin{i+1};
         case 'indices'
               handles.indices = varargin{i+1};
         case 'Name'
               handles.name = varargin{i+1};
               set(handles.eigenfunctions_oneplot,'Name',[handles.name ': Eigenfunctions on one plot']);
         case 'number_matslise' %to keep track which instance of Matslise 
             handles.number_matslise=varargin{i+1};
     end
     i = i+2;
    end
end
ahandle = handles.plot_axes;
phandles=plot_eigfs(handles,ahandle);
% Choose default command line output for eigenfunctions_oneplot
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes eigenfunctions_oneplot wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = eigenfunctions_oneplot_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function openItem_Callback(hObject, eventdata, handles)
%open plot in new window
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigfs(handles,ahandle);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');

%---------------------------------------------------------------------
function phandles=plot_eigfs(handles,ahandle)
number_selected = length(handles.indices);
colors = number_selected;
colormp = jet(colors);
colormp=remove_yellow(colormp);
set(ahandle,'ColorOrder',colormp);
phandles=[];
minx = handles.x{1}(1);
for i=1:number_selected
     phandles=[phandles; plot(handles.x{i},handles.y{i},'Color',colormp(i,:),'Parent',ahandle)];
     if handles.x{i}(1) < minx
         minx = handles.x{i}(1);
     end
     hold on;
end
hold off;
axis(ahandle,'tight');
set(get(ahandle,'XLabel'),'String','x','FontSize',12);
for i =1:number_selected
   legendStr{i} = ['y_{', num2str(handles.indices(i)),'}']; 
end
legend(phandles(1:end),legendStr{:},'Location','Best');


% --------------------------------------------------------------------
function SaveAsItem_Callback(hObject, eventdata, handles)
[fileName,path,filterindex] = uiputfile({'*.fig','MATLAB figures (*.fig)';...
        '*.jpg','JPEG images (*.jpg)';'*.eps','EPS files (*.eps)';...
        '*.eps','EPS Color files (*.eps)';'*.eps','EPS Level 2 files (*.eps)'
        '*.eps','EPS Level 2 Color files (*.eps)';...
        '*.ai','Adobe Illustrator files (*.ai)';...
        '*.bmp','bitmap files (*.bmp)';'*.tif','TIFF images (*.tif)';...
        '*.tif','TIFF no compression images (*.tif)';...
        '*.emf','Enhanced Metafiles (*.emf)';'*.pbm','Portable bitmap files (*.pbm)';...
        '*.png','Portable Network Graphics files (*.png)'},...
    'Save plot as');
if strcmp(fileName,'0') || strcmp(path,'0') || filterindex == 0
    return;
end
file=fullfile(path,fileName);
filters ={'fig','jpg','eps','epsc','eps2','epsc2','ai','bmp','tif','tiffn','emf','pbm','png'};
s=char(filters(filterindex));
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles=plot_eigfs(handles,ahandle)
saveas(fhandle,file,s);




% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.eigenfunctions_oneplot)




% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.eigenfunctions_oneplot)




% --------------------------------------------------------------------
function CopyItem_Callback(hObject, eventdata, handles)
% copy figure to clipboard
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigfs(handles,ahandle);
set(fhandle,'Position',[-100 -100 30 25]);
set(fhandle,'Visible','on');
print -dmeta; 
delete(fhandle);



