function varargout = eigenfunctions_plot(varargin)
% EIGENFUNCTIONS_PLOT M-file for eigenfunctions_plot.fig

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenfunctions_plot_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenfunctions_plot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenfunctions_plot is made visible.
function eigenfunctions_plot_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenfunctions_plot (see VARARGIN)
global gapp
%processing the command line arguments:
i = 1;
while i < length(varargin)
switch varargin{i}
    case 'Eigenvalues'
        handles.eigenvalues = varargin{i+1}; 
    case 'Indices'
        handles.indices = varargin{i+1};  
    case 'CPM'
        handles.cpm = varargin{i+1};
    case 'halfrangereduction'
        handles.halfrange_reduction = varargin{i+1};
        if handles.halfrange_reduction
         handles.cpm_hr1 = handles.cpm(1);
         handles.cpm_hr2 = handles.cpm(2);
         sch=get(handles.cpm(1),'schrod');
         nmin=-get(sch,'max');
         sch = set(sch,'min',nmin);
         handles.cpm = set(handles.cpm(1),'schrod',sch);
        end
    case 'Name'
        handles.name = varargin{i+1};
        set(hObject,'Name',[handles.name ': eigenfunctions']);
    case 'number_matslise'
        handles.number_matslise = varargin{i+1};
end
i = i+ 2;
end
handles = set_buttons(handles,1);
warning = false;
number_eigenfunctions = length(handles.eigenvalues);
%select appropriate axes
if number_eigenfunctions == 1
   axesses = [handles.axesb1];
elseif number_eigenfunctions == 2
   axesses = [handles.axesb21,handles.axesb22];
elseif number_eigenfunctions > 6
    axesses = [handles.axess1,handles.axess2,handles.axess3,handles.axess4,handles.axess5,handles.axess6,...
     handles.axess7,handles.axess8,handles.axess9,handles.axess10,handles.axess11,handles.axess12,...
     handles.axess13,handles.axess14,handles.axess15];
else
    axesses = [handles.axes1,handles.axes2,handles.axes3,handles.axes4,handles.axes5,handles.axes6];
end
%
schrod_object = get(handles.cpm(1),'schrod');
distorted = isa(schrod_object,'distorted_coulomb');
xmax = get(schrod_object,'max');
if distorted
    xmin=0;
else
    xmin = get(schrod_object,'min');
end
if isa(schrod_object,'transformed_slp') %takes more time  --> less points
 xmax = get(get(schrod_object,'slp'),'max');
 xmin = get(get(schrod_object,'slp'),'min');
 number_pts = 70;
else
 number_pts = 200;
end
truncated=get(handles.cpm(1),'truncated');
if truncated && length(handles.cpm)==1
     bp=get(handles.cpm,'bp');
     [trunca,truncb]=get_truncation_points(bp,handles.eigenvalues(end),distorted);
     xmint=xmin+sum(bp.h(1:trunca-1));
     xmaxt=xmin+sum(bp.h(1:truncb));
else
    xmint=xmin;
    xmaxt=xmax;
end
%try
len = floor(xmaxt-xmint);
m = number_pts + handles.indices(end)*12 + floor(len*0.3);
m = min(m,1800);
step = (xmaxt-xmint)/(m*10);
xx = xmint:step:xmaxt;
if distorted
    m = number_pts + (handles.indices(1)+1)*20;
    m = min(m,2000);
    [V,handles.status(1),part] = get_eigenfunction(handles.cpm,handles.eigenvalues(1),m,false);
    for i=1:number_eigenfunctions
      if i>1   
         [V,handles.status(i),part] = get_eigenfunction(handles.cpm,handles.eigenvalues(i),part,false);
      end
      if abs(xx(end)-V.x(end))<1e-12
        endspline = length(xx);
        yy = spline(V.x,V.y,xx);
      else
       for j=length(xx)-1:-1:1
        if xx(j)<V.x(end)
          endspline = j+1;
          break;
        end
       end
       yy = spline([V.x xx(endspline)],[V.y 0],xx(1:endspline));
      end
      norm = test_orthogonality([xx(1:endspline)],yy,yy);
      yy = yy ./ sqrt(norm);
      handles.X{i} = [xx(1:endspline)'];
      handles.Y{i} = [yy'];
      handles.yprime{i} = V.yprime';
      handles.x_orig{i} = V.x';
      handles.y_orig{i} = V.y';
      set(axesses(i),'Visible','on');
      axes(axesses(i));
      %plot(handles.X{i},handles.Y{i});
      plot(V.x,V.y);
      axis tight;
      set(get(axesses(i),'Title'),'String',['Eigenfunction ' num2str(handles.indices(i))]);
      if number_eigenfunctions > 2
        set(get(axesses(i),'Title'),'FontSize',8)
        set(axesses(i),'FontSize',8);
      end
      drawnow;
    end
else
    if handles.halfrange_reduction
       [V,handles.status(1),part] = get_eigenfunction(handles.cpm_hr1,handles.eigenvalues(1),m,false); 
    else
       [V,handles.status(1),part] = get_eigenfunction(handles.cpm,handles.eigenvalues(1),m,false);       
    end
    for i=1:number_eigenfunctions
     if handles.halfrange_reduction
      if mod(handles.indices(i),2) == 0
          [V,handles.status(i)] = get_eigenfunction(handles.cpm_hr1,handles.eigenvalues(i),part,false);
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) V.yprime]./sqrt(2);
      else
          [V,handles.status(i)] = get_eigenfunction(handles.cpm_hr2,handles.eigenvalues(i),part,false);
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) -V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) -V.yprime]./sqrt(2); 
      end
     else 
      [V,handles.status(i)] = get_eigenfunction(handles.cpm,handles.eigenvalues(i),part,false);
     end
     endspline = length(xx);
     cursor=1;
     for j=1:length(V.y)
         if isnan(V.y(j))
           cursor = cursor+1;
         else
           V.y=V.y(cursor:end);
           V.x=V.x(cursor:end);
           break;
         end
     end
     yy = spline(V.x,V.y,xx);
     handles.X{i} = xx(1:endspline)';
     handles.Y{i} = yy';
     handles.yprime{i} = V.yprime';
     if truncated
       tmp=find(V.x<=xmint);
       tmp2=find(V.x<=xmaxt);
       if isempty(tmp)
          tmp=1;
       end
       if isempty(tmp2)
          tmp2=length(V.x);
       end
       handles.x_orig{i} = V.x(tmp(end):tmp2(end))';
       handles.y_orig{i} = V.y(tmp(end):tmp2(end))';   
     else
       handles.x_orig{i} = V.x';
       handles.y_orig{i} = V.y';
     end
     set(axesses(i),'Visible','on');
     axes(axesses(i));
     plot(handles.X{i},handles.Y{i});
     %plot(handles.x_orig{i},handles.y_orig{i});
     axis tight;
     ticks=get(gca,'XTick');
     if number_eigenfunctions > 6 && length(ticks) > 4
         ticksnew=[];
         k=1;
         while k < length(ticks)+1
             ticksnew=[ticksnew ticks(k)];
             k=k+2;
         end
         set(gca,'XTick',ticksnew);
     end
     set(get(axesses(i),'Title'),'String',['Eigenfunction ' num2str(handles.indices(i))]);
     if number_eigenfunctions > 2
      set(get(axesses(i),'Title'),'FontSize',8)
      set(axesses(i),'FontSize',8);
     end
     drawnow;
    end
end
% catch
%       warning = true;
%       handles.indices = handles.indices(1:i-1);
%       handles.eigenvalues = handles.eigenvalues(1:i-1);
%       number_eigenfunctions = i-1;
% end
resultsStr = {['Eigenfunction ',num2str(handles.indices(1)) ]};
for i=2:length(handles.eigenvalues)
    resultsStr = [resultsStr;{['Eigenfunction ',num2str(handles.indices(i))]}] ;
end
set(handles.eigenfunction_box,'String',resultsStr);
set(handles.eigenfunction_box,'Value',[]);
%handles = set_buttons(handles,0);
set(handles.stop_button,'Enable','off');
set(handles.info_edit,'String','Ready');
set([handles.selectAll_button,handles.close_button,handles.help_button,...
    handles.select_text,handles.results_text],'Enable','on');
if length(handles.eigenvalues) < 2
    set(handles.oneplot_button,'Enable','off');
end
if warning
    set(handles.info_edit,'String','The calculation has been interrupted!!!');
end
incorrect = test_correctness(handles);
if length(incorrect)>0
  s=sprintf('The following eigenfunctions are not correct: %d',incorrect(1));
  for i=2:length(incorrect)
      s= sprintf('%s, %d',s,incorrect(i));
  end
  set(handles.info_edit,'String',s);
  set(handles.info_edit,'BackgroundColor',[1 0 0]); %red
  gapp.incorrect_eigenfunctions = incorrect;
end
% Choose default command line output for eigenfunctions_plot
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = eigenfunctions_plot_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function eigenfunction_box_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function results_box_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes during object creation, after setting all properties.
function info_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on button press in test_orthonormality_button.
function test_orthonormality_button_Callback(hObject, eventdata, handles)
handles = set_buttons(handles,1);
try
resultsStr={};
currentVals = get(handles.eigenfunction_box,'Value');
if isempty(currentVals)
    error('No eigenfunctions are selected')
end
distorted=isa(get(handles.cpm(1),'schrod'),'distorted_coulomb');
for i = 1:length(currentVals) 
    for j = i:length(currentVals)
        corr=0;
        if ~isa(get(handles.cpm(1),'schrod'),'transformed_slp')
          l=min(length(handles.X{currentVals(i)}),length(handles.X{currentVals(j)})); %voor als intervallen niet even lang (vb bij distorted coulomb))
          if i~=j && distorted
            ortho = test_orthogonality([handles.X{currentVals(i)}(1:l)],[handles.Y{currentVals(i)}(1:l)./10],[handles.Y{currentVals(j)}(1:l)./10]);
          else
            ortho = test_orthogonality([handles.X{currentVals(i)}(1:l)],[handles.Y{currentVals(i)}(1:l)],[handles.Y{currentVals(j)}(1:l)]);
          end
          if ~distorted
            ortho1 = test_orthogonality(handles.x_orig{currentVals(i)},handles.y_orig{currentVals(i)},handles.y_orig{currentVals(j)});
            if (abs(ortho1) < abs(ortho) && i ~=j) || (i==j && abs(ortho1-1) < abs(ortho-1))
              ortho = ortho1;
            end
          end
        else %slp
          wfie = get(get(handles.cpm(1),'schrod'),'w');
          x = handles.X{currentVals(i)};
          w1 = [];
          for s=1:length(x)
              w1 = [w1 wfie(x(s))];
          end
          xx=handles.x_orig{currentVals(i)};
          w = [];
          for s=1:length(xx)
              w = [w wfie(xx(s))];
          end
          if i < j 
            ortho1=test_orthogonality_slp(x,handles.Y{currentVals(i)}./10,...
              handles.Y{currentVals(j)}./10,w1); 
            corr = corr + 2;
            ortho=test_orthogonality_slp(xx,handles.y_orig{currentVals(i)}./10,handles.y_orig{currentVals(j)}./10,w); 
            if abs(ortho1) < abs(ortho) 
                ortho = ortho1;
            end
          else
             ortho1=test_orthogonality_slp(xx,handles.y_orig{currentVals(i)},handles.y_orig{currentVals(j)},w); 
             dist1 = abs(1-ortho1);
             ortho=test_orthogonality_slp(x,handles.Y{currentVals(i)},handles.Y{currentVals(j)},w1);
             dist = abs(1-ortho);
             if dist1 < dist
                 ortho=ortho1;
             end
          end
        end
        if handles.indices(currentVals(i)) == handles.indices(currentVals(j)) && abs(ortho-1) < 0.0005 ||...
            handles.indices(currentVals(i)) < handles.indices(currentVals(j)) && abs(ortho-0) < 0.0005
        resultsStr = [resultsStr;...
        {['<y_' num2str(handles.indices(currentVals(i))) ' | y_' num2str(handles.indices(currentVals(j))) '> = ',...
                num2str(ortho)]}];
        else
             if i ~= j
              ortho = ortho*10^corr;
            end
         resultsStr = [resultsStr;...
        {['<y_' num2str(handles.indices(currentVals(i))) ' | y_' num2str(handles.indices(currentVals(j))) '> = ',...
           sprintf('%1.4f',ortho) '           (NOK)']}];
        end
    end
end
catch
     errordlg(lasterr,'Error','modal');
end
handles = set_buttons(handles,0);
set([handles.results_box,handles.results_text],'Enable','on');
set(handles.results_box,'Value',[]);
set(handles.results_box,'String',resultsStr);


% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
delete(handles.eigenfunctions_plot);

% --- Executes on button press in help_button.
function help_button_Callback(hObject, eventdata, handles)
HelpPath = which('eigenfunctions_plot.m');
[pathstr,name,ext] = fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','eigenfunctions.html');
web(HelpPath);

% --- Executes on button press in oneplot_button.
function oneplot_button_Callback(hObject, eventdata, handles)
global gapp
if isfield(gapp,'eigenfunctions_oneplot') && length(gapp.eigenfunctions_oneplot)>=handles.number_matslise && ishandle(gapp.eigenfunctions_oneplot(handles.number_matslise))
    try
    delete(gapp.eigenfunctions_oneplot(handles.number_matslise));
    catch
    end
end
currentVals = get(handles.eigenfunction_box,'Value');
j=1;
for i=1:length(currentVals)
  x{j}=handles.x_orig{currentVals(i)};
  y{j}=handles.y_orig{currentVals(i)};
  j=j+1;
end
gapp.eigenfunctions_oneplot(handles.number_matslise) = eigenfunctions_oneplot('Name',handles.name,...
         'x',x,'y',y,'indices',handles.indices(currentVals));

% --- Executes on button press in potential_eigenfunctions_plot.
function potential_eigenfunctions_plot_Callback(hObject, eventdata, handles)
global gapp
handles = set_buttons(handles,1);
if isfield(gapp,'potential_eigenfunctions_plot') && length(gapp.potential_eigenfunctions_plot)>=handles.number_matslise && ishandle(gapp.potential_eigenfunctions_plot(handles.number_matslise))
    try
    delete(gapp.potential_eigenfunctions_plot(handles.number_matslise));
    catch
    end
end
pause(0) % stop the calculation in the GUI?
load stop
if stop
   error('The calculation was interrupted');
end 
try
currentVals = get(handles.eigenfunction_box,'Value');
number_selected = length(currentVals);
j=1;
for i=1:length(currentVals)
  Y{j}=handles.Y{currentVals(i)};
  X{j}=handles.X{currentVals(i)};
  j=j+1;
end
gapp.potential_eigenfunctions_plot(handles.number_matslise) = eigenfunctions_potential_plot('Name',handles.name,...
       'cpm',handles.cpm,'indices',handles.indices(currentVals),'eigenvalues',handles.eigenvalues(currentVals),'X',X,'Y',Y);
if isa(get(handles.cpm(1),'schrod'),'transformed_slp')
   error('This option is not possible for a Sturm-Liouville problem.');
end
catch
    errordlg(lasterr,'Error','modal');
end
handles = set_buttons(handles,0);
if length(handles.eigenvalues) < 2
    set(handles.oneplot_button,'Enable','off');
end


% --- Executes on button press in stop_button.
function stop_button_Callback(hObject, eventdata, handles)
stop = 1;
save stop.mat stop;

%-----------------------------------------------------
function ortho=test_orthogonality(x,y1,y2)
pause(0) % stop the calculation in the GUI?
load stop
if stop
   error('The calculation was interrupted');
end 
if isnan(y1(1)) || isnan(y2(1))
    x = x(2:end);
    y1 = y1(2:end);
    y2 = y2(2:end);
end
h = x(2:end)-x(1:length(x)-1);
y1l = y1(1:length(y1)-1);
y1r = y1(2:end);
y2l = y2(1:length(y2)-1);
y2r = y2(2:end);
ortho = sum(0.5*h.*(y1l.*y2l + y1r.*y2r));

%-----------------------------------------------------
function ortho=test_orthogonality_slp(x,y1,y2,w)
pause(0) % stop the calculation in the GUI?
load stop
if stop
   error('The calculation was interrupted');
end 
if isnan(y1(1)) || isnan(y2(1))
    x = x(2:end);
    y1 = y1(2:end);
    y2 = y2(2:end);
    w = w(2:end);
end
h = x(2:end)-x(1:length(x)-1);
y1l = y1(1:length(y1)-1);
y1r = y1(2:end);
y2l = y2(1:length(y2)-1);
y2r = y2(2:end);
if size(y1,2)==1
    w = w';
end
wl = w(1:length(w)-1);
wr = w(2:end);
ortho = sum(0.5*h.*(y1l.*y2l.*wl + y1r.*y2r.*wr));


% --- Executes on button press in onefunction_button.
function onefunction_button_Callback(hObject, eventdata, handles)
global gapp
handles = set_buttons(handles,1);
try
currentVals = get(handles.eigenfunction_box,'Value');
if length(currentVals) > 1
    error('Error!!! : Only one eigenfunction should be selected when you push this button')
end
if isfield(gapp,'eigenfunction_plot') && length(gapp.eigenfunction_plot)>=(handles.number_matslise) && ishandle(gapp.eigenfunction_plot(handles.number_matslise))
    try
  delete(gapp.eigenfunction_plot(handles.number_matslise));
    catch
    end
end
V.x = handles.x_orig{currentVals};
V.y = handles.y_orig{currentVals};
V.yprime = handles.yprime{currentVals};
if handles.halfrange_reduction
    cpms=[handles.cpm_hr1 handles.cpm_hr2];
else
    cpms=handles.cpm;
end
gapp.eigenfunction_plot(handles.number_matslise) = eigenfunction_plot('CPM',cpms,'eigenvector',V,...
    'eigenvalue',handles.eigenvalues(currentVals),...
    'index',handles.indices(currentVals),'status',handles.status(currentVals),...
    'halfrangereduction',handles.halfrange_reduction,'Name',handles.name,'number_matslise',handles.number_matslise);
movegui(gapp.eigenfunction_plot(handles.number_matslise),'center');
movegui(gapp.eigenfunction_plot(handles.number_matslise),'onscreen');
catch 
       set(handles.info_edit,'String','Ready...');
        hlp=strfind(lasterr,'Error!!! : ');
        if isempty(hlp)
          errordlg(lasterr,'Error','modal');
        else
          msg=lasterr; 
          errordlg(msg(hlp(1)+11:end),'Error','modal');
        end
end
handles = set_buttons(handles,0);
if length(handles.eigenvalues) < 2
    set(handles.oneplot_button,'Enable','off');
end
guidata(hObject,handles);

%-----------------------------------------------------------------
function incorrect=test_correctness(handles)
% test if number of nodes == index
incorrect = [];
for i=1:length(handles.indices)
    y = [handles.y_orig{i}; 0];
    z = [0; handles.y_orig{i}];
    w = y.*z;
    hlp=length(find(w(3:length(w)-2)<0));
    if handles.indices(i) < hlp
         incorrect = [incorrect handles.indices(i)];    
    elseif handles.indices(i) > hlp
         hlp2=y(2:length(y)-2);
         nodes = length(find(w(3:length(w)-2)<0));
         tmp=find(hlp2==0);
         if length(tmp)==0
             return;
         end
         if tmp(1)==1
             tmp=tmp(2:length(tmp));
         end
         if tmp(end)==length(hlp2)
             tmp=tmp(1:length(tmp)-1);
         end
         for j=1:length(tmp)
             if hlp2(tmp(j)-1)*hlp2(tmp(j)+1) < 0
                 nodes=nodes+1;
             end
         end
         if nodes ~= handles.indices(i)
             incorrect = [incorrect handles.indices(i)]; 
         end
     end
end



% --- Executes on selection change in eigenfunction_box.
function eigenfunction_box_Callback(hObject, eventdata, handles)
if length(get(handles.eigenfunction_box,'String'))>0
set([handles.potential_eigenfunctions_plot,...
    handles.test_orthonormality_button,handles.oneplot_button,handles.onefunction_button],'Enable','On');
 if isa(get(handles.cpm(1),'schrod'),'transformed_slp')
       set([handles.potential_eigenfunctions_plot],'Enable','off');
   end
else
    set([handles.potential_eigenfunctions_plot,...
    handles.test_orthonormality_button,handles.oneplot_button,handles.onefunction_button],'Enable','Off');
end

%--------------------------------------------------------
function handles=set_buttons(handles,calculating)
% Enable / Disable GUI-buttons when starting a calculation
% Enable / Disable GUI-buttons when finishing a calculation
if calculating
  stop = 0;
  save stop.mat stop;
  set(handles.stop_button,'Enable','on');
  set(handles.info_edit,'BackgroundColor',[1 1 1]);
  set([handles.selectAll_button,handles.close_button,handles.help_button,handles.oneplot_button,...
        handles.test_orthonormality_button,handles.select_text,handles.results_text,...
        handles.potential_eigenfunctions_plot,handles.onefunction_button],'Enable','off');
  set(handles.results_box,'String','');
  set(handles.results_box,'Value',1);
  set(handles.info_edit,'String','Busy...');
  drawnow;
else
   set([handles.selectAll_button,handles.close_button,handles.help_button,handles.oneplot_button,handles.test_orthonormality_button,...
        handles.select_text,handles.results_text,handles.potential_eigenfunctions_plot,handles.onefunction_button],'Enable','on');
   set(handles.stop_button,'Enable','off');
   if isa(get(handles.cpm(1),'schrod'),'transformed_slp')
       set([handles.potential_eigenfunctions_plot],'Enable','off');
   end
   if length(handles.eigenvalues) < 2
     set(handles.oneplot_button,'Enable','off');
   end
   set(handles.info_edit,'String','Ready');
end


% --- Executes on button press in selectAll_button.
function selectAll_button_Callback(hObject, eventdata, handles)
set(handles.eigenfunction_box,'Value',1:length(get(handles.eigenfunction_box,'String')));
set_buttons(handles,0);
guidata(hObject,handles);




% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.eigenfunctions_plot)


% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.eigenfunctions_plot)


% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
HelpPath = which('eigenfunctions_plot.m');
[pathstr,name,ext] = fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','eigenfunctions.html');
web(HelpPath);


function [trunca,truncb]=get_truncation_points(bp,E,distorted)
trunca=1;
truncb=length(bp.h);
inita=bp.imatch;
initb=bp.imatch;
%if infmax
  sums=0;
  V0=bp.V0;
  h=bp.h;
  for i=initb:length(h)-1 
    v0i=V0(i);  
    if v0i>=E && V0(i+1) > v0i
      if sums==0
          initb=i;
      end
      sums=sums+sqrt(v0i-E)*h(i);
    else
      sums=0;  
    end
    if sums > 15
        truncb=i;
        break;
    end
  end
%else
%  truncb=length(bp.h);   
%end
%if infmin
if ~distorted
  sums=0;
  for i=inita:-1:2
    v0i=V0(i);  
    if v0i>=E && V0(i-1) > v0i
      if sums==0
          inita=i;
      end
      sums=sums+sqrt(v0i-E)*h(i);
    else
      sums=0;  
    end
    if sums > 15
        trunca=i;
        break;
    end
  end
end
%else
%  trunca=1;   
%end


