function varargout = eigenfunctions_potential_plot(varargin)
% EIGENFUNCTIONS_POTENTIAL_PLOT M-file for
% eigenfunctions_potential_plot.fig

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help eigenfunctions_potential_plot

% Last Modified by GUIDE v2.5 09-Dec-2004 14:50:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenfunctions_potential_plot_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenfunctions_potential_plot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenfunctions_potential_plot is made visible.
function eigenfunctions_potential_plot_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenfunctions_potential_plot (see VARARGIN)
i=1;
handles.squares=false;
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
         case 'cpm'
               handles.cpm = varargin{i+1}; 
         case 'eigenvalues'
               handles.eigenvalues = varargin{i+1};
         case 'indices'
               handles.indices = varargin{i+1};
         case 'Y'
               handles.Y = varargin{i+1};
         case 'X'
               handles.X = varargin{i+1};
         case 'Name'
               handles.name = varargin{i+1};
               set(handles.eigenfunctions_potential_plot,'Name',[handles.name ': Eigenfunctions + Potential function']);
         case 'number_matslise' %to keep track which instance of Matslise 
             handles.number_matslise=varargin{i+1};
     end
     i = i+2;
    end
end
ahandle = handles.plot_axes;
problem = get(handles.cpm(1),'schrod');
b = get(problem,'max');
a = get(problem,'min');
if isa(problem,'distorted_coulomb')
    a = min(0.02,a);
end
V = get(problem,'V');
if abs(b-a) >5e3
  step = min(abs(b-a)/250,1);
elseif abs(b-a) >1e3
  step = min(abs(b-a)/250,0.2);
else  
  step = min(abs(b-a)/250,0.05);
end
w = a:step:b;
YY = V(w);
handles.x_V=w;
handles.y_V=YY;
number_selected =length(handles.eigenvalues);
%search a good scale-factor for the eigenfunction(s):
eigdiff = [handles.eigenvalues 0] - [0 handles.eigenvalues];
if number_selected > 3 && max(handles.Y{end}) < 1
    eigdiff = max(abs(mean(eigdiff(2:length(eigdiff)-1))/2),0.002);
else
    eigdiff = max(abs(mean(eigdiff(2:length(eigdiff)-1))/4),0.002);
end
if length(handles.eigenvalues) == 1
    eigdiff = max(1,abs(min(YY)-handles.eigenvalues(1))/6);
end
len=0;
for i=2:length(handles.eigenvalues)
      len = max(len,length(handles.X{i}));
end
for i=1:length(handles.eigenvalues)
     tmp = eigdiff*handles.Y{i};
     tmp = tmp + handles.eigenvalues(i)*ones(length(tmp),1);
     Y(:,i) = [tmp; ones(len-length(tmp),1).*tmp(end)];
     x = handles.X{i};
     X(:,i) = [x; ones(len-length(tmp),1).*x(end)];
end
pause(1e-100) % stop the calculation in the GUI?
load stop
if stop
   error('The calculation was interrupted');
end
handles.eigf_X=X;
handles.eigf_Y=Y;
% for the dotted lines:
eigx = [X(1,:);X(ceil(size(X,1)/2),:);X(end,:)];
eigy = [handles.eigenvalues;handles.eigenvalues;handles.eigenvalues];
phandles=plot(handles.x_V,YY,'-k','LineWidth',1.4,'Parent',ahandle);
hold on;
colors = number_selected;
colormp = jet(colors);
%colormp = gray(colors);
colormp=remove_yellow(colormp);
set(ahandle,'ColorOrder',colormp);
for j = size(X,2):-1:1
     phandles = [phandles; plot(X(:,j),Y(:,j),'Color',colormp(j,:),'Parent',ahandle)];
end
pause(0) % stop the calculation in the GUI?
load stop
if stop
      error('The calculation was interrupted'); 
end 
tmp = find(abs(handles.Y{end})>0.0001);
j = tmp(end);
j = min(mean(X(end,:)),X(j,number_selected));
if X(tmp(1),number_selected) < j
   set(ahandle,'Xlim',[X(tmp(1),number_selected) j]);
else
   axis tight;
end
m2 = max(max(Y));
if number_selected == 1 
    set(ahandle,'Ylim',[min(YY) m2+(m2-min(YY))/4]);   
else
     m1 = max(min(YY),min(min(Y))-(m2-min(min(Y)))/4);
     set(ahandle,'Ylim',[m1 m2+(m2-m1)/7]);
end
set(get(ahandle,'XLabel'),'String','x','FontSize',12);
set(get(ahandle,'Title'),'String','Eigenfunctions + Potential function','FontSize',12);
if isa(problem,'distorted_coulomb')
   legendStr{1} = 'Potential';
else
   legendStr{1} = 'V(x)';  
end
for i =number_selected:-1:1
    legendStr = {legendStr{:} ['y_{', num2str(handles.indices(i)),'}']}; 
end
%legend(phandles(1:end),legendStr{:},'Location','Best');
leg=legend(phandles(1:end),legendStr{:});
set(leg,'FontSize',9);
hold on;
plot(eigx,eigy,':','Parent',ahandle);
hold off;

% Choose default command line output for eigenfunctions_potential_plot
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes eigenfunctions_potential_plot wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = eigenfunctions_potential_plot_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.eigenfunctions_potential_plot)


% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.eigenfunctions_potential_plot)



% --------------------------------------------------------------------
function OpenItem_Callback(hObject, eventdata, handles)
%open plot in new window
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigfs(handles,ahandle,handles.squares);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');


% --------------------------------------------------------------------
function SaveAsItem_Callback(hObject, eventdata, handles)
[fileName,path,filterindex] = uiputfile({'*.fig','MATLAB figures (*.fig)';...
        '*.jpg','JPEG images (*.jpg)';'*.eps','EPS files (*.eps)';...
        '*.eps','EPS Color files (*.eps)';'*.eps','EPS Level 2 files (*.eps)'
        '*.eps','EPS Level 2 Color files (*.eps)';...
        '*.ai','Adobe Illustrator files (*.ai)';...
        '*.bmp','bitmap files (*.bmp)';'*.tif','TIFF images (*.tif)';...
        '*.tif','TIFF no compression images (*.tif)';...
        '*.emf','Enhanced Metafiles (*.emf)';'*.pbm','Portable bitmap files (*.pbm)';...
        '*.png','Portable Network Graphics files (*.png)'},...
    'Save plot as');
if strcmp(fileName,'0') || strcmp(path,'0') || filterindex == 0
    return;
end
file=fullfile(path,fileName);
filters ={'fig','jpg','eps','epsc','eps2','epsc2','ai','bmp','tif','tiffn','emf','pbm','png'};
s=char(filters(filterindex));
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles=plot_eigfs(handles,ahandle,handles.squares);
saveas(fhandle,file,s);


%---------------------------------------------------------------------
function phandles = plot_eigfs(handles,ahandle,squares)
number_selected =length(handles.eigenvalues);
% for the dotted lines:
eigx = [handles.eigf_X(1,:);handles.eigf_X(end,:)];
eigy = [handles.eigenvalues;handles.eigenvalues];
phandles=plot(handles.x_V,handles.y_V,'-k','LineWidth',1.4,'Parent',ahandle);
hold on;
colors = number_selected;
colormp = jet(colors);
%colormp = gray(colors+4);
colormp=remove_yellow(colormp);
set(ahandle,'ColorOrder',colormp);
if handles.squares
    Y = handles.eigf_Y2;
else
    Y = handles.eigf_Y;
end
for j = size(handles.eigf_X,2):-1:1
    phandles = [phandles; plot(handles.eigf_X(:,j),Y(:,j),'Color',colormp(j,:),'Parent',ahandle)];
end
tmp = find(abs(handles.Y{end})>0.0002);
j = tmp(end);
j = min(mean(handles.eigf_X(end,:)),handles.eigf_X(j,number_selected));
if handles.eigf_X(tmp(1),number_selected) < j
  set(ahandle,'Xlim',[handles.eigf_X(tmp(1),number_selected) j]);
else
  axis tight;
end
m2 = max(max(handles.eigf_Y));
if number_selected == 1 
   set(ahandle,'Ylim',[min(handles.y_V) m2+(m2-min(handles.y_V))/4]);   
else
    m1 = max(min(handles.y_V),min(min(handles.eigf_Y))-(m2-min(min(handles.eigf_Y)))/4);
    set(ahandle,'Ylim',[m1 m2+(m2-m1)/7]);
end
set(get(ahandle,'XLabel'),'String','x','FontSize',12);
set(get(ahandle,'Title'),'String','Eigenfunctions + Potential function','FontSize',12);
if isa(get(handles.cpm(1),'schrod'),'distorted_coulomb')
  legendStr{1} = 'Potential';
else
  legendStr{1} = 'V(x)';  
end
if squares
  for i =number_selected:-1:1
   legendStr = {legendStr{:} ['(y_{', num2str(handles.indices(i)),'})^2']}; 
  end  
else
  for i =number_selected:-1:1
   legendStr = {legendStr{:} ['y_{', num2str(handles.indices(i)),'}']}; 
  end
end
hold on;
plot(eigx,eigy,':','Parent',ahandle);
hold off;
leg=legend(phandles(1:end),legendStr{:});
set(leg,'FontSize',9);

% --------------------------------------------------------------------
function CopyItem_Callback(hObject, eventdata, handles)
% copy figure to clipboard
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigfs(handles,ahandle,handles.squares);
set(fhandle,'Position',[-100 -100 30 25]);
set(fhandle,'Visible','on');
print -dmeta; 
delete(fhandle);


% --------------------------------------------------------------------
function SquareItem_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'Checked'),'off')
  set(hObject,'Checked','on');
  eigvs = ones(size(handles.eigf_Y,1),1)*handles.eigenvalues;
  eigf =(handles.eigf_Y-eigvs);
  mindiff = mean(handles.eigenvalues(2:end)-handles.eigenvalues(1:length(handles.eigenvalues)-1));
  if max(max(eigf))^2 < mindiff/2
      tmp=sqrt(mindiff)/max(max(eigf));
      eigf = eigf*tmp;
  end
  while mean(max(eigf.^2)) > max(handles.eigenvalues(2:end)-handles.eigenvalues(1:length(handles.eigenvalues)-1))
      eigf = eigf/2;
  end
  handles.eigf_Y2 = eigf.^2+eigvs;
  handles.squares = true;
else
  set(hObject,'Checked','off');  
  handles.squares = false;
end
plot_eigfs(handles,handles.plot_axes,handles.squares);
guidata(hObject, handles);


% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
HelpPath = which('eigenfunctions_potential_plot.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','eigenfunctions_potential.html');
web(HelpPath);


