function varargout = eigenvalue_data(varargin)
% EIGENVALUE_DATA M-file for eigenvalue_data.fig

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenvalue_data_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenvalue_data_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenvalue_data is made visible.
function eigenvalue_data_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenvalue_data (see VARARGIN)
i=1;
while i < length(varargin)
switch varargin{i}
    case 'eigenvalues'
        handles.eigenvalues = varargin{i+1};
    case 'indices'
        handles.indices = varargin{i+1};
    case 'errors'
        handles.errors = varargin{i+1};
    case 'Name'
        set(hObject,'Name',[varargin{i+1} ': eigenvalues ']); 
end
i = i+2;
end
s1 = sprintf('%d',handles.indices(1));
s2 = sprintf('%-22.16f',handles.eigenvalues(1));
s3 = sprintf('%4.2e',handles.errors(1));
if handles.indices(1) < 10
  resultsStr = {[s1,'     ',s2,'  ',s3]};
else
  resultsStr = {[s1,'    ',s2,'  ',s3]};  
end
for i=2:length(handles.indices)
        s1 = sprintf('%d',handles.indices(i));
        s2 = sprintf('%-22.16f',handles.eigenvalues(i));
        s3 = sprintf('%4.2e',handles.errors(i));
        if handles.indices(i) < 10
           resultsStr = [resultsStr;...
              {[s1,'     ',s2,'  ',s3]}] ;
        else
            resultsStr = [resultsStr;...
              {[s1,'    ',s2,'  ',s3]}] ;
        end
end
set(handles.data_listbox,'String',resultsStr);
set(handles.data_listbox,'Value',[]);

% Choose default command line output for eigenvalue_data
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes eigenvalue_data wait for user response (see UIRESUME)
% uiwait(handles.eigenvalue_data);


% --- Outputs from this function are returned to the command line.
function varargout = eigenvalue_data_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function data_listbox_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in data_listbox.
function data_listbox_Callback(hObject, eventdata, handles)

% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
delete(handles.eigenvalue_data);


% --- Executes on button press in workspace_button.
function workspace_button_Callback(hObject, eventdata, handles)
global gapp
prompt={'Enter name for the indices:','Enter name for the eigenvalues:',...
        'Enter name for the errors:'};
title = 'Enter variable names';
lines = 1;
if isfield(gapp,'name_indices')
  def = {gapp.name_indices,gapp.name_eigenvalues,gapp.name_errors};
else
  def = {'indices','eigenvalues','errors'};
end
answer = inputdlg(prompt,title,lines,def);
if ~isempty(answer)
  assignin('base',answer{1},handles.indices);
  assignin('base',answer{2},handles.eigenvalues);
  assignin('base',answer{3},handles.errors);
  gapp.name_indices = answer{1};
  gapp.name_eigenvalues = answer{2};
  gapp.name_errors = answer{3};
end


% --- Executes on button press in Clipboard_button.
function Clipboard_button_Callback(hObject, eventdata, handles)
% hObject    handle to Clipboard_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s1 = sprintf('%d',handles.indices(1));
s2 = sprintf('%-22.16f',handles.eigenvalues(1));
s3 = sprintf('%4.2e',handles.errors(1));
Str = [s1,'             ',s2,'              ',s3];
for i=2:length(handles.indices)
        Str = sprintf('%s\n',Str);
        s1 = sprintf('%d',handles.indices(i));
        s2 = sprintf('%-22.16f',handles.eigenvalues(i));
        s3 = sprintf('%4.2e',handles.errors(i));
        Str = [Str [s1,'             ',s2,'              ',s3]] ;
end
clipboard('copy',Str);
