function varargout = eigenvalues_plot(varargin)
% EIGENVALUES_PLOT M-file for eigenvalues_plot.fig
%      EIGENVALUES_PLOT, by itself, creates a new EIGENVALUES_PLOT or raises the existing
%      singleton*.
%
%      H = EIGENVALUES_PLOT returns the handle to a new EIGENVALUES_PLOT or the handle to
%      the existing singleton*.
%
%      EIGENVALUES_PLOT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EIGENVALUES_PLOT.M with the given input arguments.
%
%      EIGENVALUES_PLOT('Property','Value',...) creates a new EIGENVALUES_PLOT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before eigenvalues_plot_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to eigenvalues_plot_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help eigenvalues_plot

% Last Modified by GUIDE v2.5 13-Dec-2004 10:04:08

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenvalues_plot_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenvalues_plot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenvalues_plot is made visible.
function eigenvalues_plot_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenvalues_plot (see VARARGIN)
i=1;
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
         case 'eigenvalues'
               handles.eigenvalues = varargin{i+1};
         case 'indices'
               handles.indices = varargin{i+1};
         case 'Name'
               handles.name = varargin{i+1};
               set(handles.eigenvalues_plot,'Name',[handles.name ': Eigenvalues plot']);
         case 'a'
               handles.a = varargin{i+1};
         case 'b'
               handles.b = varargin{i+1};
         case 'V'
               handles.V = varargin{i+1};
         case 'cpm'
               handles.cpm = varargin{i+1};
     end
     i = i+2;
    end
end
ahandle = handles.axes1;
phandles = plot(handles.indices,handles.eigenvalues,'bo',...
     'MarkerFaceColor','b','MarkerSize',5,'Parent',ahandle);
 if length(handles.indices) <200
   set(ahandle,'XGrid','on');
   set(ahandle,'YGrid','on');
   set(ahandle,'xtick',handles.indices)
   set(ahandle, 'XTickMode', 'manual');
end
set(get(ahandle,'XLabel'),'String','i','FontSize',11);
legend(ahandle,'E_i','Location','Best');
%
a = handles.a;
b = handles.b;
V = inline(handles.V);
problem = get(handles.cpm,'schrod');
if isa(problem,'distorted_coulomb')
   step = min(abs(b-a)/500,1);
else
   step = min(abs(b-a)/500,3);
end
w = a:step:b;
if isa(problem,'transformed_slp')
   r = x2r(problem,w);    %= sturm-liouville r
   VV = V(r);
else
   VV = V(w);
end
%construct new figure + axes:
ahandle = handles.axes2;
phandles = plot(w,VV,':k','Parent',ahandle);
colors = length(handles.indices);
colormp = jet(colors);
colormp=remove_yellow(colormp);
legendStr{1} = 'V(x)';
hold on;
if length(handles.indices)<15
 %to make the colors in the legend match with the color of the eigenvalues_window:
 for j = length(handles.indices):-1:1
   plot(b+2,handles.eigenvalues(j),'Color',colormp(j,:),'Parent',ahandle);
   hold on;
   legendStr = {legendStr{:} ['E_{', num2str(handles.indices(j)),'}']};
 end
end
%
for j = length(handles.indices):-1:1
  lines = []; %linesegments representing energy levels
  eigv = handles.eigenvalues(j); %current eigenvalue
  start = a; %start of linesegment
  for i=1:length(VV)-1
    if VV(i) >= eigv && VV(i+1) < eigv
        start = (w(i) + w(i+1))/2; 
    end
    if VV(i) < eigv && VV(i+1) >= eigv
        lines = [lines; start (w(i) + w(i+1))/2];
    end
  end
  if VV(end) < eigv
      lines = [lines; start b];
  end
 %draw these linesegments
 for s=1:size(lines,1)
   plot([lines(s,1) lines(s,2)],[eigv eigv],'Color',colormp(j,:),'Parent',ahandle);
   hold on;
 end
 if isempty(lines)
     plot([a b],[eigv eigv],'Color',colormp(j,:),'Parent',ahandle);
 end
 if j==length(handles.indices)
     savedLines=lines;
 end
end
%find good xlimits and ylimits for the axis: 
if isempty(lines)
    xmax = b;
    xmin = a;
else
  xmax = min(max([max(savedLines) a])+1,b);
  xmin = max(min([min(savedLines) b]-1),a);
end
hold off;
ymin = min(min(handles.eigenvalues),min(VV(15:end)));
ymax = max(handles.eigenvalues);
ymin=ymin-(ymax-ymin)/30;
if length(handles.indices) > 1
 [s1,s2]=size(handles.eigenvalues);   
 if s1<s2
    eigvdiff = [handles.eigenvalues 0]-[0 handles.eigenvalues];
 else
    eigvdiff = [handles.eigenvalues; 0]-[0; handles.eigenvalues]; 
 end
 eigvdiff = min(eigvdiff(2:length(eigvdiff)-1));
 if (eigvdiff/(ymax-ymin)) < 0.005
  ymin = min(handles.eigenvalues) - abs(ymax-min(handles.eigenvalues))/6;
 end
end
ymax = ymax + abs(ymax-ymin)/6;
if ymax <= ymin
    ymax = ymin + 1;
    ymin = ymin - 1;
end
axis(ahandle,[xmin xmax ymin ymax]);
leg=legend(ahandle,legendStr{:},'Location','Best');
set(leg,'FontSize',9);
set(get(ahandle,'XLabel'),'String','x','FontSize',11);

% Choose default command line output for eigenvalues_plot
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes eigenvalues_plot wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = eigenvalues_plot_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.eigenvalues_plot)


% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.eigenvalues_plot)


% --------------------------------------------------------------------
function OpenItem_Callback(hObject, eventdata, handles)
set(handles.info_edit,'String','Busy...');
drawnow;
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigv1(handles,ahandle);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigv2(handles,ahandle);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');
set(handles.info_edit,'String','Ready');


%------------------------------------------------------------------
function phandles=plot_eigv1(handles,ahandle)
phandles = plot(handles.indices,handles.eigenvalues,'bo',...
     'MarkerFaceColor','b','MarkerSize',5,'Parent',ahandle);
if length(handles.indices) <200
   set(ahandle,'XGrid','on');
   set(ahandle,'YGrid','on');
   set(ahandle,'xtick',handles.indices)
   set(ahandle, 'XTickMode', 'manual');
end
set(get(ahandle,'XLabel'),'String','i','FontSize',11);
legend(ahandle,'E_i','Location','Best');


%--------------------------------------------------------------------
function phandles=plot_eigv2(handles,ahandle)
a = handles.a;
b = handles.b;
V = inline(handles.V);
problem = get(handles.cpm,'schrod');
if isa(problem,'distorted_coulomb')
   step = min(abs(b-a)/500,1);
else
   step = min(abs(b-a)/500,3);
end
w = a:step:b;
if isa(problem,'transformed_slp')
     w = x2r(problem,w);    %= sturm-liouville r
end
VV = V(w);
phandles = plot(w,VV,':k','Parent',ahandle);
colors = length(handles.indices);
colormap = jet(colors);
colormap=remove_yellow(colormap);
legendStr{1} = 'V(x)';
hold on;
%to make the colors in the legend match with the color of the eigenvalues_window:
for j = length(handles.indices):-1:1
   plot(b+2,handles.eigenvalues(j),'Color',colormap(j,:),'Parent',ahandle);
   hold on;
   legendStr = {legendStr{:} ['E_{', num2str(handles.indices(j)),'}']}; 
end
%
savedLines=[];
for j = 1:length(handles.indices)
  lines = []; %linesegments representing energy levels
  eigv = handles.eigenvalues(j); %current eigenvalue
  start = a; %start of linesegment
  for i=1:length(VV)-1
    if VV(i) >= eigv && VV(i+1) < eigv
        start = (w(i) + w(i+1))/2; 
    end
    if VV(i) < eigv && VV(i+1) >= eigv
        lines = [lines; start (w(i) + w(i+1))/2];
    end
  end
  if VV(end) < eigv
      lines = [lines; start b];
  end
 %draw these linesegments
 for s=1:size(lines,1)
   plot([lines(s,1) lines(s,2)],[eigv eigv],'Color',colormap(j,:),'Parent',ahandle);
   hold on;
 end
 if isempty(lines)
     plot([a b],[eigv eigv],'Color',colormap(j,:),'Parent',ahandle);
 end
  if j==length(handles.indices)
     savedLines=lines;
 end
end
%find good xlimits and ylimits for the axis: 
if isempty(savedLines)
    xmax = b;
    xmin = a;
else
  xmax = min(max([max(savedLines) a])+1,b); 
  xmin = max(min([min(savedLines) b]-1),a);
end
hold off;
ymin = min(min(handles.eigenvalues),min(VV(15:end)));
ymax = max(handles.eigenvalues);
ymin=ymin-(ymax-ymin)/30;
if length(handles.indices) > 1
 [s1,s2]=size(handles.eigenvalues);
 if s1<s2
   eigvdiff = [handles.eigenvalues 0]-[0 handles.eigenvalues];
 else
   eigvdiff = [handles.eigenvalues; 0]-[0; handles.eigenvalues];  
 end
 eigvdiff = min(eigvdiff(2:length(eigvdiff)-1));
 if (eigvdiff/(ymax-ymin)) < 0.005
  ymin = min(handles.eigenvalues) - abs(ymax-min(handles.eigenvalues))/6;
 end
end
ymax = ymax + abs(ymax-ymin)/6;
if ymax <= ymin
    ymax = ymin + 1;
    ymin = ymin - 1;
end
axis(ahandle,[xmin xmax ymin ymax]);
leg=legend(ahandle,legendStr{:},'Location','Best');
set(leg,'FontSize',9);
set(get(ahandle,'XLabel'),'String','x','FontSize',11);



function info_edit_Callback(hObject, eventdata, handles)
% hObject    handle to info_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of info_edit as text
%        str2double(get(hObject,'String')) returns contents of info_edit as a double


% --- Executes during object creation, after setting all properties.
function info_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to info_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


