function varargout = eigenvalues_plot_param(varargin)
% EIGENVALUES_PLOT_PARAM M-file for eigenvalues_plot_param.fig
%      EIGENVALUES_PLOT_PARAM, by itself, creates a new EIGENVALUES_PLOT_PARAM or raises the existing
%      singleton*.
%
%      H = EIGENVALUES_PLOT_PARAM returns the handle to a new EIGENVALUES_PLOT_PARAM or the handle to
%      the existing singleton*.
%
%      EIGENVALUES_PLOT_PARAM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EIGENVALUES_PLOT_PARAM.M with the given input arguments.
%
%      EIGENVALUES_PLOT_PARAM('Property','Value',...) creates a new EIGENVALUES_PLOT_PARAM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before eigenvalues_plot_param_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to eigenvalues_plot_param_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help eigenvalues_plot_param

% Last Modified by GUIDE v2.5 13-Dec-2004 10:09:23

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenvalues_plot_param_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenvalues_plot_param_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenvalues_plot_param is made visible.
function eigenvalues_plot_param_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenvalues_plot_param (see VARARGIN)

% Choose default command line output for eigenvalues_plot_param
i=1;
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
         case 'Name'
               handles.name = varargin{i+1};
               set(handles.eigenvalues_plot_param,'Name',[handles.name ': Eigenvalues plot']);
         case 'E'
               handles.E = varargin{i+1};
         case 'parameterName'
               handles.parameterName = varargin{i+1};
         case 'parameterValues'
               handles.parameterValues = varargin{i+1};
     end
     i = i+2;
    end
end
ahandle = handles.axes1;
colors = length(handles.E);
colormap = jet(colors);
%colormap = gray(colors+2);
colormap=remove_yellow(colormap);
if length(handles.E)>19
       colormap=[colormap(1,:); colormap(end,:); colormap(2:length(handles.E)-1,:)]; 
       inds=[1 length(handles.E) 2:length(handles.E)-1];
else
    inds=1:length(handles.E);
end
for i=1:length(handles.E)
    plot(handles.E(inds(i)).indices,handles.E(inds(i)).eigenvalues,':.',...
        'Color',colormap(i,:),'Parent',ahandle);
    if length(handles.E)<20
       legendStr{i} = [char(handles.parameterName), ' = ', num2str(handles.parameterValues(i))];
    end
    hold on;
end
hold off;
if length(handles.E)>19
    legendStr{1} = [char(handles.parameterName), ' = ', num2str(handles.parameterValues(1))];
    legendStr{2} = [char(handles.parameterName), ' = ', num2str(handles.parameterValues(end))];
end
indmin = handles.E(1).indices(1);
indmax = handles.E(1).indices(end);
axis tight;
set(ahandle,'xtick',[indmin:indmax])
set(ahandle, 'XTickMode', 'manual');
set(get(ahandle,'XLabel'),'String','i','FontSize',12);
set(get(ahandle,'YLabel'),'String','E_i','FontSize',12);
set(get(ahandle,'YLabel'),'Rotation',0.0);
leg=legend(ahandle,legendStr{:},'Location','Best');
set(leg,'FontSize',8);
ahandle=handles.axes2;
% index_low = handles.E(1).indices(1);
% for i=2:length(handles.E)
%     if handles.E(i).indices(1) ~= index_low
%         index_low = -1;
%         break;
%     end
% end
%if index_low > -1            % when using the option "Eigenvalues between ... and ...", 
    %it is possible that the different runs have different (or less ...) values for the
    %indices. In that case, the second plot is not produced.
min_index = handles.E(1).indices(1);
max_index = handles.E(1).indices(1);
for i=1:length(handles.E)
  min_index = min(min(handles.E(i).indices),min_index);
  max_index = max(max(handles.E(i).indices),max_index);
end
min_index=min_index-1;
for j=1:(max_index-min_index)
  X{j}=[];
  Y{j}=[];
end
for i=1:length(handles.E)
    for j=1:length(handles.E(i).indices)
        X{handles.E(i).indices(j)-min_index}=[X{handles.E(i).indices(j)-min_index} handles.parameterValues(i)];
        Y{handles.E(i).indices(j)-min_index}=[Y{handles.E(i).indices(j)-min_index} handles.E(i).eigenvalues(j)];
    end
end
legendStr = {};
colors = max_index-min_index;
colormap = jet(colors);
colormap=remove_yellow(colormap);
hlp=find((handles.parameterValues(2:length(handles.parameterValues))-...
        handles.parameterValues(1:length(handles.parameterValues)-1))<0);
if isempty(hlp) || length(hlp)==length(handles.parameterValues)-1
    t=(max_index-min_index);
    for j=t:-1:1
    phandles = plot(X{j},Y{j},':.','Color',colormap(j,:),'Parent',ahandle);
      set(ahandle,'Nextplot','add');
    legendStr{t-j+1} = ['i = ' num2str(min_index+j)];
    hold on;
  end
else
   t=max_index-min_index; 
   for j=t:-1:1
    phandles = plot(X{j},Y{j},'.','Color',colormap(j,:),'Parent',ahandle);
      set(ahandle,'Nextplot','add');
    legendStr{t-j+1} = ['i = ' num2str(min_index+j)];
    hold on;
  end 
end
hold off;
axis tight;
try
set(ahandle,'xtick',handles.parameterValues)
set(ahandle, 'XTickMode', 'manual');
axis(ahandle,'tight');
catch
end
set(get(ahandle,'XLabel'),'String',char(handles.parameterName),'FontSize',12);
set(get(ahandle,'YLabel'),'String','E_i','FontSize',12);
set(get(ahandle,'YLabel'),'Rotation',0.0);
leg=legend(ahandle,legendStr{:});
set(leg,'FontSize',8);
%end
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes eigenvalues_plot_param wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = eigenvalues_plot_param_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.eigenvalues_plot_param)


% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.eigenvalues_plot_param)

% --------------------------------------------------------------------
function OpenItem_Callback(hObject, eventdata, handles)
set(handles.info_edit,'String','Busy...');
drawnow;
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
colors = length(handles.E);
colormap = jet(colors);
colormap=remove_yellow(colormap);
if length(handles.E)>19
   colormap=[colormap(1,:); colormap(end,:); colormap(2:length(handles.E)-1,:)];  
   inds=[1 length(handles.E) 2:length(handles.E)-1];
else
   inds=1:length(handles.E); 
end
for i=1:length(handles.E)
    plot(handles.E(inds(i)).indices,handles.E(inds(i)).eigenvalues,':.',...
        'Color',colormap(i,:),'Parent',ahandle);
    if length(handles.E)<20
      legendStr{i} = [char(handles.parameterName), ' = ', num2str(handles.parameterValues(i))];
    end
    hold on;
end
hold off;
if length(handles.E)>19
    legendStr{1} = [char(handles.parameterName), ' = ', num2str(handles.parameterValues(1))];
    legendStr{2} = [char(handles.parameterName), ' = ', num2str(handles.parameterValues(end))];
end
indmin = handles.E(1).indices(1);
indmax = handles.E(1).indices(end);
set(ahandle,'xtick',[indmin:indmax])
set(ahandle, 'XTickMode', 'manual');
set(get(ahandle,'XLabel'),'String','i','FontSize',12);
set(get(ahandle,'YLabel'),'String','E_i','FontSize',12);
set(get(ahandle,'YLabel'),'Rotation',0.0);
leg=legend(ahandle,legendStr{:});
set(leg,'FontSize',8);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
% index_low = handles.E(1).indices(1);
% for i=2:length(handles.E)
%     if handles.E(i).indices(1) ~= index_low
%         index_low = -1;
%         break;
%     end
% end
%if index_low > -1            % when using the option "Eigenvalues between ... and ...", 
    %it is possible that the different runs have different (or less ...) values for the
    %indices. In that case, the second plot is not produced.
% for i=1:length(handles.E)
%   X(:,i) = (handles.E(1).indices)';
%   Y(:,i) = (handles.E(i).eigenvalues)'; 
% end
% legendStr = {};
% set(fhandle,'DefaultAxesColorOrder',hsv(size(X,1)));
% phandles = plot(handles.parameterValues',Y',':.','Parent',ahandle);
% axis tight;
% axis(ahandle,'tight');
% set(ahandle,'xtick',handles.parameterValues)
% set(ahandle, 'XTickMode', 'manual');
% set(get(ahandle,'XLabel'),'String',char(handles.parameterName),'FontSize',12);
% set(get(ahandle,'YLabel'),'String','E_i','FontSize',12);
% set(get(ahandle,'YLabel'),'Rotation',0.0);
% for i =1:size(X,1)
%    legendStr{i} = ['i = ', num2str(X(i,1))]; 
% end
% legend(phandles(1:end),legendStr{:});
%end
min_index = handles.E(1).indices(1);
max_index = handles.E(1).indices(1);
for i=1:length(handles.E)
  min_index = min(min(handles.E(i).indices),min_index);
  max_index = max(max(handles.E(i).indices),max_index);
end
min_index=min_index-1;
for j=1:(max_index-min_index)
  X{j}=[];
  Y{j}=[];
end
for i=1:length(handles.E)
    for j=1:length(handles.E(i).indices)
        X{handles.E(i).indices(j)-min_index}=[X{handles.E(i).indices(j)-min_index} handles.parameterValues(i)];
        Y{handles.E(i).indices(j)-min_index}=[Y{handles.E(i).indices(j)-min_index} handles.E(i).eigenvalues(j)];
    end
end
legendStr = {};
colors = max_index-min_index;
colormap = jet(colors);
colormap=remove_yellow(colormap);
hlp=find((handles.parameterValues(2:length(handles.parameterValues))-...
        handles.parameterValues(1:length(handles.parameterValues)-1))<0);
if isempty(hlp) || length(hlp)==length(handles.parameterValues)-1
    t=(max_index-min_index);
    for j=t:-1:1   
     phandles = plot(X{j},Y{j},':.','Color',colormap(j,:),'Parent',ahandle);
      set(ahandle,'Nextplot','add');
     legendStr{t-j+1} = ['i = ' num2str(min_index+j)];
    hold on;
  end
else
   t=(max_index-min_index);
   for j=t:-1:1
    phandles = plot(X{j},Y{j},'.','Color',colormap(j,:),'Parent',ahandle);
      set(ahandle,'Nextplot','add');
    legendStr{t-j+1} = ['i = ' num2str(min_index+j)];
    hold on;
  end 
end
hold off;
axis tight;
try
set(ahandle,'xtick',handles.parameterValues)
catch
end
set(ahandle, 'XTickMode', 'manual');
set(get(ahandle,'XLabel'),'String',char(handles.parameterName),'FontSize',12);
set(get(ahandle,'YLabel'),'String','E_i','FontSize',12);
set(get(ahandle,'YLabel'),'Rotation',0.0);
leg=legend(ahandle,legendStr{:});
set(leg,'FontSize',8);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');
set(handles.info_edit,'String','Ready');




function info_edit_Callback(hObject, eventdata, handles)
% hObject    handle to info_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of info_edit as text
%        str2double(get(hObject,'String')) returns contents of info_edit as a double


% --- Executes during object creation, after setting all properties.
function info_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to info_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


