function varargout = eigenvalues_window(varargin)
% EIGENVALUES_WINDOW M-file for eigenvalues_window.fig

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenvalues_window_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenvalues_window_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenvalues_window is made visible.
function eigenvalues_window_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenvalues_window (see VARARGIN)
global gapp
i=1;
cpm_set = false;
handles.halfrange_reduction = false;
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
         case 'CPM'
               handles.cpm = varargin{i+1};
               cpm_set = true;
         case 'halfrangereduction'
               handles.halfrange_reduction = varargin{i+1}; 
         case 'Name'
               handles.name = varargin{i+1};
               set(handles.eigenvalues_window,'Name',[handles.name ': eigenvalues']);
         case 'number_matslise' %to keep track which instance of Matslise 
             handles.number_matslise=varargin{i+1};
     end
     i = i+2;
    end
end
if ~cpm_set
    errordlg('Eigenvalues should receive a cpm_object as input argument','Error','modal');
end
handles.cpm_original = handles.cpm;
set(handles.CopyItem,'Enable','off');
if isfield(gapp,'indices') && length(gapp.indices) >= handles.number_matslise
if gapp.indices(handles.number_matslise) == 1  
    set(handles.indmin_edit,'String',gapp.eigvIndexi(handles.number_matslise));
    set(handles.indmax_edit,'String',gapp.eigvIndexf(handles.number_matslise));
elseif gapp.indices(handles.number_matslise) == -1  
    set(handles.indices_button,'Value',0);
    set(handles.eigenvalue_button,'Value',1);
    set([handles.eigmin_edit,handles.eigmax_edit,handles.eigenvalues_text],'Enable','On');
    set([handles.indmin_edit,handles.indmax_edit,handles.indices_text],'Enable','Off');
    set([handles.indmin_edit,handles.indmax_edit],'String','');
    set(handles.eigmin_edit,'String',gapp.eigvi(handles.number_matslise));
    set(handles.eigmax_edit,'String',gapp.eigvf(handles.number_matslise));
end
end
% Choose default command line output for eigenvalues_window
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = eigenvalues_window_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%----------------------------------------------------------------------
%-----------------------Create functions-------------------------------
%----------------------------------------------------------------------

function results_listbox_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function indmin_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function indmax_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function eigmin_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function eigmax_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function info_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function stop_button_CreateFcn(hObject, eventdata, handles)
%----------------------------------------------------------------------
%-----------------------Callback functions-----------------------------
%----------------------------------------------------------------------

% --- Executes on button press in eigenvector_button.
function eigenvector_button_Callback(hObject, eventdata, handles)
global gapp 
try
stop = 0;
save stop.mat stop;
set([handles.calculate_button,handles.eigenvector_button,handles.plot_button,...
        handles.close_button,handles.save_button,handles.help_button,handles.selectAll_button],'Enable','off');
set(handles.info_edit,'String','Busy...');
drawnow
currentVals = get(handles.results_listbox,'Value');
tol = get(handles.cpm(1),'tol');
for i=1:length(currentVals)
 tmp = find(handles.incorrect == currentVals(i));
 if ~isempty(tmp)
     error(['Error!!! : The eigenfunction of the incorrect eigenvalue ' num2str(handles.indices(handles.incorrect(tmp(1)))) ' can''t be calculated'])
 end
end
cluster = 3;
if handles.halfrange_reduction
    acc = 1e-16;
    cluster = 1; %aantal eigenwaarden in cluster
    for i=2:length(handles.eigvalues)
          if abs((handles.eigvalues(i)-handles.eigvalues(i-1))/handles.eigvalues(currentVals(1)))<acc
            cluster = cluster+1;
          else
            cluster=1;  
          end
          if cluster > 2
              break;
          end
          if i==length(handles.eigvalues) && length(handles.eigvalues)>3
              acc =0;
          end
    end
else
    acc = 3e-14;
end
for i=1:length(currentVals)-1
    if abs((handles.eigvalues(currentVals(i))-handles.eigvalues(currentVals(i+1)))/handles.eigvalues(currentVals(i)))<acc && cluster > 2
        error(['Error!!! : Very close eigenvalues: the eigenfunctions are very ill-conditioned and can''t be calculated accurately within the double precision arithmetic.']);
    end
end
if handles.halfrange_reduction
       acc = 1e-12;
else
       acc = 8e-8;
end
number_selected = length(currentVals);
if number_selected == 1  
   if currentVals>1 && handles.eigvalues(currentVals)-handles.eigvalues(currentVals-1) < acc
    warndlg('Close eigenvalues detected: This makes the eigenfunctions of the clustered eigenvalues very ill-conditioned!');
   elseif currentVals < length(handles.eigvalues) &&  handles.eigvalues(currentVals+1)-handles.eigvalues(currentVals) < acc
       warndlg('Close eigenvalues detected: This makes the eigenfunctions of the clustered eigenvalues very ill-conditioned!');
   end
   if isfield(gapp,'eigenfunction_plot') && length(gapp.eigenfunction_plot)>=handles.number_matslise && ishandle(gapp.eigenfunction_plot(handles.number_matslise))
       try
         delete(gapp.eigenfunction_plot(handles.number_matslise));
       catch
       end
   end 
   gapp.eigenfunction_plot(handles.number_matslise) = eigenfunction_plot('CPM',handles.cpm,...
    'eigenvalue',handles.eigvalues(currentVals),...
    'index',handles.indices(currentVals),'halfrangereduction',handles.halfrange_reduction,...
    'Name',handles.name,'number_matslise',handles.number_matslise);
  % movegui(gapp.eigenfunction_plot,'center');
   movegui(gapp.eigenfunction_plot(handles.number_matslise),'onscreen');
else
if number_selected > 15
    warndlg('Please select less then 16 eigenfunctions to plot simultaneously');
    set([handles.calculate_button,handles.eigenvector_button,handles.plot_button,...
        handles.close_button,handles.save_button,handles.help_button,handles.selectAll_button],'Enable','on');
    set(handles.info_edit,'String','Ready');
    return;
end
if isfield(gapp,'eigenfunctions_plot') && length(gapp.eigenfunctions_plot) >= handles.number_matslise && ishandle(gapp.eigenfunctions_plot(handles.number_matslise))
    try
      delete(gapp.eigenfunctions_plot(handles.number_matslise));
    catch
    end
end
if min(handles.eigvalues(2:length(handles.eigvalues))-handles.eigvalues(1:length(handles.eigvalues)-1)) < acc
    warndlg('Close eigenvalues detected: This makes the eigenfunctions of the clustered eigenvalues very ill-conditioned!');
end
gapp.incorrect_eigenfunctions = [];
gapp.eigenfunctions_plot(handles.number_matslise)=eigenfunctions_plot('Eigenvalues',handles.eigvalues(currentVals),'Indices',...
    handles.indices(currentVals),'CPM',handles.cpm,'halfrangereduction',handles.halfrange_reduction,...
    'Name',handles.name,'number_matslise',handles.number_matslise);
if ~isempty(gapp.incorrect_eigenfunctions)
    s=sprintf(['Some of the eigenfunctions are incorrect.\nThis may be the consequence of :\n\n'...
            '1. The input tolerance is not small enough --> the eigenvalue is not accurate enough to compute the associated eigenfunction correctly.\n\n'...
            '2. Very close eigenvalues occur and the input tolerance can''t '...
            'be chosen low enough (within the double precision) to differentiate adequately between them.']);
    errordlg(s);
end
end
catch
     hlp=strfind(lasterr,'Error!!! : ');
     if isempty(hlp)
          errordlg(lasterr,'Error','modal');
     else
          msg=lasterr; 
          errordlg(msg(hlp(1)+11:end),'Error','modal');
     end
end
set(handles.info_edit,'String','Ready...');
set([handles.calculate_button,handles.eigenvector_button,handles.plot_button,...
        handles.close_button,handles.save_button,handles.help_button,handles.selectAll_button],'Enable','on');
guidata(hObject, handles);

% --- Executes on button press in plot_button.
function plot_button_Callback(hObject, eventdata, handles)
global gapp
try
set(handles.info_edit,'String','Busy...');
set([handles.calculate_button,handles.eigenvector_button,handles.plot_button,...
        handles.close_button,handles.save_button,handles.help_button,handles.selectAll_button],'Enable','off');
currentVals = get(handles.results_listbox,'Value');
if isempty(currentVals) 
    error('There are no eigenvalues selected')
end
if isfield(gapp,'eigenvalue_plot') && length(gapp.eigenvalue_plot) >= handles.number_matslise && ishandle(gapp.eigenvalue_plot(handles.number_matslise))
    try
     delete(gapp.eigenvalue_plot(handles.number_matslise));
    catch
    end
end
problem = get(handles.cpm(1),'schrod');
b = get(problem,'max');
a = get(problem,'min');
if handles.halfrange_reduction
   a = -b; 
end
%construct potential function:
V = get(problem,'V');
gapp.eigenvalue_plot(handles.number_matslise) = eigenvalues_plot('eigenvalues',handles.eigvalues(currentVals),...
    'indices',handles.indices(currentVals),'Name',handles.name,'V',char(V),'a',a,'b',b,'cpm',handles.cpm(1));
catch
    errordlg(lasterr,'Error','modal');
end
set([handles.calculate_button,handles.eigenvector_button,handles.plot_button,...
        handles.close_button,handles.save_button,handles.help_button,handles.selectAll_button],'Enable','on');
set(handles.info_edit,'String','Ready...');


% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
delete(handles.eigenvalues_window)


% --- Executes on button press in help_button.
function help_button_Callback(hObject, eventdata, handles)
HelpPath = which('eigenvalues_window.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','eigenvalues.html');
web(HelpPath);

% --- Executes on button press in calculate_button.
function calculate_button_Callback(hObject, eventdata, handles)
global ghandles gapp
stop = 0;
save stop.mat stop;
set(handles.stop_button,'Enable','on');
set([handles.calculate_button,handles.eigenvector_button,handles.plot_button,...
        handles.close_button,handles.save_button,handles.help_button,handles.selectAll_button,...
        handles.indices_button,handles.eigenvalue_button],'Enable','off');
val = get(handles.indices_button,'Value');
set(handles.results_listbox,'String','');
set(handles.results_listbox,'Value',1);
set(handles.info_edit,'BackgroundColor',[1 1 1]);
handles.indices = [];
handles.eigvalues = [];
handles.incorrect=[];
class=get(get(handles.cpm_original(1),'schrod'),'classification');
tol = get(handles.cpm_original(1),'tol');
try 
  set(handles.info_edit,'String','Busy...');
  drawnow;
  if val == 1
    indmin = str2double(get(handles.indmin_edit,'String'));
    indmax = str2double(get(handles.indmax_edit,'String'));
    gapp.indices(handles.number_matslise)=1;
    gapp.eigvIndexi(handles.number_matslise)=indmin;
    gapp.eigvIndexf(handles.number_matslise)=indmax;
    time = cputime;
    if ~handles.halfrange_reduction 
         [E,handles.cpm] = get_eigenvalues(handles.cpm_original,indmin,indmax,true);
    else
          original = handles.cpm_original;
          if mod(indmin,2)==0
              i1=indmin/2;
          else
              i1=(indmin+1)/2;
          end
          if mod(indmax,2)==0
              i2=indmax/2;
          else
              i2=(indmax-1)/2;
          end
          try
          [E1,cpm_hr1] = get_eigenvalues(original(1),i1,i2,true);
          catch
              E1.eigenvalues=[];
          end
          if mod(indmin,2)==1
              i1=(indmin-1)/2;
          else
              i1=indmin/2;
          end
          if mod(indmax,2)==1
              i2=(indmax-1)/2;
          else
              i2=(indmax/2)-1;
          end
          try
          [E2,cpm_hr2] = get_eigenvalues(original(2),i1,i2,true);
          catch
              E2.eigenvalues=[];
          end
          E.success = E1.success || E2.success;
          if E.success
              E.eigenvalues = [];
              E.errors = [];
              E.status = [];
              if isempty(E1.eigenvalues)
                  E.eigenvalues = E2.eigenvalues;
                  E.errors = E2.errors;
                  E.status = E2.status;
              else
              len = min(length(E2.eigenvalues),length(E1.eigenvalues));    
              for i = 1:len
                  E.eigenvalues = [E.eigenvalues E1.eigenvalues(i)...
                      E2.eigenvalues(i)];
                  E.errors = [E.errors E1.errors(i) E2.errors(i)];
                  E.status = [E.status E1.status(i) E2.status(i)];
              end
              if length(E2.eigenvalues) < length(E1.eigenvalues)
                  E.eigenvalues = [E.eigenvalues E1.eigenvalues(end)];
                  E.errors = [E.errors E1.errors(end)];
                  E.status = [E.status E1.status(end)];
              end
              if length(E1.eigenvalues) < length(E2.eigenvalues)
                  E.eigenvalues = [E.eigenvalues E2.eigenvalues(end)];
                  E.errors = [E.errors E2.errors(end)];
                  E.status = [E.status E2.status(end)];
              end
              end
              E.indices = indmin:indmax;
          else
              if ~E1.success
                  E.msg = E1.msg;
              end
              if ~E2.success
                  E.msg = E2.msg;
              end
          end
    end
    time = cputime - time;
else
    eigmin = str2double(get(handles.eigmin_edit,'String'));
    eigmax = str2double(get(handles.eigmax_edit,'String'));
    gapp.eigvi(handles.number_matslise)=eigmin;
    gapp.eigvf(handles.number_matslise)=eigmax;
    gapp.indices(handles.number_matslise)=-1;
    time = cputime;
    if ~handles.halfrange_reduction 
           [E,handles.cpm] = get_eigenvalues(handles.cpm_original,eigmin,eigmax,false); 
    else
          [E1,cpm_hr1] = get_eigenvalues(handles.cpm_original(1),eigmin,eigmax,false); 
          [E2,cpm_hr2] = get_eigenvalues(handles.cpm_original(2),eigmin,eigmax,false);
          E.success = E1.success & E2.success;
          if E.success
              j=1;
              for i = 1:length(E1.eigenvalues)
                  if i <= length(E2.eigenvalues)
                      if E1.eigenvalues(i)<=E2.eigenvalues(i)
                        E.eigenvalues(j)=E1.eigenvalues(i);
                        E.errors(j)=E1.errors(i);
                        E.status(j)=E1.status(i);
                        E.indices(j)=E1.indices(i)*2;
                        j = j+1;
                        E.eigenvalues(j)=E2.eigenvalues(i);
                        E.errors(j)=E2.errors(i);
                        E.status(j)=E2.status(i);
                        E.indices(j)=E2.indices(i)*2+1;
                        j = j+1;
                      else
                        E.eigenvalues(j)=E2.eigenvalues(i);
                        E.errors(j)=E2.errors(i);
                        E.status(j)=E2.status(i);
                        E.indices(j)=E2.indices(i)*2+1;
                        j = j+1;
                        E.eigenvalues(j)=E1.eigenvalues(i);
                        E.errors(j)=E1.errors(i);
                        E.status(j)=E1.status(i);
                        E.indices(j)=E1.indices(i)*2;
                        j = j+1;
                      end
                  else
                     E.eigenvalues(j)=E1.eigenvalues(i);
                     E.errors(j)=E1.errors(i);
                     E.status(j)=E1.status(i);
                     E.indices(j)=E1.indices(i)*2;
                     j = j+1;
                  end
              end
              if length(E.eigenvalues)<length([E1.eigenvalues E2.eigenvalues])
                  E.eigenvalues= [E.eigenvalues E2.eigenvalues(end)];
                  E.errors(j)=[E.errors E2.errors(end)];
                  E.status(j)=[E.status E2.status(end)];
                  E.indices(j)=[E.indices E2.indices(end)*2+1];
                  j = j+1;
              end
          else
              if ~E1.success
                  E.msg = E1.msg;
              end
              if ~E2.success
                  E.msg = E2.msg;
              end
          end
    end
    time = cputime - time;
end
if E.success  
    if handles.halfrange_reduction
            handles.cpm = [cpm_hr1 cpm_hr2];
    end
    if ~isempty(find(E.status > 0))
        s=sprintf('calculated %d eigenvalues in %4.2f (s) time',length(E.indices),time);
        set(handles.info_edit,'String',s);
        if abs(min(E.eigenvalues(2:end)-E.eigenvalues(1:length(E.eigenvalues)-1))) < 1e-4
            s = sprintf(['Close eigenvalues detected:\n'...
                   'Caution: clustering causes the eigenfunctions to be very ill-conditioned!\n\n'...
                   '--> A small input tolerance should be chosen (The tolerance must be smaller than the smallest distance between two eigenvalues!).\n'...
                   '--> For symmetric double well problems, half-range reduction may make the problem more tractable: '...
                   'Select the option "Half-range reduction" in the Options-menu of the problem specification window.']);
            warndlg(s);
        else
           warndlg('Some difficulties occurred during the calculation. This may suggest that the input tolerance should be decreased');
        end
        for i=1:length(E.status)
             if E.status(i) == 3
                 handles.incorrect = [handles.incorrect i];
             end
        end
        for i=1:length(E.eigenvalues)-1
               if E.eigenvalues(i)>E.eigenvalues(i+1)
                    handles.incorrect = [handles.incorrect i+1];
               end
        end
        
        if ~isempty(handles.incorrect)
            s=['NOT CORRECT: eigenvalue(s) with index ' num2str(E.indices(handles.incorrect))];
            set(handles.info_edit,'BackgroundColor',[1 0 0]); %red
            set(handles.info_edit,'String',s); 
        else
            tol = get(handles.cpm(1),'tol');
            difficulties =[];
            for i=1:length(E.errors)
             if abs(E.errors(i)) > tol*15
                 difficulties=[difficulties i];
             end
            end
            if ~isempty(difficulties)
                s=['Difficulties detected in the calculation of the eigenvalue(s) ' num2str(E.indices(difficulties))];
                set(handles.info_edit,'BackgroundColor',[1 0 0]); %red
                set(handles.info_edit,'String',s);
            end
        end
    else
      s=sprintf('Succeeded -- calculated %d eigenvalues in %4.2f (s) time',length(E.indices),time);
      set(handles.info_edit,'String',s);    
    end
    handles = display_results(handles,E,handles.incorrect);
else
    set(handles.info_edit,'String','No success!');
    s = ['The calculation din''t succeed:', E.msg];
    errordlg(s,'Error','modal');
end
catch
        set(handles.info_edit,'String','Ready...');
        hlp=strfind(lasterr,'Error!!! : ');
        if isempty(hlp)
          errordlg(lasterr,'Error','modal');
        else
          msg=lasterr; 
          errordlg(msg(hlp(1)+11:end),'Error','modal');
         end
        check_eigenvalues(handles,tol);
end
set([handles.calculate_button,handles.close_button,handles.help_button,handles.selectAll_button,...
    handles.indices_button,handles.eigenvalue_button],'Enable','on');
set(handles.stop_button,'Enable','off');
guidata(hObject,handles)


% --- Executes on button press in indices_button.
function indices_button_Callback(hObject, eventdata, handles)
if get(hObject,'Value') == 1
  set(handles.calculate_button,'Enable','On');
  set(handles.eigenvalue_button,'Value',0);
  set([handles.eigmin_edit,handles.eigmax_edit,handles.eigenvalues_text],'Enable','Off');
  set(handles.eigmin_edit,'String','');
  set(handles.eigmax_edit,'String','');
  set([handles.indmin_edit,handles.indmax_edit,handles.indices_text],'Enable','On');
else
  %set(handles.calculate_button,'Enable','Off');
  set([handles.indmin_edit,handles.indmax_edit,handles.indices_text],'Enable','Off'); 
  set([handles.eigmin_edit,handles.eigmax_edit,handles.eigenvalues_text],'Enable','On');
  set(handles.eigenvalue_button,'Value',1);
end

% --- Executes on button press in eigenvalue_button.
function eigenvalue_button_Callback(hObject, eventdata, handles)
if get(hObject,'Value') == 1
  set(handles.indices_button,'Value',0);
  set(handles.calculate_button,'Enable','On');
  set([handles.eigmin_edit,handles.eigmax_edit,handles.eigenvalues_text],'Enable','On');
  set([handles.indmin_edit,handles.indmax_edit,handles.indices_text],'Enable','Off');
  set([handles.indmin_edit,handles.indmax_edit],'String','');
else
 % set(handles.calculate_button,'Enable','Off');
  set([handles.eigmin_edit,handles.eigmax_edit,handles.eigenvalues_text],'Enable','Off');
  set(handles.indices_button,'Value',1);
 set([handles.indmin_edit,handles.indmax_edit,handles.indices_text],'Enable','On');
end


% --- Executes on button press in save_button.
function save_button_Callback(hObject, eventdata, handles)
global gapp
prompt={'Enter name for the indices:','Enter name for the eigenvalues:',...
        'Enter name for the errors:'};
title = 'Enter variable names';
lines = 1;
if isfield(gapp,'name_indices')
  def = {gapp.name_indices,gapp.name_eigenvalues,gapp.name_errors};
else
  def = {'indices','eigenvalues','errors'};
end
answer = inputdlg(prompt,title,lines,def);
if ~isempty(answer)
  currentVals = get(handles.results_listbox,'Value');
  assignin('base',answer{1},handles.indices(currentVals));
  assignin('base',answer{2},handles.eigvalues(currentVals));
  assignin('base',answer{3},handles.errors(currentVals));
  gapp.name_indices = answer{1};
  gapp.name_eigenvalues = answer{2};
  gapp.name_errors = answer{3};
end

% --- Executes on button press in selectAll_button.
function selectAll_button_Callback(hObject, eventdata, handles)
set(handles.results_listbox,'Value',1:length(get(handles.results_listbox,'String')));
set([handles.plot_button,handles.eigenvector_button,handles.save_button],'Enable','On');
guidata(hObject,handles);


% --- Executes on button press in stop_button.
function stop_button_Callback(hObject, eventdata, handles)
stop = 1;
save stop.mat stop;

% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.eigenvalues_window)

% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.eigenvalues_window)

% --------------------------------------------------------------------
function CopyItem_Callback(hObject, eventdata, handles)
s1 = sprintf('%-22.15f',handles.eigvalues(1));
s2 = sprintf('%4.1e',handles.errors(1));
if handles.indices(1) < 10
   Str = [num2str(handles.indices(1)),'         ',s1,'         ',s2];
else
   Str = [num2str(handles.indices(1)),'        ',s1,'         ',s2];
end
for i=2:length(handles.eigvalues)
   Str = sprintf('%s\n',Str); 
   s1 = sprintf('%-22.15f',handles.eigvalues(i));
   s2 = sprintf('%4.1e',handles.errors(i));
   if handles.indices(i) < 10
    Str = [Str [num2str(handles.indices(i)),'         ',s1,'         ',s2]];
   else
    Str = [Str [num2str(handles.indices(i)),'        ',s1,'         ',s2]] ;
   end
end 
clipboard('copy',Str);

%---------------------------------------------
function handles = display_results(handles,Ef,incorrect)
global ghandles
set(handles.CopyItem,'Enable','on');
if length(Ef.eigenvalues) > 0
 handles.indices = Ef.indices;  
 handles.eigvalues = Ef.eigenvalues;
 handles.errors = Ef.errors;
 s0=num2str(Ef.indices(1));
 sp0=' ';
 for i=1:(5-length(s0))
      sp0=[sp0 ' '];
 end
 s1 = sprintf('%-22.15f',Ef.eigenvalues(1));
 sp1=' ';
 for i=1:(20-length(s1))
     sp1=[sp1 ' '];
 end  
 if isempty(find(incorrect==1))
    s2 = sprintf('%4.1e',Ef.errors(1));
 else
    s2 = 'NOK';
 end
 if ispc, s2 = strrep(s2, 'e-0', 'e-'); end
 resultsStr = {[s0,sp0,s1,sp1,s2]};
 for n=2:length(Ef.eigenvalues)
   s0=num2str(Ef.indices(n));
   sp0=' ';
   for i=1:(5-length(s0))
      sp0=[sp0 ' '];
   end
   s1 = sprintf('%-22.15f',Ef.eigenvalues(n));
   sp1=' ';
   for i=1:(20-length(s1))
     sp1=[sp1 ' '];
   end
   if isempty(find(incorrect==n))
     s2 = sprintf('%4.1e',Ef.errors(n));
   else
     s2 = 'NOK';  
   end
   if ispc, s2 = strrep(s2, 'e-0', 'e-'); end
   resultsStr = [resultsStr;...
                  {[s0,sp0,s1,sp1,s2]}];
 end
set(handles.results_listbox,'String',resultsStr);
set(handles.results_listbox,'Value',[]);
set([handles.plot_button,handles.eigenvector_button,handles.save_button],'Enable','Off');
ghandles = handles;
end

%------------------------------------------------
function check_eigenvalues(handles,tol)
for i=1:length(handles.indices)-1
    if handles.eigvalues(i) > handles.eigvalues(i+1) && ...
        handles.eigvalues(i)-handles.eigvalues(i+1) > tol
        warndlg(['Eigenvalues with index > ' num2str(handles.indices(i)) ' are uncertain.   Maybe you should choose a lower tolerance.']);
        break;
    end
end

%-------------------------------------------------
function check_stop
pause(0) % stop the calculation in the GUI?
load stop
if stop
      error('The calculation was interrupted');
end

% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
HelpPath = which('eigenvalues_window.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'/Helpfiles/eigenvalues.html');
web(HelpPath);


% --------------------------------------------------------------------
function AboutItem_Callback(hObject, eventdata, handles)
HelpPath = which('eigenvalues_window.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'/helpfiles/matslise.html');
web(HelpPath);

%-----------------------------------------------------------
function cp = get_halfrange(cpm0,N)
schr = get(cpm0,'schrod');
schr=set(schr,'min',0);
tol = get(cpm0,'tol');
if N == 1
    schr = set(schr,'a0',0);
    schr = set(schr,'b0',1);
else
    schr = set(schr,'a0',1);
    schr = set(schr,'b0',0);
end
cp = cpm16_14(schr,tol);


% --- Executes on selection change in results_listbox.
function results_listbox_Callback(hObject, eventdata, handles)
if length(get(handles.results_listbox,'String'))>0
set([handles.plot_button,handles.eigenvector_button,handles.save_button],'Enable','On');
else
    set([handles.plot_button,handles.eigenvector_button,handles.save_button],'Enable','Off');
end


