function varargout = eigenvector_data(varargin)
% EIGENVECTOR_DATA M-file for eigenvector_data.fig

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eigenvector_data_OpeningFcn, ...
                   'gui_OutputFcn',  @eigenvector_data_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eigenvector_data is made visible.
function eigenvector_data_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eigenvector_data (see VARARGIN)
i=1;
while i < length(varargin)
switch varargin{i}
    case 'x'
        handles.x = varargin{i+1};
    case 'y'
        handles.y = varargin{i+1};
    case 'yp'
        handles.yp = varargin{i+1};
end
i = i+2;
end
s1 = sprintf('%-22.16f',handles.x(1));
s2 = sprintf('%-22.16f',handles.y(1));
s3 = sprintf('%-22.16f',handles.yp(1));
resultsStr = {[s1,'        ',s2,'         ',s3]};
for i=2:length(handles.x)
        s1 = sprintf('%-22.16f',handles.x(i));
        s2 = sprintf('%-22.16f',handles.y(i));
        s3 = sprintf('%-22.16f',handles.yp(i));
        resultsStr = [resultsStr;...
            {[s1,'        ',s2,'         ',s3]}] ;
end
set(handles.data_listbox,'String',resultsStr);
set(handles.data_listbox,'Value',[]);

% Choose default command line output for eigenvector_data
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes eigenvector_data wait for user response (see UIRESUME)
% uiwait(handles.eigenvector_data);


% --- Outputs from this function are returned to the command line.
function varargout = eigenvector_data_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function data_listbox_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in data_listbox.
function data_listbox_Callback(hObject, eventdata, handles)


% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
delete(handles.eigenvector_data);


% --- Executes on button press in workspace_button.
function workspace_button_Callback(hObject, eventdata, handles)
global gapp
prompt={'Enter name for the x-values:','Enter name for the y-values:',...
        'Enter name for the y''-values:'};
title = 'Enter variable names';
lines = 1;
if isfield(gapp,'name_x')
  def = {gapp.name_x,gapp.name_y,gapp.name_yp};
else
  def = {'x','y','yp'};
end
answer = inputdlg(prompt,title,lines,def);
if ~isempty(answer)
  assignin('base',answer{1},handles.x);
  assignin('base',answer{2},handles.y);
  assignin('base',answer{3},handles.yp);
  gapp.name_x = answer{1};
  gapp.name_y = answer{2};
  gapp.name_yp = answer{3};
end



% --- Executes on button press in Clipboard_button.
function Clipboard_button_Callback(hObject, eventdata, handles)
% hObject    handle to Clipboard_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
s1 = sprintf('%-22.16f',handles.x(1));
s2 = sprintf('%-22.16f',handles.y(1));
s3 = sprintf('%-22.16f',handles.yp(1));
Str = [s1,'        ',s2,'         ',s3];
for i=2:length(handles.x)
        Str = sprintf('%s\n',Str);
        s1 = sprintf('%-22.16f',handles.x(i));
        s2 = sprintf('%-22.16f',handles.y(i));
        s3 = sprintf('%-22.16f',handles.yp(i));
        Str = [Str [s1,'        ',s2,'         ',s3]];
end
clipboard('copy',Str);

