function varargout = param_eigenvector_plot(varargin)
% PARAM_EIGENVECTOR_PLOT M-file for param_eigenvector_plot.fig

% Last Modified by GUIDE v2.5 25-Oct-2004 13:15:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @param_eigenvector_plot_OpeningFcn, ...
                   'gui_OutputFcn',  @param_eigenvector_plot_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before param_eigenvector_plot is made visible.
function param_eigenvector_plot_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)
i = 1;
handles.halfrange_reduction = false;
while i < length(varargin)
switch varargin{i}
    case 'Eigenvalues'
        handles.eigenvalues = varargin{i+1}; 
    case 'Index'
        handles.index = varargin{i+1};  
    case 'CPM'
        handles.cpm = varargin{i+1};
    case 'parameterName'
        handles.parameterName = varargin{i+1};
    case 'parameterValues'
        handles.parameterValues = varargin{i+1}; 
    case 'Name'
        set(hObject,'Name',[varargin{i+1} ': eigenfunction ' num2str(handles.index)]);
        handles.name = varargin{i+1};
    case 'number_matslise'
        handles.number_matslise = varargin{i+1};
    case 'halfrangereduction'
        handles.halfrange_reduction = varargin{i+1};
end
i = i+ 2;
end
movegui(handles.param_eigenvector_plot,'center');
set([handles.plot_button,handles.close_button,handles.movie_button],'Enable','off');
points = 70 + (floor(handles.index/5)+1)*30;
points=min(points,2000);
set(handles.points_edit,'String',points);
handles.min = get(get(handles.cpm(1),'schrod'),'min');
handles.max = get(get(handles.cpm(1),'schrod'),'max');
for i = 2:length(handles.cpm)
    m=get(get(handles.cpm(i),'schrod'),'min');
    if m < handles.min
        handles.min = m;
    end
    m=get(get(handles.cpm(i),'schrod'),'max');
    if m > handles.max
        handles.max = m;
    end
end
if handles.halfrange_reduction
    handles.min = -handles.max;
end
set(handles.a_edit,'String',handles.min);
set(handles.b_edit,'String',handles.max);
set(handles.info_edit,'String','Busy...');
drawnow;
axes(handles.eigenvector);
if ~isfield(handles,'MarkersOn')
    handles.MarkersOn = false;
end
guidata(hObject, handles);
markers = {'o','*','+','v','x','p','s','d','>','<','h','^','.'};
colors = length(handles.parameterValues);
colormap = jet(colors);
%colormap = gray(colors+2);
colormap=remove_yellow(colormap);
pn = char(handles.parameterName);
if length(handles.parameterValues)<20
  legendStr = cell(length(handles.cpm),1);
else
  legendStr = cell(2,1);
end
try
    if handles.halfrange_reduction
      if mod(handles.index,2) == 0
          V = get_eigenfunction(handles.cpm(1,1),handles.eigenvalues(1),ceil(points/2));
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) V.yprime]./sqrt(2);
      else
          V = get_eigenfunction(handles.cpm(1,2),handles.eigenvalues(1),ceil(points/2));
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) -V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) -V.yprime]./sqrt(2); 
      end
      handles.current_eigenvector(1) = V;
    else 
       handles.current_eigenvector(1) = get_eigenfunction(handles.cpm(1),handles.eigenvalues(1),points);
    end
catch
     errordlg(lasterr,'Error','modal');
end
if(test_eigenfunction(handles.index,handles.current_eigenvector(1)))
    incorrect=handles.parameterValues(1);
else
    incorrect=[];
end
if handles.MarkersOn
        phandles = plot(handles.current_eigenvector(1).x,handles.current_eigenvector(1).y,'Color',colormap(1,:),...
        'Marker',markers{2},'MarkerSize',5);
else
        phandles = plot(handles.current_eigenvector(1).x,handles.current_eigenvector(1).y,'Color',colormap(1,:));
end
s = sprintf('Eigenfunction associated with eigenvalue %d ',handles.index);
ahandle = gca;
set(get(ahandle,'XLabel'),'String','x','FontSize',10);
set(get(ahandle,'YLabel'),'String','y','FontSize',10);
set(get(ahandle,'YLabel'),'Rotation',0.0);
p=get(get(ahandle,'YLabel'),'Position');
ticks = (max(max(handles.current_eigenvector(1).x))-min(min(handles.current_eigenvector(1).x)))/100;
set(get(ahandle,'YLabel'),'Position',[p(1)-1.5*ticks p(2) p(3)]);
set(get(ahandle,'Title'),'String',s,'FontSize',10);
legendStr{1}=[pn ' = ' num2str(handles.parameterValues(1))];
drawnow
hold on
axis tight
if length(handles.parameterValues)>19
  phandles = plot(handles.current_eigenvector(1).x(1),handles.current_eigenvector(1).y(1),'Color',colormap(end,:));
end
for i=2:length(handles.parameterValues)
 try
     if handles.halfrange_reduction
        if mod(handles.index,2) == 0
          V = get_eigenfunction(handles.cpm(i,1),handles.eigenvalues(i),ceil(points/2));
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) V.yprime]./sqrt(2);
        else
          V = get_eigenfunction(handles.cpm(i,2),handles.eigenvalues(i),ceil(points/2));
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) -V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) -V.yprime]./sqrt(2); 
        end
        handles.current_eigenvector(i) = V;
      else 
         handles.current_eigenvector(i) = get_eigenfunction(handles.cpm(i),handles.eigenvalues(i),points);
     end
 catch
     errordlg(lasterr,'Error','modal');
 end
 if(test_eigenfunction(handles.index,handles.current_eigenvector(i)))
    incorrect=[incorrect handles.parameterValues(i)];
 end
 if handles.MarkersOn
        phandles = plot(handles.current_eigenvector(i).x,handles.current_eigenvector(i).y,'Color',colormap(i,:),...
        'Marker',markers{mod(i,13)+1},'MarkerSize',5);
 else
        phandles = plot(handles.current_eigenvector(i).x,handles.current_eigenvector(i).y,'Color',colormap(i,:));
 end
 axis tight;
 drawnow
 if length(handles.parameterValues) <20
   legendStr{i}=[pn ' = ' num2str(handles.parameterValues(i))];
 end
end
if length(handles.parameterValues) >19
  legendStr{2}=[pn ' = ' num2str(handles.parameterValues(end))];
end
leg=legend(legendStr{:},'Location','Best');
set(leg,'FontSize',8)
hold off;
axis tight
set([handles.plot_button,handles.close_button,handles.movie_button],'Enable','on');
if isempty(incorrect)
   set(handles.info_edit,'String','Ready');
else
   set(handles.info_edit,'BackgroundColor',[1 0 0]); %red
   set(handles.info_edit,'String',['Eigenfunction(s) not correct for ' handles.parameterName ' = ' num2str(incorrect)]);
end
% Choose default command line output for param_eigenvector_plot
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = param_eigenvector_plot_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%------------------------------------------------------------------
%---------------------------Create functions-----------------------
%------------------------------------------------------------------

function a_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function points_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function b_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function info_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


%------------------------------------------------------------------
%---------------------------Callback functions-----------------------
%------------------------------------------------------------------

% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
delete(handles.param_eigenvector_plot)


% --- Executes on button press in plot_button.
function plot_button_Callback(hObject, eventdata, handles)
set([handles.plot_button,handles.close_button,handles.movie_button],'Enable','off');
set(handles.info_edit,'BackgroundColor',[1 1 1]);
a = str2double(get(handles.a_edit,'String'));
b = str2double(get(handles.b_edit,'String'));
if isnan(a) || isnan(b)
    errordlg('You must enter a numeric value','Bad Input','modal')
elseif (a < handles.min && abs(a - handles.min) > 0.0001) || (b > handles.max && abs(b - handles.max) > 0.0001)
       errordlg(sprintf('The X-interval must be a subinterval of the interval [%d , %f]',handles.min,handles.max),...
           'Bad Input','modal');
else
    set(handles.info_edit,'String','Busy...');
    drawnow
    if abs(b - handles.max) <= 0.0001
        b = handles.max;
    end
    if abs(a - handles.min) <= 0.0001
        a = handles.min;
    end
    p = str2double(get(handles.points_edit,'String'));
    if isnan(p)
        errordlg('Number of points must be a numeric value','Bad Input','modal')
    else
        handles=plot_calc_eigenvectors(handles,a,b,p);
    end
    set(handles.info_edit,'String','Ready');
end
set([handles.plot_button,handles.close_button,handles.movie_button],'Enable','on');
guidata(hObject, handles);

% --------------------------------------------------------------------
function OpenNewItem_Callback(hObject, eventdata, handles)
set(handles.info_edit,'String','Busy...');
drawnow;
fhandle = figure('NumberTitle','off','Name',['Eigenfunctions plot: eigenfunction ', num2str(handles.index)]);
ahandle = axes('Parent',fhandle);
plot_eigenvectors(handles,ahandle);
set(fhandle,'HandleVisibility','off');
set(fhandle,'IntegerHandle','off');
set(handles.info_edit,'String','Ready');
guidata(hObject,handles);

% --------------------------------------------------------------------
function saveItem_Callback(hObject, eventdata, handles)
set(handles.info_edit,'String','Busy...');
drawnow;
fhandle = figure('NumberTitle','off','Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_eigenvectors(handles,ahandle);
[fileName,path,filterindex] = uiputfile({'*.fig','MATLAB figures (*.fig)';...
        '*.jpg','JPEG images (*.jpg)';'*.eps','EPS files (*.eps)';...
        '*.eps','EPS Color files (*.eps)';'*.eps','EPS Level 2 files (*.eps)'
        '*.eps','EPS Level 2 Color files (*.eps)';...
        '*.ai','Adobe Illustrator files (*.ai)';...
        '*.bmp','bitmap files (*.bmp)';'*.tif','TIFF images (*.tif)';...
        '*.tif','TIFF no compression images (*.tif)';...
        '*.emf','Enhanced Metafiles (*.emf)';'*.pbm','Portable bitmap files (*.pbm)';...
        '*.png','Portable Network Graphics files (*.png)'},...
    'Save plot as');
if strcmp(fileName,'0') || strcmp(path,'0') || filterindex == 0
    return;
end
file=fullfile(path,fileName);
filters ={'fig','jpg','eps','epsc','eps2','epsc2','ai','bmp','tif','tiffn','emf','pbm','png'};
s=char(filters(filterindex));
%set(fhandle,'HandleVisibility','off');
%set(fhandle,'IntegerHandle','off');
saveas(fhandle,file,s);
set(handles.info_edit,'String','Ready');

% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.param_eigenvector_plot)

% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.param_eigenvector_plot)

% --------------------------------------------------------------------
function MarkerType_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'Checked'),'on')
    set(hObject,'Checked','off');
    handles.MarkersOn = false;
else
    set(hObject,'Checked','on');
    handles.MarkersOn = true;
end
guidata(hObject,handles);
plot_eigenvectors(handles,gca);

% --------------------------------------------------------------------
function CopyItem_Callback(hObject, eventdata, handles)
set(handles.info_edit,'String','Busy...');
drawnow;
fhandle = figure('NumberTitle','off','Name',['Eigenvectors plot: eigenvector ', num2str(handles.index)]);
set(fhandle,'Position',[-100,-100,30,25]);
ahandle = axes('Parent',fhandle);
plot_eigenvectors(handles,ahandle);
set(handles.info_edit,'String','Ready');
print -dmeta; 
delete(fhandle);

% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
HelpPath = which('param_eigenvector_plot.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','eigenfunctions_param.html');
web(HelpPath);

% --------------------------------------------------------------------
function AboutItem_Callback(hObject, eventdata, handles)
HelpPath = which('param_eigenvector_plot.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'/helpfiles/matslise.html');
web(HelpPath);

%--------------------------------------------------------------------
function handles=plot_calc_eigenvectors(handles,a,b,p,varargin)
if length(varargin)== 0
    axes(handles.eigenvector);
    ahandle = gca;
else
    ahandle = varargin{1};
end
set(handles.info_edit,'String','Busy...');
drawnow;
colors = length(handles.parameterValues);
colormap = jet(colors);
%colormap = gray(colors+2);
colormap=remove_yellow(colormap);
markers = {'o','*','+','v','x','p','s','d','>','<','h','^','.'};
line = {'-',':','--','-.'};
pn = char(handles.parameterName);
if colors < 20
   legendStr = cell(length(handles.cpm),1);
else
   legendStr = cell(2,1); 
end
try
    if handles.halfrange_reduction
        if a ~= -b
             error('You selected halfrange reduction for this problem: please take a symmetric interval [-b,b].')
        end
        if mod(handles.index,2) == 0
          V = get_eigenfunction(handles.cpm(1,1),handles.eigenvalues(1),ceil(p/2));
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) V.yprime]./sqrt(2);
        else
          V = get_eigenfunction(handles.cpm(1,2),handles.eigenvalues(1),ceil(p/2));
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) -V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) -V.yprime]./sqrt(2); 
        end
        handles.current_eigenvector(1) = V;
    else 
        handles.current_eigenvector(1) = get_eigenfunction(handles.cpm(1),handles.eigenvalues(1),a,b,p);
    end
catch
     errordlg(lasterr,'Error','modal');
     return;
end
if handles.MarkersOn
        phandles = plot(handles.current_eigenvector(1).x,handles.current_eigenvector(1).y,'Color',colormap(1,:),...
        'Marker',markers{2},'MarkerSize',5);
else
        phandles = plot(handles.current_eigenvector(1).x,handles.current_eigenvector(1).y,'Color',colormap(1,:));
end
s = sprintf('Eigenvector associated with eigenvalue %d ',handles.index);
set(get(ahandle,'XLabel'),'String','x','FontSize',10);
set(get(ahandle,'YLabel'),'String','y','FontSize',10);
set(get(ahandle,'YLabel'),'Rotation',0.0);
set(get(ahandle,'Title'),'String',s,'FontSize',10);
legendStr{1}=[pn ' = ' num2str(handles.parameterValues(1))];
drawnow
hold on
axis tight
if colors >19
   phandles = plot(handles.current_eigenvector(1).x(1),handles.current_eigenvector(1).y(1),'Color',colormap(end,:)); 
end
for i=2:length(handles.parameterValues)
 try
     if handles.halfrange_reduction
       if mod(handles.index,2) == 0
          V = get_eigenfunction(handles.cpm(i,1),handles.eigenvalues(i),ceil(p/2));
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) V.yprime]./sqrt(2);
        else
          V = get_eigenfunction(handles.cpm(i,2),handles.eigenvalues(i),ceil(p/2));
          V.x = [-(V.x(length(V.x):-1:2)) V.x];
          V.y = [V.y(length(V.y):-1:2) -V.y]./sqrt(2);
          V.yprime = [V.yprime(length(V.yprime):-1:2) -V.yprime]./sqrt(2); 
        end
        handles.current_eigenvector(i) = V;
     else 
        handles.current_eigenvector(i) = get_eigenfunction(handles.cpm(i),handles.eigenvalues(i),a,b,p);
     end
 catch
     errordlg(lasterr,'Error','modal');
 end
 if handles.MarkersOn
        phandles = plot(handles.current_eigenvector(i).x,handles.current_eigenvector(i).y,'Color',colormap(i,:),...
        'Marker',markers{mod(i,13)+1},'MarkerSize',5);
 else
        phandles = plot(handles.current_eigenvector(i).x,handles.current_eigenvector(i).y,'Color',colormap(i,:));
 end
 axis tight;
 drawnow
 if colors < 20
   legendStr{i}=[pn ' = ' num2str(handles.parameterValues(i))];
 end
end
if colors >19
  legendStr{2}=[pn ' = ' num2str(handles.parameterValues(end))];  
end
leg=legend(legendStr{:},'Location','Best');
set(leg,'FontSize',8)
hold off;
axis tight
set(handles.info_edit,'String','Ready');

%--------------------------------------------------------------------
function mutual_exclusive(off)
set(off,'Checked','Off');

%--------------------------------------------------------------------
function phandles=plot_eigenvectors(handles,ahandle)
set(handles.info_edit,'String','Busy...');
drawnow;
colors = length(handles.parameterValues);
colormap = jet(colors);
colormap=remove_yellow(colormap);
markers = {'o','*','+','v','x','p','s','d','>','<','h','^','.'};
pn = char(handles.parameterName);
legendStr = cell(length(handles.cpm),1);
if handles.MarkersOn
        phandles = plot(handles.current_eigenvector(1).x,handles.current_eigenvector(1).y,'Color',colormap(1,:),...
        'Marker',markers{2},'MarkerSize',5,'Parent',ahandle);
else
        phandles = plot(handles.current_eigenvector(1).x,handles.current_eigenvector(1).y,'Color',colormap(1,:),...
        'Parent',ahandle);
end
s = sprintf('Eigenfunction associated with eigenvalue %d ',handles.index);
set(get(ahandle,'XLabel'),'String','x','FontSize',10);
set(get(ahandle,'YLabel'),'String','y','FontSize',10);
set(get(ahandle,'YLabel'),'Rotation',0.0);
set(get(ahandle,'Title'),'String',s,'FontSize',10);
legendStr{1}=[pn ' = ' num2str(handles.parameterValues(1))];
axis tight;
drawnow
hold on
for i=2:length(handles.cpm)
if handles.MarkersOn
        phandles = plot(handles.current_eigenvector(i).x,handles.current_eigenvector(i).y,'Color',colormap(i,:),...
        'Marker',markers{mod(i,13)+1},'MarkerSize',5,'Parent',ahandle);
else
        phandles = plot(handles.current_eigenvector(i).x,handles.current_eigenvector(i).y,'Color',colormap(i,:),...
        'Parent',ahandle);
end
axis tight
hold on
drawnow
legendStr{i}=[pn ' = ' num2str(handles.parameterValues(i))];
end
legend(legendStr{:},'Location','Best');
hold off;
axis tight
set(handles.info_edit,'String','Ready');


% --- Executes on button press in movie_button.
function movie_button_Callback(hObject, eventdata, handles)
global gapp
set(handles.info_edit,'String','Busy...');
drawnow
if isfield(gapp,'movie') && length(gapp.movie)>=(handles.number_matslise) &&ishandle(gapp.movie(handles.number_matslise))
    try
       delete(gapp.movie(handles.number_matslise));
    catch
    end
end
gapp.movie(handles.number_matslise)=param_movie('Data',handles.current_eigenvector,'parameterName',handles.parameterName,...
    'parameterValues',handles.parameterValues,'Eigenvalues',handles.eigenvalues,...
    'Index',handles.index,'CPM',handles.cpm,'Name',handles.name,'halfrangereduction',handles.halfrange_reduction);
set(handles.info_edit,'String','Ready');
guidata(hObject,handles);

%---------------------------------------------------------------
function incorrect=test_eigenfunction(index,V)
% test if number of nodes == index
incorrect = false;
y = [V.y 0];
z = [0 V.y];
w = y.*z;
hlp=length(find(w(3:length(w)-2)<0));
if index < hlp
         incorrect = true;    
elseif index > hlp
         hlp2=y(2:length(y)-2);
         nodes = length(find(w(3:length(w)-2)<0));
         tmp=find(hlp2==0);
         if length(tmp)==0
             return;
         end
         if tmp(1)==1
             tmp=tmp(2:length(tmp));
         end
         if tmp(end)==length(hlp2)
             tmp=tmp(1:length(tmp)-1);
         end
         for j=1:length(tmp)
             if hlp2(tmp(j)-1)*hlp2(tmp(j)+1) < 0
                 nodes=nodes+1;
             end
         end
         if nodes ~= index
             incorrect = true; 
         end
    end
