function varargout = param_eigenvector_results(varargin)
% PARAM_EIGENVECTOR_RESULTS M-file for param_eigenvector_results.fig

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @param_eigenvector_results_OpeningFcn, ...
                   'gui_OutputFcn',  @param_eigenvector_results_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before param_eigenvector_results is made visible.
function param_eigenvector_results_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to param_eigenvector_results (see VARARGIN)
set(handles.results_box,'String','');
set(handles.results_box,'Value',1);
i = 1;
handles.halfrange_reduction = false;
while i < length(varargin)
switch varargin{i}
    case 'Eigenvalues'
        handles.eigenvalues = varargin{i+1};
    case 'Indices'
        handles.indices = varargin{i+1};  
    case 'CPM'
        handles.cpm = varargin{i+1};
    case 'parameterName'
        handles.parameterName = varargin{i+1};
    case 'parameterValues'
        handles.parameterValues = varargin{i+1};
    case 'Name'
        set(hObject,'Name',[varargin{i+1} ': eigenfunctions']);
        handles.name = varargin{i+1};
    case 'number_matslise'
        handles.number_matslise = varargin{i+1};
    case 'halfrangereduction'
        handles.halfrange_reduction = varargin{i+1};
end
i = i+ 2;
end
resultsStr = {['Eigenfunction',num2str(handles.indices(1))]};
for i=2:length(handles.indices)
    resultsStr = [resultsStr;{['Eigenfunction',num2str(handles.indices(i))]}] ;
end
set(handles.results_box,'String',resultsStr);
% Choose default command line output for param_eigenvector_results
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes param_eigenvector_results wait for user response (see UIRESUME)
% uiwait(handles.param_eigenvectors);


% --- Outputs from this function are returned to the command line.
function varargout = param_eigenvector_results_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function results_box_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
global gapp
if isfield(gapp,'eigenvector_plot') && ishandle(gapp.eigenvector_plot)
    close(gapp.eigenvector_plot);
end
rmfield(gapp,'eigenvector_window');
delete(handles.param_eigenvectors)


% --- Executes during object creation, after setting all properties.
function info_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on button press in help_button.
function help_button_Callback(hObject, eventdata, handles)
HelpPath = which('param_eigenvector_results.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','eigenfunctions_param.html');
web(HelpPath);

% --- Executes on button press in plotp_button.
function plotp_button_Callback(hObject, eventdata, handles)
global gapp
set(handles.info_edit,'String','Busy...');
drawnow
currentVals = get(handles.results_box,'Value');
if length(currentVals) > 1
    errordlg('Only one eigenfunction should be selected','Error','modal')
    return
end
if isfield(gapp,'eigenvector_plotp') && length(gapp.eigenvector_plotp)>=(handles.number_matslise) && ishandle(gapp.eigenvector_plotp(handles.number_matslise))
    try
    delete(gapp.eigenvector_plotp(handles.number_matslise));
    catch
    end
end
gapp.eigenvector_plotp(handles.number_matslise) = param_eigenvector_plot('CPM',handles.cpm,'parameterName',handles.parameterName,...
    'parameterValues',handles.parameterValues,'Eigenvalues',handles.eigenvalues(currentVals,:),...
    'Index',handles.indices(currentVals),'Name',handles.name,'number_matslise',handles.number_matslise,'halfrangereduction',handles.halfrange_reduction);
movegui(gapp.eigenvector_plotp(handles.number_matslise),'center');
set(handles.info_edit,'String','Ready');
guidata(hObject,handles);

