function varargout = param_movie(varargin)
% PARAM_MOVIE M-file for param_movie.fig

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @param_movie_OpeningFcn, ...
                   'gui_OutputFcn',  @param_movie_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before param_movie is made visible.
function param_movie_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to param_movie (see VARARGIN)
i = 1;
handles.halfrange_reduction = false;
while i < length(varargin)
switch varargin{i}
    case 'Data'
        handles.data = varargin{i+1};
    case 'Eigenvalues'
        handles.eigenvalues = varargin{i+1}; 
    case 'Index'
        handles.index = varargin{i+1};  
    case 'CPM'
        handles.cpm = varargin{i+1};
    case 'parameterName'
        handles.parameterName = varargin{i+1};
    case 'parameterValues'
        handles.parameterValues = varargin{i+1};
    case 'Name'
        set(hObject,'Name',[varargin{i+1} ': eigenfunction ' num2str(handles.index) ' - movie']);
        handles.name = varargin{i+1};
    case 'halfrangereduction'
        handles.halfrange_reduction = varargin{i+1};
end
i = i+ 2;
end
set(handles.play_button,'Enable','off');
% Choose default command line output for param_movie
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = param_movie_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function info_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function info_edit_Callback(hObject, eventdata, handles)


% --- Executes on button press in make_button.
function make_button_Callback(hObject, eventdata, handles)
set([handles.make_button,handles.play_button,handles.Close_button,handles.help_button,handles.slider],...
    'Enable','off');
set(handles.info_edit,'String','Busy...');
drawnow
axes(handles.eigenvector_axes);
V = handles.data(1);
V0 = V;
h = plot(V.x,V.y);
ymax1 = max(V.y);
ymin1 = min(V.y);
V = handles.data(end);
ymax2 = max(V.y);
ymin2 = min(V.y);
ymax = max(ymax1,ymax2);
ymin = min(ymin1,ymin2);
xmin = [];
xmax = [];
if handles.halfrange_reduction
    for i=1:length(handles.cpm)
      xmax = [xmax get(get(handles.cpm(i),'schrod'),'max')];
    end
    xmin=-xmax;
else
    for i=1:length(handles.cpm)
      xmin = [xmin get(get(handles.cpm(i),'schrod'),'min')];
      xmax = [xmax get(get(handles.cpm(i),'schrod'),'max')];
    end
end
xmin = min(xmin);
xmax = max(xmax);
if isa(get(handles.cpm(1),'schrod'),'transformed_slp')
    xmax=get(get(get(handles.cpm(1),'schrod'),'slp'),'max');
    xmax = max(get(get(get(handles.cpm(end),'schrod'),'slp'),'max'),xmax);
    xmin=get(get(get(handles.cpm(1),'schrod'),'slp'),'min');
    xmin = min(get(get(get(handles.cpm(end),'schrod'),'slp'),'min'),xmin);
end
y = 3*(ymin+ymax)/4;
x = (xmin+xmax)/2;
axis([xmin xmax ymin ymax]);
pn = handles.parameterName;
for i=1:length(handles.cpm)
  set(handles.info_edit,'String',[char(pn) ' = ' num2str(handles.parameterValues(i))]);
  drawnow
  V = handles.data(i);
  step = V.x(2)-V.x(1);
  xx = V.x(1):step/5:V.x(end);
  yy = spline(V.x,V.y,xx);
  pv = handles.parameterValues(i);
  set(h,'XData',xx,'YData',yy);
  ha=text(x,y,['parameter value = ' num2str(pv)]);
  axis([xmin xmax ymin ymax]);
  handles.M(i)=getframe;
  delete(ha);
end
step = V0.x(2)-V0.x(1);
xx = V0.x(1):step/5:V0.x(end);
yy = spline(V0.x,V0.y,xx);
set(h,'XData',xx,'YData',yy);
%axis equal
axis tight
drawnow
set([handles.make_button,handles.play_button,handles.Close_button,handles.help_button,handles.slider],'Enable','on');
set(handles.info_edit,'String','Ready');
guidata(hObject,handles);

% --- Executes on button press in play_button.
function play_button_Callback(hObject, eventdata, handles)
% hObject    handle to play_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set([handles.make_button,handles.play_button,handles.Close_button,handles.help_button,handles.slider],'Enable','off');
pn = handles.parameterName;
pv1 = handles.parameterValues(1);
pv2 = handles.parameterValues(end);
fps = ceil(get(handles.slider,'Value'));
set(handles.info_edit,'String',[char(pn) ' = ' num2str(pv1) ' --> ' num2str(pv2)]);
drawnow
axes(handles.eigenvector_axes);
movie(handles.M,1,fps);
set(handles.info_edit,'String','Ready');
set([handles.make_button,handles.play_button,handles.Close_button,handles.help_button,handles.slider],...
    'Enable','on');
guidata(hObject,handles);


% --- Executes on button press in help_button.
function help_button_Callback(hObject, eventdata, handles)
% hObject    handle to help_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hlpwin=msgbox(['The "Make"-button constructs the movie: Several plots are generated: the eigenfunction '...
'is plotted for each value of the parameter. These plots are played back (one after the other) '...
'when the "Play"-button is pushed.'],'Help Movie window'); 

% --- Executes on button press in Close_button.
function Close_button_Callback(hObject, eventdata, handles)
% hObject    handle to Close_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
delete(handles.param_movie);


% --- Executes during object creation, after setting all properties.
function slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background, change
%       'usewhitebg' to 0 to use default.  See ISPC and COMPUTER.
usewhitebg = 1;
if usewhitebg
    set(hObject,'BackgroundColor',[.9 .9 .9]);
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on slider movement.
function slider_Callback(hObject, eventdata, handles)
% hObject    handle to slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


