function varargout = partition_plot_window(varargin)
% PARTITION_PLOT_WINDOW M-file for partition_plot_window.fig

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help partition_plot_window

% Last Modified by GUIDE v2.5 08-Dec-2004 16:49:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @partition_plot_window_OpeningFcn, ...
                   'gui_OutputFcn',  @partition_plot_window_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before partition_plot_window is made visible.
function partition_plot_window_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to partition_plot_window (see VARARGIN)
i=1;
handles.slp=false;
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
         case 'V'
               handles.V = varargin{i+1};
         case 'a'
               handles.a = varargin{i+1};
         case 'b'
               handles.b = varargin{i+1}; 
         case 'Name'
               handles.name = varargin{i+1};
               set(handles.partition_plot_window,'Name',[handles.name ': Partition plot']);
         case 'number_matslise' %to keep track which instance of Matslise 
               handles.number_matslise=varargin{i+1};
         case 'x_bp'
               handles.x_bp = varargin{i+1};
         case 'slp'
               handles.slp = varargin{i+1};
         case 'schrod'
               handles.schrod = varargin{i+1};
         case 'Vbar'
               handles.Vbar = varargin{i+1};     
         case 'imatch'
               handles.imatch = varargin{i+1}; 
     end
     i = i+2;
    end
end
ahandle = handles.partition_plot_axes;
a=handles.a;
b=handles.b;
V=inline(handles.V);
step = min(abs(b-a)/100,0.05);
while (b-a)/step>8000
    step=step*2;
end
w = a:step:b;
Y = [];
if handles.slp
    for i = 1:length(w)
      r = x2r(handles.schrod,w(i));    %= sturm-liouville r
      Y = [Y V(r)];
   end
else
  for i = 1:length(w)
        Y = [Y V(w(i))];
  end
end
YY=Y;
handles.x = w;
handles.y = Y;
x = handles.x_bp;
%y=[];
% if handles.slp
%  for i = 1:length(x)
%       r = x2r(handles.schrod,x(i));    %= sturm-liouville r
%       y = [y V(r)];
%  end
% else
%   for i = 1 :length(x)
%     y=[y V(x(i))];
%   end
% end
my=min(YY);
handles.y_bp = my;
legendStr{1} = 'meshpoints';
phandles= plot(x,my*ones(1,length(x)),'bo','MarkerSize',5,'MarkerFaceColor','b','Parent',ahandle);
hold on;
legendStr{2} = 'x_{match}';
phandles = [phandles plot(x(handles.imatch+1),my,'rs','MarkerSize',5,'MarkerFaceColor','r','Parent',ahandle)];
phandles = [phandles plot(w,YY,'k:','Parent',ahandle)];
legendStr{3} = 'V(x)';
legendStr{4} = 'V_0';
cvbar=[];
cx=[];
for i=1:length(handles.Vbar)
 %  phandles= [phandles plot([x(i) x(i+1)],[handles.Vbar(i) handles.Vbar(i)],'g','Parent',ahandle)];
   cx=[cx x(i) x(i+1)];
   cvbar=[ cvbar handles.Vbar(i) handles.Vbar(i)];
end
phandles= [phandles plot(cx,cvbar,'b','Parent',ahandle)];
hold off;
legend(phandles(1:end),legendStr,'Location','Best');
set(get(ahandle,'XLabel'),'String','x','FontSize',12);
if handles.slp
    set(get(ahandle,'Title'),'String','The reference potential function of the associated Schrodinger problem');
else
  set(get(ahandle,'Title'),'String','The reference potential function + the meshpoints of the partition');
end
axis(ahandle,'tight') 

% Choose default command line output for partition_plot_window
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes partition_plot_window wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = partition_plot_window_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function OpenItem_Callback(hObject, eventdata, handles)
%open plot in new window
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_partition(handles,ahandle);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');


% --------------------------------------------------------------------
function SaveAsItem_Callback(hObject, eventdata, handles)
[fileName,path,filterindex] = uiputfile({'*.fig','MATLAB figures (*.fig)';...
        '*.jpg','JPEG images (*.jpg)';'*.eps','EPS files (*.eps)';...
        '*.eps','EPS Color files (*.eps)';'*.eps','EPS Level 2 files (*.eps)'
        '*.eps','EPS Level 2 Color files (*.eps)';...
        '*.ai','Adobe Illustrator files (*.ai)';...
        '*.bmp','bitmap files (*.bmp)';'*.tif','TIFF images (*.tif)';...
        '*.tif','TIFF no compression images (*.tif)';...
        '*.emf','Enhanced Metafiles (*.emf)';'*.pbm','Portable bitmap files (*.pbm)';...
        '*.png','Portable Network Graphics files (*.png)'},...
    'Save plot as');
if strcmp(fileName,'0') || strcmp(path,'0') || filterindex == 0
    return;
end
file=fullfile(path,fileName);
filters ={'fig','jpg','eps','epsc','eps2','epsc2','ai','bmp','tif','tiffn','emf','pbm','png'};
s=char(filters(filterindex));
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles=plot_partition(handles,ahandle)
saveas(fhandle,file,s);



% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.partition_plot_window)


% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.partition_plot_window)

%---------------------------------------------------------------------
function phandles=plot_partition(handles,ahandle)
legendStr{1} = 'meshpoints';
phandles= plot(handles.x_bp,handles.y_bp*ones(1,length(handles.x_bp)),'bo','MarkerSize',5,'MarkerFaceColor','b','Parent',ahandle);
hold on;
legendStr{2} = 'x_{match}';
phandles= [phandles plot(handles.x_bp(handles.imatch+1),handles.y_bp,'rs','MarkerSize',5,'MarkerFaceColor','r','Parent',ahandle)];
phandles= [phandles plot(handles.x,handles.y,'k:','Parent',ahandle)];
legendStr{3} = 'V(x)';
legendStr{4} = 'V_0';
cx=[];
cvbar=[];
for i=1:length(handles.Vbar)
   cx=[cx handles.x_bp(i) handles.x_bp(i+1)];
   cvbar=[cvbar handles.Vbar(i) handles.Vbar(i)];
    %phandles= [phandles plot([handles.x_bp(i) handles.x_bp(i+1)],[handles.Vbar(i) handles.Vbar(i)],'g','Parent',ahandle)];
end
phandles= [phandles plot(cx,cvbar,'b','Parent',ahandle)];
hold off;
legend(phandles(1:end),legendStr{:},'Location','Best');
set(get(ahandle,'XLabel'),'String','x');
if handles.slp
    set(get(ahandle,'Title'),'String','The reference potential function of the associated Schrodinger problem');
else
  set(get(ahandle,'Title'),'String','The reference potential function + the meshpoints of the partition');
end
axis(ahandle,'tight') 


% --------------------------------------------------------------------
function CopyItem_Callback(hObject, eventdata, handles)
% copy figure to clipboard
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
ahandle = axes('Parent',fhandle);
phandles = plot_partition(handles,ahandle);
set(fhandle,'Position',[-100 -100 30 25]);
set(fhandle,'Visible','on');
print -dmeta; 
delete(fhandle);


