function varargout = potential_plot_window(varargin)
% POTENTIAL_PLOT_WINDOW M-file for potential_plot_window.fig

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help potential_plot_window

% Last Modified by GUIDE v2.5 17-Aug-2005 13:58:03

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @potential_plot_window_OpeningFcn, ...
                   'gui_OutputFcn',  @potential_plot_window_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before potential_plot_window is made visible.
function potential_plot_window_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to potential_plot_window (see VARARGIN)
i=1;
handles.slp=false;
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
         case 'V'
               handles.V = varargin{i+1};
         case 'a'
               handles.a = varargin{i+1};
         case 'b'
               handles.b = varargin{i+1}; 
         case 'Name'
               handles.name = varargin{i+1};
               set(handles.potential_plot_window,'Name',[handles.name ': Potential function']);
         case 'slp'
             handles.slp = varargin{i+1};
         case 'schrod'
             handles.schrod = varargin{i+1};
         case 'parameterName'
             handles.parameterName = varargin{i+1};
         case 'parameterValues'
             handles.parameterValues = varargin{i+1};
         case 'Vparam'
             handles.Vparam = varargin{i+1};
         case 'noParamInAorB'
             handles.noParamInAorB = varargin{i+1};
     end
     i = i+2;
    end
end
ahandle = handles.potential_axes;
handles.Markers=false;
handles.lineType='-';
b=handles.b;
a=handles.a;
if length(b)==1
  v = vectorize(handles.V);
  if handles.slp
   set(handles.potential_edit,'String',regexprep(v, 'x', 'r')); 
  else
   set(handles.potential_edit,'String',v);
  end   
  v= [v '+0.*x'];
  V= inline(v);   
  if isinf(b)
        start=max(0,a);
        vmin=V(start);
        sums=0;
        b=start;
        h=0.1;
        it=0;
        while sums<35 && it<70
            it=it+1;
            h=h*1.01;
            b=b+h;
            vb=V(b);
            if vb >= vmin 
               sums=sums+sqrt(vb-vmin)*h;
            else
               sums=0;
               vmin=vb;
            end
         end 
  end
  if isinf(a)
        vmin=V(0);
        sums=0;
        a=0;
        h=0.1;
        it=0;
        while sums<35 && it<70
            it=it+1;
            h=h*1.01;
            a=a-h;
            va=V(a);
            if va >= vmin 
               sums=sums+sqrt(va-vmin)*h;
            else
               sums=0;
               vmin=va;
            end
         end 
  end   
 step = min(abs(b-a)/99,0.1);
 w = a:step:b;
 if handles.slp
  r = x2r(handles.schrod,w);   %Sturm-Liouville r
  Y = V(r);
 else
  Y = V(w);
 end
 phandles = plot(w,Y,'-b','Parent',ahandle);
 handles.x=w;
 handles.y=Y;
 Y0 = Y;
 if max(Y) == Y(1) && min(Y) ~= max(Y) && ~(a==-b && ~isinf(b))
        i = 1;
        while Y(1) == max(Y) && length(Y) > 1 
            Y = Y(2:end);
            i = i+1;
        end
        if length(Y) > 1
          ta = w(i)-(ceil(i/7):-1:1)*step;
          a=ta(1);
          if handles.slp
           ta = x2r(handles.schrod,ta);
          end
          Y = [V(ta) Y];
        else
           Y = Y0; 
        end
 end
 m1 = max(Y);
 m2 = min(Y);
 if m2 == m1
        m1 = m1 + 1;
        m2 = m2 - 1;
 end
 offs = abs(m1-m2)/15;
 try
      axis(ahandle,[a b m2-offs m1+offs]);
      set(handles.Y1_edit,'String',num2str(m2-offs));
      set(handles.Y2_edit,'String',num2str(m1+offs)); 
 catch
      axis(ahandle,[a b min(Y) max(Y)]);
      set(handles.Y1_edit,'String',num2str(min(Y)));
      set(handles.Y2_edit,'String',num2str(max(Y))); 
 end
 set(handles.a_edit,'String',a);
 set(handles.b_edit,'String',b);
 set(handles.points_edit,'String',length(w));
 set(get(ahandle,'XLabel'),'String','x','FontSize',12);
 legend(phandles(1:end),'V(x)','Location','Best');
 if handles.slp
   set(get(ahandle,'Title'),'String','The associated Schrodinger problem','FontSize',10);
 else
  set(get(ahandle,'Title'),'String','The potential function','FontSize',11)
 end
 handles.color='blue';
else
     colormp=jet(length(handles.parameterValues)); %jet
%     colormp=gray(length(handles.parameterValues)+2); 
      if length(b)>19
        colormp=[colormp(1,:); colormp(end,:); colormp(2:length(b)-1,:)];  
      end
     set(hObject,'DefaultAxesColorOrder',colormp);
     if handles.slp
     set(handles.potential_edit,'String',''); 
     set([handles.potential_edit,handles.pot_text],'Enable','off');
    else
     set(handles.potential_edit,'String',handles.Vparam);
    end 
    for i=1:length(b)
     ap=a(i);
     bp=b(i);
     Vp=handles.V{i};
     v= vectorize([Vp '+0.*x']) ;
     Vp= inline(v);   
     if isinf(ap) && isinf(bp)
        ap = -8;
        bp = 8;
     elseif isinf(bp)
         bp = ap+10;
     elseif isinf(ap)
         ap = bp-10;
     end         
      step = min(abs(bp-ap)/100,0.1);
      w = ap:step:bp;
      if handles.slp
         r = x2r(handles.schrod(i),w);  
         Y = Vp(r);
      else
         Y = Vp(w);
      end
      YY(:,i) = Y';
      XX(:,i) = w';
      h = num2str(handles.parameterValues(i));
      if length(b) <20
        legendStr{i} = [handles.parameterName ' = ' h];
      end
    end
   if length(b) >19
       legendStr{1} = [handles.parameterName ' = ' num2str(handles.parameterValues(1))];
       legendStr{2} = [handles.parameterName ' = ' num2str(handles.parameterValues(length(b)))];
       XX=[XX(:,1) XX(:,end) XX(:,2:length(b)-1)];
       YY=[YY(:,1) YY(:,end) YY(:,2:length(b)-1)];
   end
   phandles = plot(XX,YY,'Parent',ahandle);
   handles.x=XX;
   handles.y=YY;
   axis(ahandle,'tight');
   set(handles.a_edit,'String',min(ap));
   set(handles.b_edit,'String',max(bp));
   set(handles.Y1_edit,'String',min(min(YY)));
   set(handles.Y2_edit,'String',max(max(YY)));
   set(handles.points_edit,'String',length(w));
   set(get(ahandle,'XLabel'),'String','x','FontSize',12);
   if length(handles.b)>3 && length(handles.b)<20
      leg=legend(phandles(1:end),legendStr{:},'Location','BestOutside');
   else
      leg=legend(phandles(1:end),legendStr{:},'Location','Best');
   end
   set(leg,'FontSize',8);
   if handles.slp
     set(get(ahandle,'Title'),'String','The associated Schrodinger equation','FontSize',11);
   else
    set(get(ahandle,'Title'),'String','The potential function','FontSize',12)
   end
   set(handles.potential_edit,'Enable','inactive');
   if ~handles.noParamInAorB
      set(handles.a_edit,'Enable','inactive');
      set(handles.b_edit,'Enable','inactive');
   end
   set(handles.LineColorItem,'Enable','off');
end
set(handles.info_edit,'String','Ready');
% Choose default command line output for potential_plot_window
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes potential_plot_window wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = potential_plot_window_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function potential_edit_Callback(hObject, eventdata, handles)
% hObject    handle to potential_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of potential_edit as text
%        str2double(get(hObject,'String')) returns contents of potential_edit as a double


% --- Executes during object creation, after setting all properties.
function potential_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to potential_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function a_edit_Callback(hObject, eventdata, handles)
% hObject    handle to a_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of a_edit as text
%        str2double(get(hObject,'String')) returns contents of a_edit as a double


% --- Executes during object creation, after setting all properties.
function a_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to a_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function b_edit_Callback(hObject, eventdata, handles)
% hObject    handle to b_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of b_edit as text
%        str2double(get(hObject,'String')) returns contents of b_edit as a double


% --- Executes during object creation, after setting all properties.
function b_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to b_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function points_edit_Callback(hObject, eventdata, handles)
s=get(hObject,'String');

% --- Executes during object creation, after setting all properties.
function points_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to points_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end




% --- Executes on button press in plot_button.
function plot_button_Callback(hObject, eventdata, handles)
try
  handles=plot_potential(handles,handles.potential_axes);
  guidata(hObject, handles);
catch
    errordlg(lasterr);
    set(handles.info_edit,'String','');
    set([handles.plot_button],'Enable','on');
end


% --- Executes on button press in close_button.
function close_button_Callback(hObject, eventdata, handles)
delete(handles.potential_plot_window)




% --------------------------------------------------------------------
function OpenNewWindowItem_Callback(hObject, eventdata, handles)
%open plot in new window
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
if length(handles.b) > 3
       set(fhandle,'DefaultAxesColorOrder',jet(length(handles.b)));
else
       set(fhandle,'DefaultAxesColorOrder',hsv(length(handles.b)));
end
ahandle = axes('Parent',fhandle);
phandles = plot_potential2(handles,ahandle);
set(fhandle,'Visible','on');
set(fhandle,'HandleVisibility','off');

% --------------------------------------------------------------------
function SaveAsItem_Callback(hObject, eventdata, handles)
[fileName,path,filterindex] = uiputfile({'*.fig','MATLAB figures (*.fig)';...
        '*.jpg','JPEG images (*.jpg)';'*.eps','EPS files (*.eps)';...
        '*.eps','EPS Color files (*.eps)';'*.eps','EPS Level 2 files (*.eps)'
        '*.eps','EPS Level 2 Color files (*.eps)';...
        '*.ai','Adobe Illustrator files (*.ai)';...
        '*.bmp','bitmap files (*.bmp)';'*.tif','TIFF images (*.tif)';...
        '*.tif','TIFF no compression images (*.tif)';...
        '*.emf','Enhanced Metafiles (*.emf)';'*.pbm','Portable bitmap files (*.pbm)';...
        '*.png','Portable Network Graphics files (*.png)'},...
    'Save plot as');
if strcmp(fileName,'0') || strcmp(path,'0') || filterindex == 0
    return;
end
file=fullfile(path,fileName);
filters ={'fig','jpg','eps','epsc','eps2','epsc2','ai','bmp','tif','tiffn','emf','pbm','png'};
s=char(filters(filterindex));
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
if length(handles.b) > 3
       set(fhandle,'DefaultAxesColorOrder',jet(length(handles.b)));
else
       set(fhandle,'DefaultAxesColorOrder',hsv(length(handles.b)));
end
ahandle = axes('Parent',fhandle);
phandles=plot_potential2(handles,ahandle)
saveas(fhandle,file,s);


% --------------------------------------------------------------------
function PrintItem_Callback(hObject, eventdata, handles)
printdlg(handles.potential_plot_window)

% --------------------------------------------------------------------
function CloseItem_Callback(hObject, eventdata, handles)
delete(handles.potential_plot_window)

%-----------------------------------------
function handles=plot_potential(handles,ahandle)
set(handles.info_edit,'String','Busy...');
set([handles.plot_button],'Enable','off');
drawnow;
if length(handles.b)==1 
V=get(handles.potential_edit,'String');
a=str2num(get(handles.a_edit,'String'));
b=str2num(get(handles.b_edit,'String'));
y1=str2num(get(handles.Y1_edit,'String'));
y2=str2num(get(handles.Y2_edit,'String'));
points=str2double(get(handles.points_edit,'String'));
if points < 1
    error('Number of points must be a positive integer')
end
if ~isa(points,'double') || ~isa(a,'double') || ~isa(b,'double') || ~isa(y1,'double') || ~isa(y2,'double') ||...
    isempty(points) || isempty(a) || isempty(b) || isempty(y1) || isempty(y2)
  error('you should enter a double');
end
v= strrep([handles.V '+0.*x'],'^','.^') ;
v= strrep(v,'*','.*');
v= strrep(v,'/','./');
V= inline(strrep(v,'..','.'));   
if isinf(b)
        vmin=V(0);
        sums=0;
        b=0;
        h=0.1;
        while sums<35
            h=h*1.01;
            b=b+h;
            vb=V(b);
            if vb >= vmin 
               sums=sums+sqrt(vb-vmin)*h;
            else
               sums=0;
               vmin=vb;
            end
         end 
end
if isinf(a)
        vmin=V(0);
        sums=0;
        a=0;
        h=0.1;
        while sums<35
            h=h*1.01;
            a=a-h;
            va=V(a);
            if va >= vmin 
               sums=sums+sqrt(va-vmin)*h;
            else
               sums=0;
               vmin=va;
            end
         end 
end    
step = abs(b-a)/points;
w = a:step:b;
if handles.slp
 r = x2r(handles.schrod,w);
 Y = V(r);
else
 Y = V(w);
end
handles.x=w;
handles.y=Y;
if handles.Markers
   phandles = plot(w,Y,'.','LineStyle',handles.lineType,'Color',handles.color,'Parent',ahandle);
else
   phandles = plot(w,Y,'LineStyle',handles.lineType,'Color',handles.color,'Parent',ahandle);
end
axis(ahandle,'tight');
axis(ahandle,[a b y1 y2]);
set(get(ahandle,'XLabel'),'String','x','FontSize',12);
legend(phandles(1:end),'V(x)');
if handles.slp
   set(get(ahandle,'Title'),'String','The associated Schrodinger equation','FontSize',10);
else
  set(get(ahandle,'Title'),'String','The potential function','FontSize',12);
end
else
    b=handles.b;
    a=handles.a;
    y1=str2double(get(handles.Y1_edit,'String'));
    y2=str2double(get(handles.Y2_edit,'String'));
    if handles.noParamInAorB
       a=str2double(get(handles.a_edit,'String'))*ones(1,length(a));
       b=str2double(get(handles.b_edit,'String'))*ones(1,length(b)); 
    end
    for i=1:length(b)
     ap=a(i);
     bp=b(i);
     Vp=handles.V{i};
     points=str2double(get(handles.points_edit,'String'));
     if isinf(ap) && isinf(bp)
        ap = -8;
        bp = 8;
     elseif isinf(bp)
         bp = ap+10;
     elseif isinf(ap)
         ap = bp-10;
     end         
      step =abs(bp-ap)/points;
      Vp = inline(Vp);
      w = ap:step:bp;
      Y = [];
      if handles.slp
        for j =1:length(w)
          r = x2r(handles.schrod(i),w(j));
          Y = [Y Vp(r)];
        end
      else
        for j =1:length(w)
        Y = [Y Vp(w(j))];
        end
      end
      YY(:,i) = Y';
      XX(:,i) = w';
      h = num2str(handles.parameterValues(i));
      if length(b)<20
        legendStr{i} = [handles.parameterName ' = ' h];
      end
    end
   if length(b) >19
       legendStr{1} = [handles.parameterName ' = ' num2str(handles.parameterValues(1))];
       legendStr{2} = [handles.parameterName ' = ' num2str(handles.parameterValues(length(b)))];
       XX=[XX(:,1) XX(:,end) XX(:,2:length(b)-1)];
       YY=[YY(:,1) YY(:,end) YY(:,2:length(b)-1)];
   end
   phandles = plot(XX,YY,'Parent',ahandle);
   handles.x=XX;
   handles.y=YY;
   axis(ahandle,'tight');
   axis(ahandle,[min(min(XX)) max(max(XX)) y1 y2]);
   set(get(ahandle,'XLabel'),'String','x','FontSize',12);
   set(ahandle,'Position',[14 13.385 86 23.923]);
   if length(handles.b)>3 && length(handles.b)<20
      leg=legend(phandles(1:end),legendStr{:},'Location','BestOutside');
   else
      leg=legend(phandles(1:end),legendStr{:},'Location','Best');
   end
   set(leg,'FontSize',8);
   if handles.slp
     set(get(ahandle,'Title'),'String','The associated Schrodinger equation','FontSize',11);
   else
    set(get(ahandle,'Title'),'String','The potential function','FontSize',12)
   end
end
set(handles.info_edit,'String','Ready');
set([handles.plot_button],'Enable','on');

%-----------------------------------------
function phandles=plot_potential2(handles,ahandle)
set(handles.info_edit,'String','Busy...');
set([handles.plot_button],'Enable','off');
drawnow;
if handles.Markers
    if length(handles.b)>1
     colormp=jet(length(handles.parameterValues));
     if length(handles.parameterValues)>19
       colormp=[colormp(1,:); colormp(end,:); colormp(2:length(handles.b)-1,:)];  
     end
     set(ahandle,'ColorOrder',colormp);
     phandles =plot(handles.x(:,1),handles.y(:,1),'.','LineStyle',handles.lineType,'Color',colormp(1,:),'Parent',ahandle);
     hold on;
     for j=2:length(handles.b)
       phandles =[phandles; plot(handles.x(:,j),handles.y(:,j),'.','LineStyle',handles.lineType,'Color',colormp(j,:),'Parent',ahandle)];
     end
     hold off;
    else
     phandles = plot(handles.x,handles.y,'.','LineStyle',handles.lineType,'Color',handles.color,'Parent',ahandle);
    end
else
   if length(handles.b)>1
     colormp=jet(length(handles.parameterValues));
     if length(handles.b)>19
       colormp=[colormp(1,:); colormp(end,:); colormp(2:length(handles.b)-1,:)];  
     end
     set(ahandle,'ColorOrder',colormp);
     phandles = [plot(handles.x(:,1),handles.y(:,1),'LineStyle',handles.lineType,'Color',colormp(1,:),'Parent',ahandle)];
     hold on;
     for j=2:length(handles.b)
       phandles = [phandles; plot(handles.x(:,j),handles.y(:,j),'LineStyle',handles.lineType,'Color',colormp(j,:),'Parent',ahandle)];
     end
     hold off;
   else
       phandles = plot(handles.x,handles.y,'LineStyle',handles.lineType,'Color',handles.color,'Parent',ahandle);
   end
end
axis(ahandle,'tight');
set(get(ahandle,'XLabel'),'String','x','FontSize',12);
if length(handles.b)>1
   if length(handles.b)<20 
    for i=1:length(handles.parameterValues)
      h = num2str(handles.parameterValues(i));
      legendStr{i} = [handles.parameterName ' = ' h];
    end
   else
       legendStr{1} = [handles.parameterName ' = ' num2str(handles.parameterValues(1))];
       legendStr{2} = [handles.parameterName ' = ' num2str(handles.parameterValues(length(handles.b)))];
   end
   if length(handles.b)>3 && length(handles.b)<20
      leg=legend(phandles(1:end),legendStr{:},'Location','BestOutside');
   else
      leg=legend(phandles(1:end),legendStr{:},'Location','Best');
   end
   set(leg,'FontSize',8);
else
  legend(phandles(1:end),'V(x)','Location','Best');
end
if handles.slp
   set(get(ahandle,'Title'),'String','The associated Schrodinger equation','FontSize',10);
else
  set(get(ahandle,'Title'),'String','The potential function','FontSize',12)
end
a=str2double(get(handles.a_edit,'String'));
b=str2double(get(handles.b_edit,'String'));
y1=str2double(get(handles.Y1_edit,'String'));
y2=str2double(get(handles.Y2_edit,'String'));
try
  axis(ahandle,[a b y1 y2]);
catch
end
set(handles.info_edit,'String','Ready');
set([handles.plot_button],'Enable','on');


% --------------------------------------------------------------------
function CopyItem_Callback(hObject, eventdata, handles)
% copy figure to clipboard
fhandle = figure('IntegerHandle','off','NumberTitle','off',...
    'Visible','off');
if length(handles.b) > 3
       set(fhandle,'DefaultAxesColorOrder',jet(length(handles.b)));
else
       set(fhandle,'DefaultAxesColorOrder',hsv(length(handles.b)));
end
ahandle = axes('Parent',fhandle);
phandles = plot_potential2(handles,ahandle);
set(fhandle,'Position',[-100 -100 30 25]);
set(fhandle,'Visible','on');
print -dmeta; 
delete(fhandle);


% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
HelpPath = which('potential_plot_window.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','potential_plot_window.html');
web(HelpPath);



% --------------------------------------------------------------------
function solidLineItem_Callback(hObject, eventdata, handles)
handles.lineType = '-';
off =[handles.noLineItem,handles.dottedLineItem,handles.dashedLineItem,handles.dashdotLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);


% --------------------------------------------------------------------
function dashedLineItem_Callback(hObject, eventdata, handles)
handles.lineType = '--';
off =[handles.noLineItem,handles.dottedLineItem,handles.solidLineItem,handles.dashdotLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);


% --------------------------------------------------------------------
function dottedLineItem_Callback(hObject, eventdata, handles)
handles.lineType = ':';
off =[handles.noLineItem,handles.dashedLineItem,handles.solidLineItem,handles.dashdotLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);


% --------------------------------------------------------------------
function dashdotLineItem_Callback(hObject, eventdata, handles)
handles.lineType = '-.';
off =[handles.dottedLineItem,handles.dashedLineItem,handles.solidLineItem,handles.noLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);


% --------------------------------------------------------------------
function noLineItem_Callback(hObject, eventdata, handles)
handles.lineType = 'none';
off =[handles.dottedLineItem,handles.dashedLineItem,handles.solidLineItem,handles.dashdotLineItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);




% --------------------------------------------------------------------
function redItem_Callback(hObject, eventdata, handles)
handles.color = 'r';
off = [handles.blackItem,handles.greenItem,handles.blueItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);


% --------------------------------------------------------------------
function blueItem_Callback(hObject, eventdata, handles)
handles.color = 'b';
off = [handles.blackItem,handles.redItem,handles.greenItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);


% --------------------------------------------------------------------
function greenItem_Callback(hObject, eventdata, handles)
handles.color = 'g';
off = [handles.blackItem,handles.redItem,handles.blueItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);


% --------------------------------------------------------------------
function blackItem_Callback(hObject, eventdata, handles)
handles.color = 'k';
off = [handles.greenItem,handles.redItem,handles.blueItem];
set(off,'Checked','off');
set(hObject,'Checked','on');
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);


% --------------------------------------------------------------------
function MarkersItem_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'Checked'),'on')
  set(hObject,'Checked','off');
  handles.Markers = false;
else
  set(hObject,'Checked','on');
  handles.Markers = true;
end
plot_potential2(handles,handles.potential_axes);
guidata(hObject, handles);




function info_edit_Callback(hObject, eventdata, handles)
% hObject    handle to info_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of info_edit as text
%        str2double(get(hObject,'String')) returns contents of info_edit as a double


% --- Executes during object creation, after setting all properties.
function info_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to info_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end





function Y1_edit_Callback(hObject, eventdata, handles)
% hObject    handle to Y1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Y1_edit as text
%        str2double(get(hObject,'String')) returns contents of Y1_edit as a double


% --- Executes during object creation, after setting all properties.
function Y1_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Y1_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function Y2_edit_Callback(hObject, eventdata, handles)
% hObject    handle to Y2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Y2_edit as text
%        str2double(get(hObject,'String')) returns contents of Y2_edit as a double


% --- Executes during object creation, after setting all properties.
function Y2_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Y2_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


