function varargout = regular_schrodinger(varargin)
% REGULAR_SCHRODINGER M-file for regular_schrodinger.fig
%      REGULAR_SCHRODINGER, by itself, creates a new REGULAR_SCHRODINGER or raises the existing
%      singleton.
%
%      H = REGULAR_SCHRODINGER returns the handle to a new REGULAR_SCHRODINGER or the handle to
%      the existing singleton.
%
%      REGULAR_SCHRODINGER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PARAMETER_SCHROD.M with the given input arguments.
%
%      REGULAR_SCHRODINGER('Property','Value',...) creates a new REGULAR_SCHRODINGER or raises the
%      existing singleton.  Starting from the left, property value pairs are
%      applied to the GUI before regular_schrodinger_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to regular_schrodinger_OpeningFcn via varargin.
%

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @regular_schrodinger_OpeningFcn, ...
                   'gui_OutputFcn',  @regular_schrodinger_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before regular_schrodinger is made visible.
function regular_schrodinger_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to regular_schrodinger (see VARARGIN)
global gapp
number_set=false;
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
        case 'V'
            set(handles.V_edit,'String',varargin{i+1});
        case 'parameterValue'
            set(handles.parameter_box,'Value',get(handles.parameter_box,'Max'));
            set([handles.parameter_edit,handles.parameter_text],'Enable','On');
            set(handles.parameter_edit,'String',varargin{i+1});
        case 'parameterName'
            set([handles.parameterName_edit,handles.parameterName_text],'Enable','On');
            set(handles.parameterName_edit,'String',varargin{i+1});
        case 'a'
            set(handles.a_edit,'String',varargin{i+1});
        case 'b'
             set(handles.b_edit,'String',varargin{i+1});
        case 'a0'
            set(handles.a0_edit,'String',varargin{i+1});
        case 'a1'
            set(handles.a1_edit,'String',varargin{i+1});
        case 'b0'
             set(handles.b0_edit,'String',varargin{i+1});
        case 'b1'
            set(handles.b1_edit,'String',varargin{i+1});
        case 'tol'
             set(handles.tol_edit,'String',varargin{i+1});
        case 'Name'
             name = varargin{i+1};
             if isfield(gapp,'names')
               name = test_names(name);
               gapp.names = [gapp.names;{name}];
             else
                 gapp.names ={name};
             end
             set(handles.regular_schrodinger,'Name',name);
             handles.name = name;
         case 'info'
              s=strrep(varargin{i+1},'                        ','\n');
            while strfind(s,'\n\n')
                s=strrep(s,'\n\n','\n');
            end
            s=strrep(s,'\n',sprintf('\n'));
            set(handles.problemInfo_edit,'String',s);
         case 'Number_problem'
             handles.number_matslise = varargin{i+1};
             number_set=true;
         otherwise 
             errordlg('regular_schrodinger: wrong input argument','Error','modal');
     end
     i = i+2;
    end
end
if ~isfield(handles,'name')
   name=inputdlg('Enter a name for the new problem.','Input Name');
   if isempty(name)
       name='Untitled';
   else
       name = name{1};
   end
   if isfield(gapp,'names')
          name = test_names(name);
          gapp.names = [gapp.names;{name}];
   else
          gapp.names ={name};
   end
   handles.name = name;
   set(handles.regular_schrodinger,'Name',name);
end
if ~number_set
 if isfield(gapp,'number_problems')
  gapp.number_problems = gapp.number_problems+1;
 else
  gapp.number_problems =1;
  gapp.number_opened = 0;
 end
 gapp.number_opened = gapp.number_opened +1;
 handles.number_matslise = gapp.number_opened;
 %handles.number_matslise = gapp.number_problems; %to keep track which
 %instance of matslise
end %number_problems
set(handles.stop_button,'Enable','Off');
handles.cpm = [];
handles.halfrange_reduction = false;
handles.showBasicPartition = false;
% Choose default command line output for regular_schrodinger
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = regular_schrodinger_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%----------------------------------------------------------------------
%-----------------------Create functions-------------------------------
%----------------------------------------------------------------------

function V_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function a_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function b_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function a0_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function b0_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function a1_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function b1_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function tol_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function method_popup_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function info_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function problemInfo_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function parameterName_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function parameter_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%----------------------------------------------------------------------
%-----------------------Callback functions-----------------------------
%----------------------------------------------------------------------

% --- Executes on button press in construct_button.
function construct_button_Callback(hObject, eventdata, handles)
global gapp
if isfield(gapp,'eigenvalue_window') && length(gapp.eigenvalue_window) >= handles.number_matslise
    if ishandle(gapp.eigenvalue_window(handles.number_matslise)) 
     try
       delete(gapp.eigenvalue_window(handles.number_matslise));
     catch
     end
    end
end
handles=set_buttons(handles,1);
try
  V = get(handles.V_edit,'String');
  if isempty(V)
    error('Error!!! : You should fill in all the fields');
  end
  a = get(handles.a_edit,'String');
  if isempty(a)
    error('Error!!! : You must enter a numeric value for a');
  end
  b = get(handles.b_edit,'String');
  if isempty(b)
    error('Error!!! : You must enter a numeric value for b');
  end
  a0 = get(handles.a0_edit,'String');
  b0 = get(handles.b0_edit,'String');
  a1 = get(handles.a1_edit,'String');
  b1 = get(handles.b1_edit,'String');
  if isempty(a0) || isempty(a1) || isempty(b0) || isempty(b1) 
    error('Error!!! : You must enter a numeric value for a0, b0 ,a1 ,b1');
  end
  parameter_range = false;
  if get(handles.parameter_box,'Value') == get(handles.parameter_box,'Max')
    syms x;
    pp = get(handles.parameter_edit,'String');
    if isempty(pp)
      error('Error!!! : You must enter a numeric value or vector as parametervalue');
    end
    pp = eval_parameterValues(pp);
    if ~isa(pp{1},'sym')
     if isnan(pp{1}) 
      error('Error!!! : You must enter a numeric value or vector as parametervalue');
     end
    end
    pn = get(handles.parameterName_edit,'String');
    pns = eval_parameterNames(pn);
    if length(pns) ~= length(pp)
      error('Error!!! : The number of parameternames must be equal to the number of parametervalues!')
    end
    range_p = [];
    for i=1:length(pns)
      if length(pp{i}) == 1
        V = subs(sym(V),pns(i),pp{i});
        a = subs(sym(a),pns(i),pp{i});
        b = subs(sym(b),pns(i),pp{i});
        a0 = subs(sym(a0),pns(i),pp{i});
        b0 = subs(sym(b0),pns(i),pp{i});
        a1 = subs(sym(a1),pns(i),pp{i});
        b1 = subs(sym(b1),pns(i),pp{i});
      else
          parameter_range = true;
           if isempty(range_p)
              range_p = pp{i};
              range_n = pns(i);
            else
                error('Error!!! : Only one of the parametervalues is allowed to be a vector!')
            end   
      end
    end
    if ~parameter_range
      V = char(eval(V));
      a = eval(sym(a));
      b = eval(sym(b));
      a0 = eval(sym(a0));
      b0 = eval(sym(b0));
      a1 = eval(sym(a1));
      b1 = eval(sym(b1));
    end
  else  
   a = eval(a);
   b = eval(b);  
   a0 = eval(a0);
   b0 = eval(b0);
   a1 = eval(a1);
   b1 = eval(b1);
  end
 tol = str2double(get(handles.tol_edit,'String'));
 if tol < 0
        error('Error!!! : You must enter a positive value for tol')
 end
 if isnan(tol)
        error('Error!!! : You must enter a numeric value for tol')
 end
 if tol < 1e-15
          warndlg('This tolerance can''t be achieved within the floating-point relative accuracy of the MATLAB-environment');
          tol = 1e-15;    
 end
 if ~parameter_range
    if isnan(a)
        error('Error!!! : You must enter a numeric value for a')
    elseif isnan(b)
        error('Error!!! : You must enter a numeric value for b')
    elseif isnan(tol)
        error('Error!!! : You must enter a numeric value for tol')
    elseif isnan(a0)
        error('Error!!! : You must enter a numeric value for a0')
    elseif isnan(b0)
        error('Error!!! : You must enter a numeric value for b0')
    elseif isnan(a1)
        error('Error!!! : You must enter a numeric value for a1')
    elseif isnan(b1)
        error('Error!!! : You must enter a numeric value for b1')
    else
        if handles.halfrange_reduction
            if check_symmetry(V,a,b) < 0
                error('Error!!! : The problem is not symmetric: the option half-range reduction must be unchecked.');
            end
            problem1 = schrod(V,0,b,0,1,a1,b1);
            [handles.cpm,stat] = cpm16_14(problem1,tol); 
            problem = schrod(V,0,b,1,0,a1,b1);
            class=get(problem,'classification');
            if class.cutoff<4e306
               class1=get(problem1,'classification');
               class.lastev=class.lastev+class1.lastev;
            end
            solvable=true;
            switch class.category
             case {3,7,4,5,6}
                   solvable=false;
                   class.infostring =[class.infostring 'Sorry, the problem can''t be solved using MATSLISE!'];
             otherwise
                   [handles.cpm(2),stat1] = cpm16_14(problem,tol);      
                   stat.number_intervals_bp = stat.number_intervals_bp + stat1.number_intervals_bp;
                   stat.nfev = stat.nfev + stat1.nfev;
                   stat.part_time = stat.part_time+ stat1.part_time;
            end
        else
          problem = schrod(V,a,b,a0,b0,a1,b1);
          class=get(problem,'classification');
          solvable=true;
          switch class.category
             case {3,7,4,5,6}
                   class.infostring =[class.infostring 'Sorry, the problem can''t be solved using MATSLISE!'];
                   solvable=false;
             otherwise
                   [handles.cpm,stat] = cpm16_14(problem,tol);       
          end
        end
    if solvable  
      pot = inline(V);  
      if isinf(a) || isinf(b) || isinf(pot(a)) || isinf(pot(b)) 
        set(handles.info_edit,'String','Ready');  
      else
        s = sprintf('Number of intervals in the partition: %d',stat.number_intervals_bp);
        s = sprintf('%s\nNumber of function-evaluations ( in V(x) ): %d',s,stat.nfev);
        s = sprintf('%s\nCPU-time for calculating the partitions: %4.2f s',s,stat.part_time);
        set(handles.info_edit,'String',s);
      end
    else
       set(handles.info_edit,'String','Sorry, the problem can''t be solved using MATSLISE! '); 
    end
    switch class.category
        case {1,8,9}
            gapp.eigenvalue_window(handles.number_matslise) = eigenvalues_window('CPM',handles.cpm,'halfrangereduction',...
            handles.halfrange_reduction,'Name',handles.name,'number_matslise',handles.number_matslise);
            movegui(gapp.eigenvalue_window(handles.number_matslise),'north');
        case {2,10}
            if class.lastev ~= 0
                gapp.eigenvalue_window(handles.number_matslise) = eigenvalues_window('CPM',handles.cpm,'halfrangereduction',...
                handles.halfrange_reduction,'Name',handles.name,'number_matslise',handles.number_matslise);
                movegui(gapp.eigenvalue_window(handles.number_matslise),'north');
            end
    end
    guidata(hObject,handles)
    s=class.infostring;
    if handles.halfrange_reduction
        i=findstr(s,'At endpoint A');
        j=findstr(s,'At endpoint B');
        s=[s(1:i-1) 'At both endpoints' s(j+13:end)];
        i=findstr(s,'There appear to be ');
        j=findstr(s,'eigenvalues below the');
        if ~isempty(i)
           s=[s(1:i-1) 'There appear to be ' num2str(class.lastev) s(j-1:end)];
        end
    end
    h=msgbox(s,'Classification Information','replace');
   end
 else %parameter_range == true
    syms x;
    if isfield(handles,'cpm')
       handles = rmfield(handles,'cpm');
    end
    n=sprintf('\n');
    solvable=true;
    for i=1:length(range_p)
        set(handles.info_edit,'String',['Constructing cpm for ' char(range_n) ' = ' num2str(range_p(i))]);
        drawnow;
        Vp = char(sym(eval(subs(sym(V),range_n,range_p(i)))));
        Vp = sprintf('%s +0*x',Vp);
        ap = eval(sym(subs(sym(a),range_n,range_p(i))));
        bp = eval(sym(subs(sym(b),range_n,range_p(i))));
        a0p = eval(sym(subs(sym(a0),range_n,range_p(i))));
        b0p = eval(sym(subs(sym(b0),range_n,range_p(i))));
        a1p = eval(sym(subs(sym(a1),range_n,range_p(i))));
        b1p = eval(sym(subs(sym(b1),range_n,range_p(i))));
        if handles.halfrange_reduction
            if check_symmetry(Vp,ap,bp) < 0
                error('Error!!! : The problem is not symmetric: the option half-range reduction must be unchecked.');
            end
             problem(i) = schrod(Vp,0,bp,0,1,a1p,b1p);
            [handles.cpm(i,1)] = cpm16_14(problem(i),tol); 
            problem(i) = schrod(Vp,0,bp,1,0,a1p,b1p);
            class(i)=get(problem(i),'classification');
            switch class(i).category
              case {3,7,4,5,6}
                class.infostring =[class.infostring 'Sorry, this problem can''t be solved using MATSLISE!' n];
                solvable=false;
              otherwise
                [handles.cpm(i,2)] = cpm16_14(problem(i),tol); 
            end
        else
            problem(i) = schrod(Vp,ap,bp,a0p,b0p,a1p,b1p);
            class(i)=get(problem(i),'classification');
            switch class(i).category
              case {3,7,4,5,6}
                class.infostring =[class.infostring 'Sorry, this problem can''t be solved using MATSLISE!' n];
                solvable=false;
                otherwise
                handles.cpm(i) = cpm16_14(problem(i),tol); 
            end
        end
    end
    set(handles.info_edit,'String','Ready');
    if solvable
      gapp.eigenvalue_window(handles.number_matslise) = param_eigenvalues_window('CPM',handles.cpm,'parameterName',char(range_n),...
        'parameterValues',range_p,'Name',handles.name,'number_matslise',handles.number_matslise,'halfrangereduction',...
        handles.halfrange_reduction);
      movegui(gapp.eigenvalue_window(handles.number_matslise),'north');
    else
        
        
    end
    s='';
    for i=1:length(range_p)
        cat(i)=class(i).category;
        ss=strrep(class(i).infostring,[n n],n);
        if handles.halfrange_reduction
            k=findstr(ss,'At endpoint A');
            j=findstr(ss,'At endpoint B');
            ss=[ss(1:k-1) 'At both endpoints' ss(j+13:end)];
        end
        s=[s 'For ' char(range_n) ' = ' num2str(range_p(i)) ':' n ss];
        s=[s n ];
    end
    if length(range_p)<5
          h=msgbox(s,'Classification Information','replace');
    else 
        s=['For ' char(range_n) ' = ' num2str(range_p(1)) ':'];
        s=[s n strrep(class(1).infostring,[n n],n)];
        if handles.halfrange_reduction
            i=findstr(s,'At endpoint A');
            j=findstr(s,'At endpoint B');
            s=[s(1:i-1) 'At both endpoints' s(j+13:end)];
        end
        s2=['For ' char(range_n) ' = ' num2str(range_p(end)) ':'];       
        s2=[s2 n strrep(class(end).infostring,[n n],n)];
        if handles.halfrange_reduction
            i=findstr(s2,'At endpoint A');
            j=findstr(s2,'At endpoint B');
            s2=[s2(1:i-1) 'At both endpoints' s2(j+13:end)];
        end
        s=[s n s2];
        h=msgbox(s,'Classification Information','replace');
   end
    guidata(hObject,handles)
 end
 if ~parameter_range && handles.showBasicPartition
  if isinf(a)||isinf(b)
      error('Error!!! : The partition of an infinite problem can''t be shown at this stage. (uncheck the "Show partiton" option)');
  end
  if isfield(gapp,'partition_plot') && length(gapp.partition_plot)>=handles.number_matslise
      if ishandle(gapp.partition_plot(handles.number_matslise))
          try
           delete(gapp.partition_plot(handles.number_matslise));
          catch
          end
      end
  end
  if handles.halfrange_reduction
    bp = get(handles.cpm(1),'bp');
    x = [0, 0+cumsum(bp.h)]; 
  else
    bp = get(handles.cpm(1),'bp');
    x = [a, a+cumsum(bp.h)];
   end
   gapp.partition_plot(handles.number_matslise) =  partition_plot_window('Name',handles.name,...
      'V',V,'a',a,'b',b,'x_bp',x,'Vbar',bp.V0,'imatch',bp.imatch);
end
catch
    hlp=strfind(lasterr,'Error!!! : ');
    if isempty(hlp)
       errordlg(lasterr,'Error','modal');
    else
       msg=lasterr; 
       errordlg(msg(hlp(1)+11:end),'Error','modal');
    end
    set(handles.info_edit,'String','Ready');
end
handles=set_buttons(handles,0);
guidata(hObject,handles)

% --- Executes on button press in exit_button.
function exit_button_Callback(hObject, eventdata, handles)
close(handles,true);

% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
global gapp
try
d = pwd;
try
HelpPath = which('regular_schrodinger.m');
[pathstr,name,ext] =fileparts(HelpPath);
cd(pathstr) 
cd 'predefined_problems'
catch
end
[filename, pathname] = uigetfile( ...
{'*.mat','MAT-files (*.mat)'}, ...
    'Select the problem to open');
if isequal([filename,pathname],[0,0])
    cd(d);
    return;
end
file=fullfile(pathname,filename);
if exist(file) == 2
    S = load(file);
    cd(d);
else
    errordlg('file doesn''t exist','Error','modal');
    cd(d);
    return;
end
[pathstr,fname,ext]=fileparts(filename);
if strcmp(S.type,'regular-schrodinger')
    pos=get(handles.regular_schrodinger,'Position');
    %close(handles,false);
    close_problem(handles.number_matslise);
    if handles.number_matslise==1
        gapp.names={};
        clear gapp;
    end
    delete(handles.regular_schrodinger);
    if S.parameter
        h=regular_schrodinger('V',S.V,'a',S.a,'b',S.b,'a0',S.a0,'a1',...
        S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'parameterName',...
        S.parameterName,'parameterValue',S.parameterValue,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
        h=regular_schrodinger('V',S.V,'a',S.a,'b',S.b,'a0',S.a0,'a1',...
        S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    set(h,'Position',pos);
    movegui(h,'onscreen');
elseif strcmp(S.type,'sturm-liouville')
    pos1=get(handles.regular_schrodinger,'Position');
%    close(handles,false);
    close_problem(handles.number_matslise);
    delete(handles.regular_schrodinger);
    if S.parameter
      h=sturm_liouville('p',S.p,'q',S.q,'w',S.w,'a',S.a,'b',S.b,...
      'a0',S.a0,'a1',S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,...
      'parameterValue',S.parameterValue,'parameterName',S.parameterName,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
      h=sturm_liouville('p',S.p,'q',S.q,'w',S.w,'a',S.a,'b',S.b,...
      'a0',S.a0,'a1',S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    pos2=get(h,'Position');
    set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
    movegui(h,'onscreen');
elseif strcmp(S.type,'distorted-coulomb')
    pos1=get(handles.regular_schrodinger,'Position');
 %   close(handles,false);
    close_problem(handles.number_matslise);
    delete(handles.regular_schrodinger);
    if S.parameter
      h=dist_coulomb('S',S.S,'R',S.R,'l',S.l,'tol',S.tol,...
      'xmax',S.xmax,'parameterValue',S.parameterValue,'parameterName',...
      S.parameterName,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
      h=dist_coulomb('S',S.S,'R',S.R,'l',S.l,'tol',S.tol,...
      'xmax',S.xmax,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    pos2=get(h,'Position');
    set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
    movegui(h,'onscreen');
end
catch
    errordlg(lasterr,'Error','modal');
    cd(d);
end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
printdlg(handles.regular_schrodinger)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
close(handles,true);

% --------------------------------------------------------------------
function NewSturmLiouville_Callback(hObject, eventdata, handles)
pos1=get(handles.regular_schrodinger,'Position');
close(handles,false);
h=sturm_liouville;
pos2=get(h,'Position');
set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
movegui(h,'onscreen');


% --------------------------------------------------------------------
function NewRegularSchrodinger_Callback(hObject, eventdata, handles)
pos = get(handles.regular_schrodinger,'Position');
close(handles,false);
h=regular_schrodinger;
set(h,'Position',pos);
movegui(h,'onscreen');


% --------------------------------------------------------------------
function AboutItem_Callback(hObject, eventdata, handles)
HelpPath = which('regular_schrodinger.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'helpfiles','matslise.html');
web(HelpPath);

% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
HelpPath = which('regular_schrodinger.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'helpfiles','reg_schrod.html');
web(HelpPath);

% --------------------------------------------------------------------
function NewDistortedCoulomb_Callback(hObject, eventdata, handles)
pos1=get(handles.regular_schrodinger,'Position');
close(handles,false);
h=dist_coulomb;
pos2=get(h,'Position');
set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
movegui(h,'onscreen');


% --- Executes on button press in parameter_box.
function parameter_box_Callback(hObject, eventdata, handles)
if get(hObject,'Value') == get(hObject,'Max')
    set([handles.parameter_edit,handles.parameter_text,handles.parameterName_edit,...
        handles.parameterName_text],'Enable','On'); 
else
    set([handles.parameter_edit,handles.parameter_text,handles.parameterName_edit,...
        handles.parameterName_text],'Enable','Off');
    set([handles.parameter_edit,handles.parameterName_edit],'String','');
end

% --- Executes on button press in stop_button.
function stop_button_Callback(hObject, eventdata, handles)
stop = 1;
save stop.mat stop;


% --- Executes on button press in plotpotential.
function plotpotential_Callback(hObject, eventdata, handles)
global gapp
try
set([handles.construct_button,handles.exit_button,handles.plotpotential,handles.stop_button],'Enable','off');
set(handles.info_edit,'String','Busy...');
drawnow;
if isfield(gapp,'potential_plot') && length(gapp.potential_plot)>=handles.number_matslise && ishandle(gapp.potential_plot(handles.number_matslise))
    try
      delete(gapp.potential_plot(handles.number_matslise));
    catch
    end
end
syms x;
V = get(handles.V_edit,'String');
if isempty(V)
    error('You should fill in the potential-field');
end
a = get(handles.a_edit,'String');
if isempty(a)
    error('You must enter a numeric value for a');
end
b = get(handles.b_edit,'String');
if isempty(b)
    error('You must enter a numeric value for b');
end
parameter_range = false;
if get(handles.parameter_box,'Value') == get(handles.parameter_box,'Max')
  syms x;
  pp = get(handles.parameter_edit,'String');
  if isempty(pp)
      error('You must enter a numeric value or vector as parametervalue');
  end
  pp=eval_parameterValues(pp);
  if ~isa(pp{1},'sym')
    if isnan(pp{1}) 
      error('You must enter a numeric value or vector as parametervalue');
    end
  end
  pn = get(handles.parameterName_edit,'String');
  pns = eval_parameterNames(pn);
  if length(pns) ~= length(pp)
      error('The number of parameternames must be equal to the number of parametervalues!')
  end
  range_p = [];
  for i=1:length(pns)
      if length(pp{i}) == 1
        V = subs(sym(V),pns(i),pp{i});
        a = subs(sym(a),pns(i),pp{i});
        b = subs(sym(b),pns(i),pp{i});
      else
          parameter_range = true;
           if isempty(range_p)
              range_p = pp{i};
              range_n = pns(i);
            else
                error('only one of the parametervalues is allowed to be a vector!')
            end   
      end
  end
else
  a = eval(a);
  b = eval(b);  
end
if ~parameter_range
    V = char(V);
%     if ~strcmp(V,'0')
%         V = char(eval(V));
%     end
    a = eval(sym(a));
    b = eval(sym(b)); 
    gapp.potential_plot(handles.number_matslise) = potential_plot_window('Name',handles.name ,...
         'a',a,'b',b,'V',V);
else
    Vp={};
    bp=[];
    ap=[];

    ea=isempty(findsym(sym(a)));
    eb=isempty(findsym(sym(b)));
    ib=isinf(str2double(b));
    ia=isinf(str2double(b));
    if (ea && eb) || (ib &&  (ia || ea)) || (ia &&  (ib || eb))
        noParamInAorB = true;
    else
        noParamInAorB = false;
    end
    for i=1:length(range_p)
      Vt = char(sym(eval(subs(sym(V),range_n,range_p(i)))));
      Vp{i} = sprintf('%s +0*x',Vt);
      ap(i) = eval(sym(subs(sym(a),range_n,range_p(i))));
      bp(i) = eval(sym(subs(sym(b),range_n,range_p(i))));
     end
         gapp.potential_plot(handles.number_matslise) = potential_plot_window('Name',handles.name ,...
         'a',ap,'b',bp,'V',Vp,'parameterName',char(range_n),'parameterValues',range_p,'Vparam',char(V),...
         'noParamInAorB',noParamInAorB);
end
catch
    errordlg(lasterr,'Error','modal')
end
set([handles.construct_button,handles.exit_button,handles.plotpotential,handles.stop_button],'Enable','on');
set(handles.info_edit,'String','Ready');


% --------------------------------------------------------------------
function SaveItem_Callback(hObject, eventdata, handles)
d = pwd;
try
 HelpPath = which('regular_schrodinger.m');
 [pathstr,name,ext] =fileparts(HelpPath);
 cd(pathstr) 
 cd predefined_problems
catch
end
try
[FileName,PathName,FilterIndex]=uiputfile({'*.mat','MAT-files (*.mat)'},'Save problem as ...',handles.name);
if strcmp(FileName,'0') || strcmp(PathName,'0') || FilterIndex == 0
    cd(d);
    return;
end
cd(d);
V = get(handles.V_edit,'String');
if isempty(V)
    error('You should fill in all the fields');
end
a = get(handles.a_edit,'String');
if isempty(a)
    error('You must enter a numeric value for a');
end
b = get(handles.b_edit,'String');
if isempty(b)
    error('You must enter a numeric value for b');
end
a0 = get(handles.a0_edit,'String');
b0 = get(handles.b0_edit,'String');
a1 = get(handles.a1_edit,'String');
b1 = get(handles.b1_edit,'String');
if isempty(a0) || isempty(a1) || isempty(b0) || isempty(b1) 
    error('You must enter a numeric value for a0, b0 ,a1 ,b1');
end
tol = get(handles.tol_edit,'String');
if isempty(tol) 
    error('You must enter a positive numeric value for tol');
end
info = get(handles.problemInfo_edit,'String');
parameter = false;
if get(handles.parameter_box,'Value') == get(handles.parameter_box,'Max')
  parameter = true;  
  parameterValue = get(handles.parameter_edit,'String');
  parameterName = get(handles.parameterName_edit,'String');
  if isempty(parameterValue) || isempty(parameterName)
      error('You should fill in the parameterfields');
  end
end
file=fullfile(PathName,[FileName]);
type = 'regular-schrodinger';
if parameter 
    save(file,'type','V','a','b','a0','b0','a1','b1','tol','parameter','parameterValue','parameterName','info');
else
    save(file,'type','V','a','b','a0','b0','a1','b1','tol','parameter','info');
end
catch
    errordlg(lasterr,'Error','modal');
     cd(d);
end


%---------------------------------------------------------------------
function pvs = eval_parameterValues(s)
% used to distinguish between the parameter values
try
syms x;
chopped = 'tst';
i = 1;
remainder = s;
while any(remainder)
  [chopped,remainder] = strtok(s,',');
  if chopped(1) == '[' && any(remainder)
    [chopped2,remainder] = strtok(remainder,']');
    chopped = [chopped chopped2 ']'];
    pvs{i} = eval(chopped);
    if remainder == ']'
      remainder = '';    
    else
      remainder=remainder(2:end);
    end
  else
    pvs{i} = eval(chopped);
  end  
  i = i+1;
  s = remainder;
end
catch
    error('Error in the evaluation of the parameter values');
end

%-------------------------------------------------------------------
 function pns = eval_parameterNames(s)
 try
 remainder = s;
 pns =[];
 while any(remainder)
   [chopped,remainder] = strtok(remainder,',');
  pns = [pns,sym(chopped)];
end
catch
    error('Error in the evaluation of the parameter names.');
end

%-----------------------------------------------------------------
function close(handles,quest)
global gapp
if quest
selection = questdlg(['Close ' get(handles.regular_schrodinger,'Name') '?'],...
                     ['Close ' get(handles.regular_schrodinger,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end
end
close_problem(handles.number_matslise);
delete(handles.regular_schrodinger);
gapp.number_problems = gapp.number_problems-1;
if gapp.number_problems == 0
    clear_gapp;
end



% --------------------------------------------------------------------
function Halfrange_reduction_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'Checked'),'off')
  check =check_symmetry2(handles);
  if check > 0
    set(hObject,'Checked','on');
    handles.halfrange_reduction = 1;
  elseif check < 0
      errordlg('The problem is not symmetric. Half-range reduction is not a good idea.','Error','modal');
      set(hObject,'Checked','off');
      handles.halfrange_reduction = 0;
  end
else
  set(hObject,'Checked','off');  
  handles.halfrange_reduction = 0;
end
guidata(hObject,handles)


%---------------------------------------------------------------------
function symm=check_symmetry(V,a,b)
syms x;
if ~strcmp(V,'0')
        V = char(eval(V));
end
a = eval(sym(a));
b = eval(sym(b));
symm = 1;
if a ~= -b
    symm = -1;
    return
end
pot = inline(V);
if isinf(a) && ~isinf(b)
    symm = -1;
    return;
end
if isinf(a) && isinf(b)
    a = -4;
    b = 4;
end
if pot(b/2) ~= pot(-b/2)
    symm = -1;
    return
end


%---------------------------------------------------------------------
function symm=check_symmetry2(handles)
syms x;
V = get(handles.V_edit,'String');
if isempty(V)
   return;
end
a = get(handles.a_edit,'String');
b = get(handles.b_edit,'String');
if isempty(a) || isempty(b)
    return;
end
parameter_range = false;
if get(handles.parameter_box,'Value') == get(handles.parameter_box,'Max')
  pp = get(handles.parameter_edit,'String');
  if isempty(pp)
      return;
  end
  pp=eval_parameterValues(pp);
  if ~isa(pp{1},'sym')
    if isnan(pp{1}) 
      errordlg('You must enter a numeric value or vector as parametervalue');
    end
  end
  pn = get(handles.parameterName_edit,'String');
  pns = eval_parameterNames(pn);
  if length(pns) ~= length(pp)
      errordlg('The number of parameternames must be equal to the number of parametervalues!')
  end
  range_p = [];
  for i=1:length(pns)
      if length(pp{i}) == 1
        V = subs(sym(V),pns(i),pp{i});
        a = subs(sym(a),pns(i),pp{i});
        b = subs(sym(b),pns(i),pp{i});
      else
          parameter_range = true;
           if isempty(range_p)
              range_p = pp{i};
              range_n = pns(i);
            else
                errordlg('only one of the parametervalues is allowed to be a vector!')
            end   
      end
  end
else
  a = eval(a);
  b = eval(b);  
end
if ~parameter_range
    V = char(V);
    if ~strcmp(V,'0')
        V = char(eval(V));
    end
    a = eval(sym(a));
    b = eval(sym(b));
else
  %  warndlg('Half-range reduction is not yet implemented for a range of parametervalues.');
    symm = 1;
    return; % nog niet geimplementeerd
end
symm = 1;
if a ~= -b
    symm = -1;
    return
end
pot = inline(V);
if isinf(a) && ~isinf(b)
    symm = -1;
    return;
end
if isinf(a) && isinf(b)
    a = -4;
    b = 4;
end
if pot(b/2) ~= pot(-b/2)
    symm = -1;
    return
end


% --------------------------------------------------------------------
function ShowPartition_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'Checked'),'off')  
  set(hObject,'Checked','on');
  handles.showBasicPartition = 1;
else
  set(hObject,'Checked','off');  
  handles.showBasicPartition = 0;
end
guidata(hObject,handles)


% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
About_msgbox;




% --- Executes when user attempts to close regular_schrodinger.
function regular_schrodinger_CloseRequestFcn(hObject, eventdata, handles)
close(handles,true);

%------------------------------------------------------------------------
% function check_regular(a,b,pot)
% str=maple(['singular(' char(pot) ')']);
% hlp=findstr('=',str);
% hlp2=findstr('}',str);
% for i=1:length(hlp)
%     singularity = str2double(str(hlp(i)+1:hlp2(i)-1));
%     if ~isinf(singularity) && singularity > a && singularity < b
%         error(['This problem is singular in ' num2str(singularity)]);
%         return;
%     end
% end
% step=(b-a)/50;
% tmp=a:step:b;
% p=0;
% for i=2:length(tmp)
%     if pot(tmp(i))*p < 0 && abs((p-pot(tmp(i)))/(tmp(i-1)-tmp(i)))>1400 && abs((p-pot(tmp(i-2)))/(tmp(i-1)-tmp(i-2)))<abs((p-pot(tmp(i)))/(tmp(i-1)-tmp(i)))
%         warndlg('Warning: it is possible that your problem is singular.');
%     end
%     p=pot(tmp(i));
%     if isinf(p)
%         error(['This problem is singular in ' num2str(tmp(i))])
%         return;
%     end
%     if abs(p) > 1e5 
%         tmp2= tmp(i)-step/1:step/30:tmp(i)+step/1;
%         maxp=0;
%         maxj=1;
%         for j=1:length(tmp2)
%            p=abs(pot(tmp2(j)));
%            if p>maxp
%                maxj = j;
%                maxp = p;
%            end
%           if isinf(p)
%             error(['This problem is singular in ' num2str(tmp2(j))])
%             return;
%           end
%         end
%         if maxp > 1e8
%           step = step/30;
%           tmp2=tmp2(maxj)-step:step/50:tmp2(maxj)+step;
%           maxp=0;
%           for j=1:length(tmp2)
%            p=abs(pot(tmp2(j)));
%            if p>maxp
%                maxj = j;
%                maxp = p;
%            end
%            if isinf(p)
%             error(['This problem is singular in ' num2str(tmp2(j))])
%             return;
%            end
%           end
%         end
%         if maxp > 1e14
%            step = step/60; 
%            tmp2=tmp2(maxj)-step:step/500:tmp2(maxj)+step;
%            for j=1:length(tmp2)
%              p=abs(pot(tmp2(j)));
%              if isinf(p)
%                error(['This problem is singular in ' num2str(tmp2(j))])
%                return;
%              end
%            end
%            warndlg('Warning: it is possible that your problem is singular.');
%            return;
%         end
%     end
% end

%------------------------------------------------------
function handles=set_buttons(handles,on)
if on
   stop = 0;
   save stop.mat stop;
   set([handles.construct_button,handles.exit_button,handles.plotpotential,handles.problemInfo_edit,...
       handles.a0_edit,handles.a1_edit,handles.b0_edit,handles.b1_edit,handles.a_edit,handles.b_edit,handles.parameter_box,...
       handles.tol_edit,handles.V_edit],'Enable','off');
   set(handles.stop_button,'Enable','on');
   set(handles.info_edit,'String','Busy...');
   drawnow
else
   set([handles.construct_button,handles.exit_button,handles.plotpotential,handles.problemInfo_edit,...
       handles.a0_edit,handles.a1_edit,handles.b0_edit,handles.b1_edit,handles.a_edit,handles.b_edit,handles.parameter_box,...
       handles.tol_edit,handles.V_edit],'Enable','on');
   set(handles.stop_button,'Enable','off');
end
