function varargout = startwindow(varargin)
% STARTWINDOW M-file for startwindow.fig
% When "matslise" is entered at the command line, this startwindow is opened 

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @startwindow_OpeningFcn, ...
                   'gui_OutputFcn',  @startwindow_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before startwindow is made visible.
function startwindow_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to startwindow (see VARARGIN)
% Choose default command line output for startwindow
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = startwindow_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%----------------------------------------------------------------------
%-----------------------Create functions-------------------------------
%----------------------------------------------------------------------


%----------------------------------------------------------------------
%-----------------------Callback functions-----------------------------
%----------------------------------------------------------------------


% --- Executes on button press in exit_button.
function exit_button_Callback(hObject, eventdata, handles)
% exit MATSLISE
delete(handles.startwindow);

% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% an other problem (which was saved earlier) is retrieved and opened
try
d = pwd;
try
HelpPath = which('startwindow.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
cd(pathstr)
cd ..  
cd predefined_problems
catch
 end
[filename, pathname] = uigetfile( ...
{'*.mat','MAT-files (*.mat)'}, ...
    'Select the problem to open');
if isequal([filename,pathname],[0,0])
    cd(d);
    return;
end
file=fullfile(pathname,filename);
if exist(file) == 2
    S = load(file);
    cd(d);
else
    errordlg('file doesn''t exist','Error','modal');
    cd(d);
    return;
end
[pathstr,fname,ext,versn]=fileparts(filename);
if strcmp(S.type,'regular-schrodinger')
    delete(handles.startwindow);
    if S.parameter
        h=regular_schrodinger('V',S.V,'a',S.a,'b',S.b,'a0',S.a0,'a1',...
        S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'parameterName',...
        S.parameterName,'parameterValue',S.parameterValue,'Name',fname,...
        'info',S.info);
    else
        h=regular_schrodinger('V',S.V,'a',S.a,'b',S.b,'a0',S.a0,'a1',...
        S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'Name',fname,'info',S.info);
    end
    movegui(h,'northwest');
    movegui(h,'onscreen');
elseif strcmp(S.type,'sturm-liouville')
    delete(handles.startwindow);
    if S.parameter
      h=sturm_liouville('p',S.p,'q',S.q,'w',S.w,'a',S.a,'b',S.b,...
      'a0',S.a0,'a1',S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,...
      'parameterValue',S.parameterValue,'parameterName',S.parameterName,'Name',fname,'info',S.info);
    else
      h=sturm_liouville('p',S.p,'q',S.q,'w',S.w,'a',S.a,'b',S.b,...
      'a0',S.a0,'a1',S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'Name',fname,'info',S.info);
    end
    movegui(h,'northwest');
    movegui(h,'onscreen');
elseif strcmp(S.type,'distorted-coulomb')
    delete(handles.startwindow);
    if S.parameter
      h=dist_coulomb('S',S.S,'R',S.R,'l',S.l,'tol',S.tol,...
      'xmax',S.xmax,'parameterValue',S.parameterValue,'parameterName',...
      S.parameterName,'Name',fname,'info',S.info);
    else
      h=dist_coulomb('S',S.S,'R',S.R,'l',S.l,'tol',S.tol,...
      'xmax',S.xmax,'Name',fname,'info',S.info);
    end
    movegui(h,'northwest');
    movegui(h,'onscreen');
end
 catch
     errordlg(lasterr,'Error','modal');
     cd(d);
 end

% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
printdlg(handles.startwindow)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
%closes MATSLISE
delete(handles.startwindow);

% --------------------------------------------------------------------
function NewSturmLiouville_Callback(hObject, eventdata, handles)
% open a new problem: a Sturm-Liouville problem
h=sturm_liouville;
delete(handles.startwindow);
movegui(h,'northwest');
movegui(h,'onscreen');


% --------------------------------------------------------------------
function NewRegularSchrodinger_Callback(hObject, eventdata, handles)
% open a new problem: a regular Schrodinger problem
h=regular_schrodinger;
delete(handles.startwindow);
movegui(h,'northwest');
movegui(h,'onscreen');


% --------------------------------------------------------------------
function NewDistortedCoulomb_Callback(hObject, eventdata, handles)
% open a new problem: a Schrodinger problem with a distorted coulomb
% potential
h=dist_coulomb;
delete(handles.startwindow);
movegui(h,'northwest');
movegui(h,'onscreen');

% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
% opens the helpfiles
HelpPath = which('startwindow.m');
[pathstr,name,ext,versn] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'helpfiles','matslise.html');
web(HelpPath);


% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
% displays a msgbox with information about MATSLISE
About_msgbox;


