function varargout = sturm_liouville(varargin)
% STURM_LIOUVILLE M-file for sturm_liouville.fig
%      STURM_LIOUVILLE, by itself, creates a new STURM_LIOUVILLE or raises the existing
%      singleton.
%
%      H = STURM_LIOUVILLE returns the handle to a new STURM_LIOUVILLE or the handle to
%      the existing singleton.
%
%      STURM_LIOUVILLE('Property','Value',...) creates a new STURM_LIOUVILLE using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to sturm_liouville_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton.
%
%      STURM_LIOUVILLE('CALLBACK') and STURM_LIOUVILLE('CALLBACK',hObject,...) call the
%      local function named CALLBACK in STURM_LIOUVILLE.M with the given input
%      arguments.
%

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @sturm_liouville_OpeningFcn, ...
                   'gui_OutputFcn',  @sturm_liouville_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before sturm_liouville is made visible.
function sturm_liouville_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)
global gapp
number_set=false;
set(handles.info_box,'Value',[]);
if ~isempty(varargin)
    i = 1;
    while i < length(varargin)
     switch varargin{i}
        case 'p'
            set(handles.p_edit,'String',varargin{i+1});
        case 'q'
            set(handles.q_edit,'String',varargin{i+1});
        case 'w'
             set(handles.w_edit,'String',varargin{i+1});
        case 'a'
            set(handles.a_edit,'String',varargin{i+1});
        case 'b'
             set(handles.b_edit,'String',varargin{i+1});
        case 'a0'
            set(handles.a0_edit,'String',varargin{i+1});
        case 'a1'
            set(handles.a1_edit,'String',varargin{i+1});
        case 'b0'
             set(handles.b0_edit,'String',varargin{i+1});
        case 'b1'
            set(handles.b1_edit,'String',varargin{i+1});
        case 'tol'
             set(handles.tol_edit,'String',varargin{i+1});
        case 'Name'
             name = varargin{i+1};
             if isfield(gapp,'names')
               name = test_names(name);
               gapp.names = [gapp.names;{name}];
             else
                 gapp.names ={name};
             end
             set(hObject,'Name',name);
             handles.name = name;
        case 'info'
              s=strrep(varargin{i+1},'                        ','\n');
            while strfind(s,'\n\n')
                s=strrep(s,'\n\n','\n');
            end
            s=strrep(s,'\n',sprintf('\n'));
            set(handles.problemInfo_edit,'String',s);
        case 'parameterValue'
            set(handles.parameter_box,'Value',get(handles.parameter_box,'Max'));
            set([handles.parameter_edit,handles.parameter_text],'Enable','On');
            set(handles.parameter_edit,'String',varargin{i+1});
        case 'parameterName'
            set([handles.parameterName_edit,handles.parameterName_text],'Enable','On');
            set(handles.parameterName_edit,'String',varargin{i+1});
        case 'Number_problem'
             handles.number_matslise = varargin{i+1};
             number_set=true;    
        otherwise
             errordlg('sturm_liouville: wrong input argument','Error','modal');
     end
     i = i+2;
    end
end
if ~isfield(handles,'name')
   name=inputdlg('Enter a name for the new problem.','Input Name');
   if isempty(name)
       handles.name='Untitled';
   else
       handles.name = name{1};
   end
   set(handles.sturm_liouville,'Name',handles.name);
end
if ~number_set
  if isfield(gapp,'number_problems')
   gapp.number_problems = gapp.number_problems+1;
  else
   gapp.number_problems =1;
  end
  handles.number_matslise = gapp.number_problems;
end
handles.halfrange_reduction = false;
handles.showBasicPartition = false;
set([handles.stop_button,handles.plotpotential_button],'Enable','off');
% Choose default command line output for sturm_liouville
handles.output = hObject;
% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = sturm_liouville_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%----------------------------------------------------------------------
%-----------------------Create functions-------------------------------
%----------------------------------------------------------------------

function p_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function q_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function w_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function a_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function b_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function a0_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function b0_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function a1_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function b1_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function method_popup_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function tol_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function parameter_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function parameterName_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function info_box_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function problemInfo_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%----------------------------------------------------------------------
%-----------------------Callback functions-----------------------------
%----------------------------------------------------------------------

function construct_button_Callback(hObject, eventdata, handles)
% hObject    handle to construct_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global gapp range_p range_n
stop = 0;
save stop.mat stop;
syms x;
if isfield(gapp,'eigenvalue_window') && length(gapp.eigenvalue_window)>=handles.number_matslise && ishandle(gapp.eigenvalue_window(handles.number_matslise))
    try
      delete(gapp.eigenvalue_window(handles.number_matslise));
    catch
    end
end
set(handles.stop_button,'Enable','on');
set([handles.construct_button,handles.exit_button,handles.plotpotential_button],'Enable','off');
try
  p = get(handles.p_edit,'String');
  q = get(handles.q_edit,'String');
  w = get(handles.w_edit,'String');
  a = get(handles.a_edit,'String');
  b = get(handles.b_edit,'String');
  if isempty(a) || isempty(b) || isempty(p) || isempty(q) || isempty(w)
      error('Error!!! : You should fill in all the fields');
  end
  a0 = get(handles.a0_edit,'String');
  b0 = get(handles.b0_edit,'String');
  a1 = get(handles.a1_edit,'String');
  b1 = get(handles.b1_edit,'String');
  if isempty(a0) || isempty(b0) || isempty(a1) || isempty(b1)
    error('Error!!! : You should fill in all the fields');
  end
  tol = str2double(get(handles.tol_edit,'String'));
  if isnan(tol)
    error('Error!!! : You must enter a numeric value for tol');
  end
  if tol < 1e-14
      warndlg('This tolerance can''t be achieved within the floating-point relative accuracy of the MATLAB-environment');
      tol = 1e-14;    
  end
  set(handles.info_box,'String','Busy...');
  set(handles.info_box,'Value',[]);
  drawnow
  parameter_range = false;
  if get(handles.parameter_box,'Value') == get(handles.parameter_box,'Max')
    pp = get(handles.parameter_edit,'String');
    if isempty(pp)
      error('Error!!! : You must enter a numeric value or vector as parametervalue');
    end
    pp = eval_parameterValues(pp);
    if ~isa(pp{1},'sym')
      if isnan(pp{1}) 
        error('Error!!! : You must enter a numeric value or vector as parametervalue');
      end
    end
    pn = get(handles.parameterName_edit,'String');
    pns = eval_parameterNames(pn);
    if length(pns) ~= length(pp)
      error('Error!!! : The number of parameternames must be equal to the number of parametervalues!')
    end
    range_p = [];
    for i=1:length(pns)
      if length(pp{i}) == 1
        p=simplify(sym(p));
        q=simplify(sym(q));
        w=simplify(sym(w));
        if ~isempty(findsym(sym(p))) && ~isempty(findstr(char(p),char(pns(i))))
          p = sym(subs(p,pns(i),pp{i}));
        end
        if ~isempty(findsym(sym(w))) && ~isempty(findstr(char(w),char(pns(i))))
          w = sym(subs(w,pns(i),pp{i}));
        end
        if ~isempty(findsym(sym(q))) && ~isempty(findstr(char(q),char(pns(i))))
          q = sym(subs(q,pns(i),pp{i}));
        end
        a = subs(sym(a),pns(i),pp{i});
        b = subs(sym(b),pns(i),pp{i});
        a0 = subs(sym(a0),pns(i),pp{i});
        b0 = subs(sym(b0),pns(i),pp{i});
        a1 = subs(sym(a1),pns(i),pp{i});
        b1 = subs(sym(b1),pns(i),pp{i});
      else
          parameter_range = true;
           if isempty(range_p)
              range_p = pp{i};
              range_n = pns(i);
            else
                error('Error!!! : Only one of the parametervalues is allowed to be a vector!')
            end   
      end
   end
  end
  if ~parameter_range
    p = char(eval([char(p) '+0*x']));
    w = char(eval([char(w) '+0*x']));
    q = char(q);
    if strcmp(q,'0') == 0 && ~isempty(findsym(sym(q))) 
         q = char(eval(sym(q)));
    end 
    a = eval(sym(a));
    b = eval(sym(b));
    a0 = eval(sym(a0));
    b0 = eval(sym(b0));
    a1 = eval(sym(a1));
    b1 = eval(sym(b1));
    if handles.halfrange_reduction
       if check_symmetry(p,q,w,a,b) < 0
            error('Error!!! : The problem is not symmetric: the option half-range reduction must be unchecked.');
       end
       if strcmp(p,'1') && strcmp(w,'1')
           sl = false;
           problem(1) = schrod(q,0,b,0,1,a1,b1);
           problem(2) = schrod(q,0,b,1,0,a1,b1);
       else
           sl = true;
           problem(1) = slp(p,q,w,0,b,0,1,a1,b1);
           problem(2) = slp(p,q,w,0,b,1,0,a1,b1);
       end
       [handles.cpm,stat] = cpm16_14(problem(1),tol); 
       [handles.cpm(2),stat1] = cpm16_14(problem(2),tol); 
       if sl
           stat.slfev = stat.slfev + stat1.slfev;
           stat.number_intervals_sl = stat.number_intervals_sl + stat1.number_intervals_sl;
           stat.lt_time = stat.lt_time + stat1.lt_time;
         end
         stat.number_intervals_bp = stat.number_intervals_bp + stat1.number_intervals_bp;
         stat.nfev = stat.nfev + stat1.nfev;
         stat.part_time = stat.part_time+ stat1.part_time;
    else
      if strcmp(p,'1') && strcmp(w,'1')
        problem = schrod(q,a,b,a0,b0,a1,b1); %faster then slp
        sl = false;
      else
        problem = slp(p,q,w,a,b,a0,b0,a1,b1);
        sl = true;
      end
      [handles.cpm,stat] = cpm16_14(problem,tol); 
    end
    if isinf(a) || isinf(b)
      set(handles.info_box,'String','Ready');  
    else
      if sl
        s1 = sprintf('Number of function-evaluations in the Liouville transf.: %d',stat.slfev);
        s2 = sprintf('Number of intervals in the Liouville transformation: %d',stat.number_intervals_sl);
        s3 = sprintf('CPU-time for the Liouville transformation: %4.2f s',stat.lt_time);
        s4 = sprintf('---------------------------------------------------------------------------');
      end
      s5 = sprintf('Number of intervals in the partition: %d',stat.number_intervals_bp);
      s6 = sprintf('Number of function-evaluations ( in V(x) ): %d',stat.nfev);
      s7 = sprintf('CPU-time for calculating the partitions: %4.2f s',stat.part_time);
      if sl
        s = {s1;s2;s3;s4;s5;s6;s7};
      else
        s = {s5;s6;s7};
      end
      set(handles.info_box,'String',s);
    end
    set(handles.info_box,'Value',[]);
    class=get(get(handles.cpm,'schrod'),'classification');
    switch class.category
        case {3,7,4,5,6}
            class.infostring =[class.infostring 'Sorry, the problem can''t be solved using MATSLISE!'];
        case {1,8,9}
            gapp.eigenvalue_window(handles.number_matslise) = eigenvalues_window('CPM',handles.cpm,...
          'halfrangereduction',handles.halfrange_reduction,'Name',handles.name,'number_matslise',handles.number_matslise);
            movegui(gapp.eigenvalue_window(handles.number_matslise),'north');
        case {2,10}
            if class.lastev ~= 0
                gapp.eigenvalue_window(handles.number_matslise) = eigenvalues_window('CPM',handles.cpm,...
          'halfrangereduction',handles.halfrange_reduction,'Name',handles.name,'number_matslise',handles.number_matslise);
            movegui(gapp.eigenvalue_window(handles.number_matslise),'north');
            end
    end
    guidata(hObject,handles)
    h=msgbox(class.infostring,'Classification Information','replace');
  else
    %parameter_range == true
    syms x;
    if isfield(handles,'cpm')
       handles = rmfield(handles,'cpm');
    end
    for i=1:length(range_p)
        set(handles.info_box,'String',['Constructing cpm for ' char(range_n) ' = ' num2str(range_p(i))]);
        set(handles.info_box,'Value',[]);
        drawnow;
        if ~isempty(findsym(sym(p))) && ~isempty(findstr(char(p),char(range_n)))
          ppp = char(eval([char(sym(subs(sym(p),range_n,range_p(i)))) '+0*x']));
        else
          ppp = char(p);
        end
        q = char(q);
        if strcmp(q,'0') == 0 
             qp = char(eval(sym(subs(sym(q),range_n,range_p(i)))));
        else
          qp = '0';
        end
        if ~isempty(findsym(sym(w))) && ~isempty(findstr(char(w),char(range_n)))
          wp = char(eval([char(sym(subs(sym(w),range_n,range_p(i)))) '+0*x']));
        else
          wp = char(w);
        end
        ap = eval(sym(subs(sym(a),range_n,range_p(i))));
        bp = eval(sym(subs(sym(b),range_n,range_p(i))));
        a0p = eval(sym(subs(sym(a0),range_n,range_p(i))));
        b0p = eval(sym(subs(sym(b0),range_n,range_p(i))));
        a1p = eval(sym(subs(sym(a1),range_n,range_p(i))));
        b1p = eval(sym(subs(sym(b1),range_n,range_p(i))));
         if handles.halfrange_reduction
            if check_symmetry(ppp,qp,wp,ap,bp) < 0
                error('Error!!! : The problem is not symmetric: the option half-range reduction must be unchecked.');
            end
            if strcmp(ppp,'1') && strcmp(wp,'1')
                problem(1) = schrod(qp,0,bp,0,1,a1p,b1p);
                problem(2) = schrod(qp,0,bp,1,0,a1p,b1p);
            else
                problem(1) = slp(ppp,qp,wp,0,bp,0,1,a1p,b1p);
                problem(2) = slp(ppp,qp,wp,0,bp,1,0,a1p,b1p);
            end
            [handles.cpm(i,1)] = cpm16_14(problem(1),tol); 
            [handles.cpm(i,2)] = cpm16_14(problem(2),tol); 
         else
            if strcmp(ppp,'1') && strcmp(wp,'1')
                problem = schrod(qp,ap,bp,a0p,b0p,a1p,b1p);
            else
                problem = slp(ppp,qp,wp,ap,bp,a0p,b0p,a1p,b1p);
            end
            handles.cpm(i) = cpm16_14(problem,tol); 
         end
    end
    set(handles.info_box,'String','Ready');
    set(handles.info_box,'Value',[]);
    gapp.eigenvalue_window(handles.number_matslise) = param_eigenvalues_window('CPM',handles.cpm,'parameterName',char(range_n),'parameterValues',...
        range_p,'Name',handles.name,'number_matslise',handles.number_matslise);
    movegui(gapp.eigenvalue_window(handles.number_matslise),'north');
    guidata(hObject,handles)
end
if ~parameter_range && handles.showBasicPartition
  if isfield(gapp,'partition_plot') && length(gapp.partition_plot)>=handles.number_matslise && ishandle(gapp.partition_plot(handles.number_matslise))
      try
         delete(gapp.partition_plot(handles.number_matslise));
      catch
      end
  end
  problem = get(handles.cpm,'schrod');
  a = get(problem,'min');
  b = get(problem,'max');
  if isinf(a)||isinf(b)
      error('Error!!! : The partition of an infinite problem can''t be shown at this stage. (uncheck the "Show partiton" option)');
  end
  V = get(problem,'V');
  if handles.halfrange_reduction
      bp = get(handles.cpm(1),'bp');
      x = [0, cumsum(bp.h)];
  else
      bp = get(handles.cpm,'bp');
      x = [a, a+cumsum(bp.h)];
  end
   gapp.partition_plot(handles.number_matslise) =  partition_plot_window('Name',handles.name,...
      'V',char(V),'a',a,'b',b,'x_bp',x,'slp',true,'schrod',problem,'Vbar',bp.V0,'imatch',bp.imatch);
end
catch
    hlp=strfind(lasterr,'Error!!! : ');
    if isempty(hlp)
       errordlg(lasterr,'Error','modal');
    else
       msg=lasterr; 
       errordlg(msg(hlp(1)+11:end),'Error','modal');
    end
    set(handles.info_box,'String','Ready');
    set(handles.info_box,'Value',[]);
end
set(handles.stop_button,'Enable','off');
set([handles.construct_button,handles.exit_button],'Enable','on');
if ~parameter_range && (isinf(a) || isinf(b))
    set(handles.plotpotential_button,'Enable','off');
else
    set(handles.plotpotential_button,'Enable','on');
end
guidata(hObject,handles)


% --- Executes on button press in exit_button.
function exit_button_Callback(hObject, eventdata, handles)
close(handles,true);


% --------------------------------------------------------------------
function NewRegularSchrodinger_Callback(hObject, eventdata, handles)
pos1=get(handles.sturm_liouville,'Position');
close(handles,false);
h=regular_schrodinger;
pos2=get(h,'Position');
set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
movegui(h,'onscreen');


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
d = pwd;
try
HelpPath = which('sturm_liouville.m');
[pathstr,name,ext] =fileparts(HelpPath);
cd(pathstr)
cd predefined_problems
catch
end
 try
[filename, pathname] = uigetfile( ...
{'*.mat','MAT-files (*.mat)'}, ...
    'Select the problem to open');
if isequal([filename,pathname],[0,0])
    cd(d);
    return;
end
file=fullfile(pathname,filename);
if exist(file) == 2
    S = load(file);
    cd(d);
else
    errordlg('file doesn''t exist','Error','modal');
    cd(d);
    return;
end
[pathstr,fname,ext]=fileparts(filename);
if strcmp(S.type,'regular-schrodinger')
    pos1=get(handles.sturm_liouville,'Position');
    close_problem(handles.number_matslise);
    delete(handles.sturm_liouville)
    if S.parameter
        h=regular_schrodinger('V',S.V,'a',S.a,'b',S.b,'a0',S.a0,'a1',...
        S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'parameterName',...
        S.parameterName,'parameterValue',S.parameterValue,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
        h=regular_schrodinger('V',S.V,'a',S.a,'b',S.b,'a0',S.a0,'a1',...
        S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    pos2=get(h,'Position');
    set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
    movegui(h,'onscreen');
elseif strcmp(S.type,'sturm-liouville')
    pos1=get(handles.sturm_liouville,'Position');
    close_problem(handles.number_matslise);
    delete(handles.sturm_liouville)
    if S.parameter
      h=sturm_liouville('p',S.p,'q',S.q,'w',S.w,'a',S.a,'b',S.b,...
      'a0',S.a0,'a1',S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,...
      'parameterValue',S.parameterValue,'parameterName',S.parameterName,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
      h=sturm_liouville('p',S.p,'q',S.q,'w',S.w,'a',S.a,'b',S.b,...
      'a0',S.a0,'a1',S.a1,'b0',S.b0,'b1',S.b1,'tol',S.tol,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    pos2=get(h,'Position');
    set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
    movegui(h,'onscreen');
elseif strcmp(S.type,'distorted-coulomb')
    pos1=get(handles.sturm_liouville,'Position');
    close_problem(handles.number_matslise);
    delete(handles.sturm_liouville)
    if S.parameter
      h=dist_coulomb('S',S.S,'R',S.R,'l',S.l,'tol',S.tol,...
      'xmax',S.xmax,'parameterValue',S.parameterValue,'parameterName',...
      S.parameterName,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    else
      h=dist_coulomb('S',S.S,'R',S.R,'l',S.l,'tol',S.tol,...
      'xmax',S.xmax,'Name',fname,'info',S.info,'Number_problem',handles.number_matslise);
    end
    pos2=get(h,'Position');
    set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
    movegui(h,'onscreen');
end
catch
    cd(d);
    errordlg(lasterr,'Error','modal');
end


% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
printdlg(handles.sturm_liouville)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
close(handles,true);

% --------------------------------------------------------------------
function HelpItem_Callback(hObject, eventdata, handles)
HelpPath = which('sturm_liouville.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'Helpfiles','sturm_liouville.html');
web(HelpPath);

% --------------------------------------------------------------------
function AboutItem_Callback(hObject, eventdata, handles)
HelpPath = which('sturm_liouville.m');
[pathstr,name,ext] =fileparts(HelpPath);
HelpPath=fullfile(pathstr,'helpfiles','matslise.html');
web(HelpPath);

% --------------------------------------------------------------------
function NewDistortedCoulomb_Callback(hObject, eventdata, handles)
pos1=get(handles.sturm_liouville,'Position');
close(handles,false);
h=dist_coulomb;
pos2=get(h,'Position');
set(h,'Position',[pos1(1) pos1(2) pos2(3) pos2(4)]);
movegui(h,'onscreen');

% --------------------------------------------------------------------
function NewSturmLiouville_Callback(hObject, eventdata, handles)
pos = get(handles.sturm_liouville,'Position');
close(handles,false);
h=sturm_liouville;
set(h,'Position',pos);
movegui(h,'onscreen');

% --- Executes on button press in parameter_box.
function parameter_box_Callback(hObject, eventdata, handles)
if get(hObject,'Value') == get(hObject,'Max')
    set([handles.parameter_edit,handles.parameter_text],'Enable','On');
    set([handles.parameterName_edit,handles.parameterName_text],'Enable','On'); 
else
    set([handles.parameter_edit,handles.parameter_text],'Enable','Off');
    set([handles.parameterName_edit,handles.parameterName_text],'Enable','Off');
    set([handles.parameter_edit,handles.parameterName_edit],'String','');
end

% --- Executes on button press in stop_button.
function stop_button_Callback(hObject, eventdata, handles)
stop = 1;
save stop.mat stop;


% --------------------------------------------------------------------
function SaveItem_Callback(hObject, eventdata, handles)
d = pwd;
try
HelpPath = which('sturm_liouville.m');
[pathstr,name,ext] =fileparts(HelpPath);
cd(pathstr)
cd predefined_problems
catch
end
try
[FileName,PathName,FilterIndex]=uiputfile({'*.mat','MAT-files (*.mat)'},'Save problem as ...',handles.name);
if strcmp(FileName,'0') || strcmp(PathName,'0') || FilterIndex == 0
    cd(d);
    return;
end
p = get(handles.p_edit,'String');
if isempty(p)
    error('You should fill in all the fields');
end
q = get(handles.q_edit,'String');
if isempty(q)
    error('You should fill in all the fields');
end
w = get(handles.w_edit,'String');
if isempty(w)
    error('You should fill in all the fields');
end
a = get(handles.a_edit,'String');
if isempty(a)
    error('You must enter a numeric value for a');
end
b = get(handles.b_edit,'String');
if isempty(b)
    error('You must enter a numeric value for b');
end
a0 = get(handles.a0_edit,'String');
b0 = get(handles.b0_edit,'String');
a1 = get(handles.a1_edit,'String');
b1 = get(handles.b1_edit,'String');
if isempty(a0) || isempty(a1) || isempty(b0) || isempty(b1) 
    error('You must enter a numeric value for a0, b0 ,a1 ,b1');
end
tol = get(handles.tol_edit,'String');
if isempty(tol) 
    error('You must enter a positive numeric value for tol');
end
info = get(handles.problemInfo_edit,'String');
parameter = false;
if get(handles.parameter_box,'Value') == get(handles.parameter_box,'Max')
  parameter = true;  
  parameterValue = get(handles.parameter_edit,'String');
  parameterName = get(handles.parameterName_edit,'String');
  if isempty(parameterValue) || isempty(parameterName)
      error('You should fill in the parameterfields');
  end
end
file=fullfile(PathName,[FileName]);
type = 'sturm-liouville';
if parameter 
    save(file,'type','p','q','w','a','b','a0','b0','a1','b1','tol',...
        'parameter','parameterValue','parameterName','info');
else
    save(file,'type','p','q','w','a','b','a0','b0','a1','b1','tol','parameter','info');
end
catch
    errordlg(lasterr,'Error','modal');
end
cd(d);


% --- Executes on button press in plotpotential_button.
function plotpotential_button_Callback(hObject, eventdata, handles)
global gapp range_p range_n
try
if isfield(gapp,'potential_plot') && length(gapp.potential_plot)>=handles.number_matslise && ishandle(gapp.potential_plot(handles.number_matslise))
    try
       delete(gapp.potential_plot(handles.number_matslise));
    catch
    end
end
set([handles.construct_button,handles.exit_button,handles.plotpotential_button],'Enable','off');
set(handles.info_box,'String','Busy...');
set(handles.info_box,'Value',[]);
drawnow
if length(handles.cpm)==1
 sch = get(handles.cpm,'schrod');
 a = get(sch,'min'); % = Schrodinger x 
 b = get(sch,'max');
 V = get(sch,'V');
 V = char(V);
 if handles.halfrange_reduction
        a = -b;
 end
 if isa(sch,'transformed_slp')
    gapp.potential_plot(handles.number_matslise) = potential_plot_window('Name',handles.name ,...
        'a',a,'b',b,'V',V,'slp',1,'schrod',sch);
 else % voor als p=w=1
    gapp.potential_plot(handles.number_matslise) = potential_plot_window('Name',handles.name ,...
        'a',a,'b',b,'V',V,'slp',0,'schrod',sch); 
 end
elseif length(handles.cpm) >1
    noParamInAorB = true;
    s = get(handles.cpm(1),'schrod');
    at = get(s,'min');
    bt = get(s,'max'); 
    for i=1:length(handles.cpm)
      sch(i) = get(handles.cpm(i),'schrod');
      Vp{i} = char(get(sch(i),'V'));
      a(i) = get(sch(i),'min');
      b(i) = get(sch(i),'max');
      if at ~= a(i) ||  bt ~= b(i)
          noParamInAorB = false;
      end
      if handles.halfrange_reduction
        a(i) = -b(i);
      end
    end
    gapp.potential_plot(handles.number_matslise) = potential_plot_window('Name',handles.name ,...
         'a',a,'b',b,'V',Vp,'parameterName',char(range_n),'parameterValues',range_p,'Vparam','',...
         'slp',true,'schrod',sch,'noParamInAorB',noParamInAorB);
end
catch
    errordlg(lasterr,'Error','modal')
end
set([handles.construct_button,handles.exit_button,handles.plotpotential_button],'Enable','on');
set(handles.info_box,'String','Ready');
set(handles.info_box,'Value',[]);
guidata(hObject,handles)

%---------------------------------------------------------------------
function pvs = eval_parameterValues(s)
% used to distinguish between the parameter values
try
syms x;
chopped = 'tst';
i = 1;
remainder = s;
while any(remainder)
  [chopped,remainder] = strtok(s,',');
  if chopped(1) == '[' && any(remainder)
    [chopped2,remainder] = strtok(remainder,']');
    chopped = [chopped chopped2 ']'];
    pvs{i} = eval(chopped);
    if remainder == ']'
      remainder = '';    
    else
      remainder=remainder(2:end);
    end
  else
    pvs{i} = eval(chopped);
  end  
  i = i+1;
  s = remainder;
end
catch
    error('Error in the evaluation of the parameter values');
end

%-------------------------------------------------------------------
 function pns = eval_parameterNames(s)
 % used to distinguish between the parameter names
 remainder = s;
 pns =[];
 while any(remainder)
  [chopped,remainder] = strtok(remainder,',');
  pns = [pns,sym(chopped)];
end

%------------------------------------------------------------------
function close(handles,quest)
global gapp
if quest
selection = questdlg(['Close ' get(handles.sturm_liouville,'Name') '?'],...
                     ['Close ' get(handles.sturm_liouville,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end
end
close_problem(handles.number_matslise);
delete(handles.sturm_liouville)
gapp.number_problems = gapp.number_problems-1;
if gapp.number_problems == 0
       clear_gapp;
end


% --------------------------------------------------------------------
function HalfrangeReduction_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'Checked'),'off')
  check =check_symmetry2(handles) ;
  if check > 0
    set(hObject,'Checked','on');
    handles.halfrange_reduction = 1;
  elseif check < 0
      errordlg('The problem is not symmetric. Half-range reduction is not a good idea.','Error','modal');
      handles.halfrange_reduction = 0;
  end
else
  set(hObject,'Checked','off');  
  handles.halfrange_reduction = 0;
end
guidata(hObject,handles)

%---------------------------------------------------------------------
function symm=check_symmetry(p,q,w,a,b)
try
symm=1;
syms x;
if a ~= -b
    symm = -1;
    return
end
if isinf(a) && ~isinf(b)
    symm = -1;
    return;
end
if isinf(a) && isinf(b)
    a = -4;
    b = 4;
end
pot = inline(q);
if pot(b/2) ~= pot(-b/2)
    symm = -1;
    return
end
pot = inline(p);
if pot(b/2) ~= pot(-b/2)
    symm = -1;
    return
end
pot = inline(w);
if pot(b/2) ~= pot(-b/2)
    symm = -1;
    return
end
catch
end


%---------------------------------------------------------------------
function symm=check_symmetry2(handles)
try
symm = 1;
syms x;
p = get(handles.p_edit,'String');
q = get(handles.q_edit,'String');
w = get(handles.w_edit,'String');
if isempty(p) || isempty(q)|| isempty(w)
   return;
end
a = get(handles.a_edit,'String');
b = get(handles.b_edit,'String');
if isempty(a) || isempty(b)
    return;
end
parameter_range = false;
if get(handles.parameter_box,'Value') == get(handles.parameter_box,'Max')
  pp = get(handles.parameter_edit,'String');
  if isempty(pp)
      return;
  end
  pp=eval_parameterValues(pp);
  if ~isa(pp{1},'sym')
    if isnan(pp{1}) 
      errordlg('You must enter a numeric value or vector as parametervalue');
    end
  end
  pn = get(handles.parameterName_edit,'String');
  pns = eval_parameterNames(pn);
  if length(pns) ~= length(pp)
      errordlg('The number of parameternames must be equal to the number of parametervalues!')
  end
  range_p = [];
  for i=1:length(pns)
      if length(pp{i}) == 1
        p = subs(sym(p),pns(i),pp{i});
        w = subs(sym(w),pns(i),pp{i});
        q = subs(sym(q),pns(i),pp{i});
        a = subs(sym(a),pns(i),pp{i});
        b = subs(sym(b),pns(i),pp{i});
      else
          parameter_range = true;
           if isempty(range_p)
              range_p = pp{i};
              range_n = pns(i);
            else
                errordlg('only one of the parametervalues is allowed to be a vector!')
            end   
      end
  end
else
  a = eval(a);
  b = eval(b);  
end
if ~parameter_range
    p = char(p);
    q = char(q);
    w = char(w);
    a = eval(sym(a));
    b = eval(sym(b));
else
    symm = 0;
    return; % nog niet geimplementeerd
end
if a ~= -b
    symm = -1;
    return
end
if isinf(a) && ~isinf(b)
    symm = -1;
    return;
end
if isinf(a) && isinf(b)
    a = -4;
    b = 4;
end
pot = inline(q);
if pot(b/2) ~= pot(-b/2)
    symm = -1;
    return
end
pot = inline(p);
if pot(b/2) ~= pot(-b/2)
    symm = -1;
    return
end
pot = inline(w);
if pot(b/2) ~= pot(-b/2)
    symm = -1;
    return
end
catch
end


% --------------------------------------------------------------------
function ShowPartition_Callback(hObject, eventdata, handles)
if strcmp(get(hObject,'Checked'),'off')
  set(hObject,'Checked','on');
  handles.showBasicPartition = 1;
else
  set(hObject,'Checked','off');  
  handles.showBasicPartition = 0;
end
guidata(hObject,handles)


% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
About_msgbox;


% --- Executes when user attempts to close sturm_liouville.
function sturm_liouville_CloseRequestFcn(hObject, eventdata, handles)
close(handles,true);


function parameter_edit_Callback(hObject, eventdata, handles)
set(handles.plotpotential_button,'Enable','off');


function parameterName_edit_Callback(hObject, eventdata, handles)
set(handles.plotpotential_button,'Enable','off');


function a_edit_Callback(hObject, eventdata, handles)
set(handles.plotpotential_button,'Enable','off');


function b_edit_Callback(hObject, eventdata, handles)
set(handles.plotpotential_button,'Enable','off');


function q_edit_Callback(hObject, eventdata, handles)
set(handles.plotpotential_button,'Enable','off');


function p_edit_Callback(hObject, eventdata, handles)
set(handles.plotpotential_button,'Enable','off');


function w_edit_Callback(hObject, eventdata, handles)
set(handles.plotpotential_button,'Enable','off');


