%running matslise at the command line: example 2
%STLSTPAK #3, Klotter.mat

disp('*************************************************************************************')
disp('The Klotter problem: an example of a Sturm-Liouville problem not in Schrodinger form.')
disp('*************************************************************************************')

%specify a Sturm-Liouville problem:
s=slp('1','3/(4*x^2)','64*pi^2/(9*x^6)',8/7,8,1,0,1,0);
% first argument is p(x); second: q(x) and third: w(x)
% integration interval =[8/7,8]

%solve the sturm-liouville problem with the CPM{16,14} method:
cp=cpm16_14(s,1e-8);
% tolerance=1e-8

%calculate eigenvalues situated in the energy-range [10,20]:
E=get_eigenvalues(cp,10,20,false);
disp('Eigenvalues is the energy-range [10,20]:')
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' num2str(E.eigenvalues(i),'% 16.12f\t') '  ' num2str(E.errors(i),'%+5.2e')])
end
%compute an eigenfunction:
V=get_eigenfunction(cp,E.eigenvalues(1),45);
plot(V.x,V.y,'.:');
xlabel('x')
ylabel('y')
title('An eigenfunction of the Klotter problem')