%running matslise at the command line: example 3
%Hydrogen atom equation

disp('****************************************************')
disp('Hydrogen atom equation: a distorted Coulomb problem.')
disp('****************************************************')


%specify a distorted_coulomb problem
dc=distorted_coulomb(1,'-1','0',inf);

%Use the CPM{16,14} method and tol=1e-8
cp=cpm16_14(dc,1e-8);

%calculate the eigenvalues with indices between 0 and 5:
[E,cp]=get_eigenvalues(cp,0,5,true);
%cp contains now information on the truncated integration interval
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' num2str(E.eigenvalues(i),'% 16.12f\t') '  ' num2str(E.errors(i),'%+5.2e')])
end
%eigenfunction associated to second eigenvalue (plotted in 80 points):
V=get_eigenfunction(cp,E.eigenvalues(2),80);
plot(V.x,V.y);
xlabel('x');
ylabel('y');