%example5

disp('****************************')
disp('Harmonic oscillator problem.')
disp('****************************')

format long;

%define a Schrodinger problem (Harmonic oscillator)
sch=schrod('x^2',0,inf,1,0,1,0);

%Is this problem singular?
get(sch,'infostring')

%we will calculate the first 10 eigenvalues
emin=0;
emax=9;
indices=true;

%with this tolerance:
tol=1e-8;

%first with the CPM{12,10} method
cp = cpm12_10(sch,tol);
%calculate eigenvalues:
[E,cp]=get_eigenvalues(cp,emin,emax,indices);
%The reference_potential looks then like this:
plot_partition(cp);
disp('First 10 eigenvalues computed with the CPM{12,10} method:')
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' num2str(E.eigenvalues(i),'% 16.12f\t') '  ' num2str(E.errors(i),'%+5.2e')])
end

%with the CPM{14,12} method
cp= cpm14_12(sch,tol);
%calculate eigenvalues:
[E,cp]=get_eigenvalues(cp,emin,emax,indices);
%The reference_potential looks then like this:
plot_partition(cp);
disp('First 10 eigenvalues computed with the CPM{14,12} method:')
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' num2str(E.eigenvalues(i),'% 16.12f\t') '  ' num2str(E.errors(i),'%+5.2e')])
end

