%running matslise at the command line: example 7
%Mathieu problem

disp('**********************')
disp('Mathieu problem.')
disp('**********************')


%First we specify the problem:
r=schrod('2*cos(2*x)',0,pi,1,0,1,0);
%The schrod constructor is used, the first argument is a string
%representing the potential function, the second and third argument are
%the two endpoints of the integration interval and the last arguments
%specify the boundary conditions

%We want to solve the problem with the CPM{12,10} method.
%initialise the CPM{12,10}-method:
cp=cpm12_10(r,1e-10);
%We have chosen the tolerance to be 1e-10

plot_partition(cp);

%calculate the first 11 eigenvalues:
[E]=get_eigenvalues(cp,0,10,true); 
disp('First 11 eigenvalues of the Mathieu problem computed with CPM{12,10}:')
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' num2str(E.eigenvalues(i),'% 16.12f\t') '  ' num2str(E.errors(i),'%+5.2e')])
end


%We want to solve the problem with the CPM{14,12} method.
%initialise the CPM{14,12}-method:
cp=cpm14_12(r,1e-10);
%We have chosen the tolerance to be 1e-10

plot_partition(cp);

%calculate the first 11 eigenvalues:
[E]=get_eigenvalues(cp,0,10,true); 
disp('First 11 eigenvalues of the Mathieu problem computed with CPM{14,12}:')
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' num2str(E.eigenvalues(i),'% 16.12f\t') '  ' num2str(E.errors(i),'%+5.2e')])
end


%We want to solve the problem with the CPM{16,14} method.
%initialise the CPM{16,14}-method:
cp=cpm16_14(r,1e-10);
%We have chosen the tolerance to be 1e-10

plot_partition(cp);

%calculate the first 11 eigenvalues:
[E]=get_eigenvalues(cp,0,10,true); 
disp('First 11 eigenvalues of the Mathieu problem computed with CPM{16,14}:')
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' num2str(E.eigenvalues(i),'% 16.12f\t') '  ' num2str(E.errors(i),'%+5.2e')])
end




