%running matslise at the command line: example 8
%Coffey_Evans

disp('**********************')
disp('Coffey-Evans problem.')
disp('**********************')

%First we specify the problem:
r=schrod('-2*20*cos(2*x)+20^2*sin(2*x)^2',-pi/2,pi/2,1,0,1,0);
%The schrod constructor is used, the first argument is a string
%representing the potential function, the second and third argument are
%the two endpoints of the integration interval and the last arguments
%specify the boundary conditions

%We want to solve the problem with the CPM{16,14} method.
%initialise the CPM{16,14}-method:
cp=cpm16_14(r,1e-12);
%We have chosen the tolerance to be 1e-12
plot_partition(cp);



%calculate the first 11 eigenvalues:
E=get_eigenvalues(cp,0,10,true); 
disp('First 11 eigenvalues of the Coffey-Evans problem:')
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' ...
        num2str(E.eigenvalues(i),'%16.12f\t') '  '...
        num2str(E.errors(i),'%+5.2e')])
end

%eigenfunction associated to eigenvalue y_4, evaluated in 100 points:
V=get_eigenfunction(cp,E.eigenvalues(5),100);
figure;
plot(V.x,V.y);
xlabel('x')
ylabel('y')
title('an eigenfunction of the Coffey-Evans problem')

%calculate some other eigenvalues:
E=get_eigenvalues(cp,1000,1500,false); 
disp('Eigenvalues found in the energy-range [1000,1500]:')
disp(sprintf('k \t  E_k \t\t\t\t  estimated error'))
for i=1:length(E.eigenvalues)
    disp([num2str(E.indices(i),'%4.0f\t') '  ' ...
        num2str(E.eigenvalues(i),'% 16.12f\t') '  '...
        num2str(E.errors(i),'%+5.2e')])
end