function showPredefinedProblems
%showPredefinedProblems: makes a list of all problems in the
%predefined_problems directory
disp(' ')
files=dir(fullfile('.','GUI/predefined_problems/distorted_Coulomb/finite_interval/*.mat'));
for i=1:length(files)
  directory{i}='/distorted_Coulomb/finite_interval';
  names{i}=lower(files(i).name);
end
t=length(directory);
files=dir(fullfile('.','GUI/predefined_problems/distorted_Coulomb/infinite_interval/*.mat'));
for i=t+1:t+length(files)
  directory{i}='/distorted_Coulomb/infinite_interval';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/distorted_Coulomb/parameter_problems/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/distorted_Coulomb/parameter_problems';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/Schrodinger/parameter_problems/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/Schrodinger/parameter_problems';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/Schrodinger/infinite_interval/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/Schrodinger/infinite_interval';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/Schrodinger/finite_interval/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/Schrodinger/regular';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/Schrodinger/finite_interval/close_eigenvalues/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/Schrodinger/regular/close_eigenvalues';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/Schrodinger/infinite_interval/close_eigenvalues/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/Schrodinger/infinite_interval/close_eigenvalues';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/Sturm-Liouville/finite_interval/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/Sturm-Liouville/regular';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/Sturm-Liouville/parameter_problems/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/Sturm-Liouville/parameter_problems';
  names{i}=lower(files(i-t).name);
end
files=dir(fullfile('.','GUI/predefined_problems/Sturm-Liouville/infinite_interval/*.mat'));
t=length(directory);
for i=t+1:t+length(files)
  directory{i}='/Sturm-Liouville/infinite_interval';
  names{i}=lower(files(i-t).name);
end

[names,directory]=sort_names(names,directory);
for i=1:length(names)
    disp(sprintf('%s  (%s)',names{i},directory{i}))
end


function [names,directory]=sort_names(names,directory)
for i=1:length(names)
  for j=1:length(names)-i 
      len=min(length(names{j+1}),length(names{j}));
      a=names{j+1};
      b=names{j};
      t = a(1:len) < b(1:len);
      asmb = false;
      for k=1:length(t)
          if t(k) == 1
              asmb = true;
              break;
          elseif a(k) > b(k)
              asmb = false;
              break;
          end
      end
      if asmb
        hlp = names{j};   
        hlp2 = directory{j};
        names{j} = names{j+1};
        directory{j}=directory{j+1};
        names{j+1} = hlp;
        directory{j+1} = hlp2;
      end
  end
end