function sch = cpm(varargin)
%CPM class constructor
% sch = cpm(schrod/slp,tol)
%
% schrod/slp    - Schrod_object or slp-object
% tol           - positive DP constant representing the accuracy requested
%
% CPM is a parent class. The user should use the derived classes (cpm12_10, cpm14_12, ...)
stop = 0;
save stop.mat stop;
sch=struct([]);
switch nargin
case 0
    % if no input arguments, create a default object
   parent = ppm(schrod,10^(-5));
   sch = class(sch,'cpm',parent);
case 1  
    %copy-constructor
 if isa(varargin{1},'cpm')
     sch  = varargin{1};
 else
     disp('Input argument is not a cpm-object')
 end
case 2
    parent = ppm(varargin{1},varargin{2});
    sch = class(sch,'cpm',parent);
otherwise
    error('Wrong number of input arguments')
end;