function varargout = get_ppm(varargin)
%CPM\GET 
% get_ppm(cpm_child,prop_name,additional input arguments)
global cpm_child schrod_object
cpm_child=varargin{1};
schrod_object=get(cpm_child,'schrod');
prop_name=varargin{2};
switch prop_name 
case 'prufer'
    varargout{1}=locate_eigenvalue(varargin{3:end});    
case 'eigenvalues'    
    varargout{1} = calculate_eigenvalues(varargin{3:end});
case 'eigenvalues_singular'    
    varargout{1} = calculate_eigenvalues_singular(varargin{3:end});           
case 'partitions'
    [varargout{1},varargout{2},varargout{3},varargout{4}]=calculate_partitions(cpm_child,varargin{3:end});
case 'partition' 
    varargout{1} = get_partition(varargin{3:end});
case 'propagation_matrices'
    [varargout{1},varargout{2}]=get_propagation_matrices(varargin{3:end});    
case 'regular_problem'
    varargout{1}=get_regular_problem(cpm_child,varargin{3:end});     
case 'partition_plot' 
    plot_partition; 
case 'init_conditions' 
    if nargout==2
        [varargout{1},varargout{2}]=get_initConditions(varargin{3:end});     
    elseif nargout==5
        [varargout{1},varargout{2},varargout{3},varargout{4},varargout{5}]=get_initConditions(varargin{3:end});     
    else
        [varargout{1},varargout{2},varargout{3},varargout{4},varargout{5},varargout{6}]=get_initConditions(varargin{3:end});     
    end
otherwise
    error([prop_name,' Is not a valid property of a cpm-object'])
end