function [h,V0,V] = get_step(xmin,trial_h,hmax,tol)
% @CPM\GET_STEP
% [h,V0,V] = get_step(xmin,trial_h,hmax)
% for give_n xmin, an upper limit for the stepsize (hmax),
% this calculates the stepsize h consistent with the tolerance tol
% and also furnishes the values of Vbar_i on the interval [xmin,xmin+h].

global cpm_child

delta = 1; 
h = trial_h;
prev_h = 0;
it = 0;
while delta > 0.1 && it < 20
    it = it +1;
    if mod(it,3)==0
      pause(1e-200) % stop the calculation in the GUI?
      load stop; 
      if stop
       error('The calculation was interrupted');
      end
    end
    h = min(h,hmax);
    if h==hmax && prev_h==hmax
        break;
    end
    [V0,V] = calculate_V(xmin,h);
    if isinf(V0)
      error('This problem can''t be solved: The intervals can''t be taken small enough');
    end
    prev_h = h;
    [e_loc,m] = get_error(cpm_child,V);
    hnew = 10*h;
    if(e_loc > eps) 
        hnew = h * (tol / e_loc)^(1/m);
    end
    quo = hnew/h;
    h = hnew;
    delta = abs(quo - 1);
end
if it<20 
  h = prev_h;
elseif h<prev_h
  [V0,V] = calculate_V(xmin,h);  
else
  h = prev_h;
end


