#include "mex.h"
#include "math.h"

#define	IN1	prhs[0]
#define	IN2	prhs[1]

/* Output Arguments */
#define	OUT1	plhs[0]


void mexFunction(int nlhs, mxArray *plhs[], int nrhs,
                 const mxArray *prhs[])
{
  double p;
  double *gammam;
  double *res;
  int mrows;
  
  mrows = mxGetN(prhs[0]); 
  
  gammam = mxGetPr(IN1);
  p =mxGetScalar(IN2);
  
  /* Create a matrix for the return argument */ 
  OUT1 = mxCreateDoubleMatrix(mrows, p+1, mxREAL); 
  
  res = mxGetPr(OUT1);
  
  /* Call the timestwo subroutine. */
  legendre(gammam,mrows,p,res);
  return;
  
}


void legendre(double *gammam,int mrows, double p,double *res)
{
    int i,j;
    double x,gamma;

    for (j = 0; j < mrows; j++){   //pas op arrays vanaf 0
     gamma=gammam[j];
     *(res+j) = 1;
     *(res+mrows+j) = -1 + 2*gamma;
     x = 2* gamma -1;
     for (i = 1; i < p; i++){
       *(res+(i+1)*mrows+j) = ((2*i+1)*x* (*(res+i*mrows+j))-i* (*(res+(i-1)*mrows+j)))/(i+1);
     }
    }
}

