function plot_partition
% makes a plot of the partition
global cpm_child
schrod=get(cpm_child,'schrod');
a=get(schrod,'min');
b=get(schrod,'max');
if isinf(a) || isinf(b)
    error('PLOT_PARTITION: Sorry, The partition can not be plotted for a problem with an infinite integration interval');
end
V=get(schrod,'V');
step = min(abs(b-a)/100,0.05);
while (b-a)/step >10000
    step=step*2;
end
w = a:step:b;
if isa(schrod,'transformed_slp')
   r= x2r(schrod,w);
   Y=V(r);
else
   Y=V(w);  
end
YY=Y;
bp=get(cpm_child,'bp');
x = [a a + cumsum(bp.h)];
legendStr{1} = 'meshpoints';
figure;
my=min(YY);
phandles= plot(x,my*ones(1,length(x)),'bo','MarkerSize',5,'MarkerFaceColor','b');
hold on;
legendStr{2} = 'x_{match}';
phandles = [phandles plot(x(bp.imatch+1),my,'rs','MarkerSize',5,'MarkerFaceColor','r')];
phandles = [phandles plot(w,YY,'k:')];
legendStr{3} = 'V(x)';
legendStr{4} = 'V_0';
cvbar=[];
cx=[];
for i=1:length(bp.V0)
   cx=[cx x(i) x(i+1)];
   cvbar=[ cvbar bp.V0(i) bp.V0(i)];
end
phandles= [phandles plot(cx,cvbar,'b')];
hold off;
legend(phandles(1:end),legendStr,'Location','Best');
xlabel('x');
if isa(schrod,'transformed_slp');
    title('The reference potential function of the associated Schrodinger problem');
else
  title('The reference potential function + the meshpoints of the partition');
end
axis 'tight'; 