function [cp] = cpm12_10(varargin)
%CPM12_10 class constructor
% cp = cpm12_10(slp/regular_schrod,tol)
% cp = cpm12_10(distorted_coulomb,tol)
cp.p=10;
cp.q=12;
cp.bp=0;
cp.rp=0;
cp.Vmin=0;
cp.Vmax=0;
cp.truncated=false;
cp.singular_min=false;
cp.singular_max=false;
cp.ref_cpm=0;
switch nargin
 case 0
    % if no input arguments, create a default object
   parent = cpm(schrod('x',0,1),10^(-5));
   cp = class(cp,'cpm12_10',parent);
case 1   
    % copy-constructor
   if isa(varargin{1},'cpm12_10')
     cp = varargin{1};
   else
     disp('Input argument is not a cpm12_10 object')
   end
case 2
    if isa(varargin{1},'slp')
       tr = Liouvilletransform(varargin{1});
       parent = cpm(tr,varargin{2});
    elseif isa(varargin{1},'schrod')
       parent = cpm(varargin{1},varargin{2});
    else 
       error('first argument must be schrod- or slp-object')
    end
    cp.ref_cpm = cpm14_12;
    cp = class(cp,'cpm12_10',parent);
    [cp.bp,cp.rp,cp.Vmin,cp.Vmax] = get_ppm(cp,'partitions');
otherwise
    error('cpm12_10: Wrong number of input arguments')
end
