function [cp,varargout] = cpm16_14(varargin)
%CPM16_14 class constructor
% cp = cpm16_14(slp/schrod,tol)
% cp = cpm16_14(distorted_coulomb,tol)
global nfev slfev
cp.p=14;
cp.q=16;
cp.bp=0;
cp.rp=0;
cp.Vmin=0;
cp.Vmax=0;
cp.ref_cpm = 0;
cp.truncated=false;
nfev = 0;
slfev = 0;
switch nargin
 case 0
    % if no input arguments, create a default object
   parent = cpm(schrod('x',0,1),10^(-5));
   cp = class(cp,'cpm16_14',parent);
case 1   
    % copy-constructor
   if isa(varargin{1},'cpm16_14')
     cp = varargin{1};
   else
     disp('Input argument is not a cpm16_14 object')
   end
case 2
    if isa(varargin{1},'slp')  
       stat.lt_time = cputime; 
       tr = Liouvilletransform(varargin{1});
       stat.number_intervals_sl = length(get(tr,'rG'));
       stat.lt_time = cputime - stat.lt_time; 
       parent = cpm(tr,varargin{2});
       stat.slfev = slfev;
    elseif isa(varargin{1},'schrod')
       parent = cpm(varargin{1},varargin{2});
    else 
       error('first argument must be schrod- or slp-object')
    end
    cp.ref_cpm = cpm18_16;
    cp = class(cp,'cpm16_14',parent);
    time = cputime;
    [cp.bp,cp.rp,cp.Vmin,cp.Vmax] = get_ppm(cp,'partitions');
    time = cputime -time;
otherwise
    error('cpm16_14: Wrong number of input arguments')
end
if nargout > 1
    if isempty(cp.bp)
        stat.number_intervals_bp = 0;
    else
        stat.number_intervals_bp = length(cp.bp.h);
    end
   stat.part_time = time;
   stat.nfev = nfev;
   varargout{1} = stat;
end