function schcp = set(schcp,varargin)
% SET Set properties and return the updated cpm-object
property_argin = varargin;
while length(property_argin) >= 2,
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    switch prop
    case 'p'
        schcp.p = val;
    case 'q'
        schcp.q = val;
    case 'cpm'
        schcp.cpm = val;
    case 'bp'
        schcp.bp = val;
    case 'rp'
        schcp.rp = val;
    case 'Vmin'
        schcp.Vmin = val;
    case 'Vmax'
        schcp.Vmax = val;
    case 'truncated'
        schcp.truncated = val;        
    case 'schrod'
        schrod=get(schcp,'schrod');
        schcp.cpm = set(schcp.cpm,'schrod',val);
        if strcmp(char(get(val,'V')),char(get(schrod,'V'))) && ( ~isa(schrod,'distorted_coulomb') && get(schrod,'a0') == get(val,'a0') &&...
                get(schrod,'a1') == get(val,'a1') && get(schrod,'b0') == get(val,'b0') && get(schrod,'b1') == get(val,'b1') )&&...
             get(schrod,'max') > get(val,'min') && get(schrod,'min') < get(val,'max') && ~isempty(schcp.bp)
            [schcp.bp,schcp.rp,schcp.Vmin,schcp.Vmax]=...
                        get_ppm(schcp,'partitions',schcp.bp,schcp.rp,get(schrod,'min'),get(schrod,'max'));        
        else %everything changes --> partition has to be recalculated
          [schcp.bp,schcp.rp,schcp.Vmin,schcp.Vmax]=get_ppm(schcp,'partitions');
        end
    case 'tol'
        schcp.cpm = set(schcp.cpm,'tol',val);   
        [schcp.bp,schcp.rp,schcp.Vmin,schcp.Vmax,schcp.inf_min,schcp.inf_max]=...
            get_ppm(schcp,'partitions');
    otherwise
        error('CPM16_14 properties: schrod, tol, p, q, cpm, bp, rp, Vmin, Vmax, inf_min, inf_max')
    end
end