function [cp] = cpm18_16(varargin)
%CPM18_16 class constructor
% cp = cpm18_16(slp/regular_schrod,tol)
% cp = cpm18_16(distorted_coulomb,tol)
cp.p=16;
cp.q=18;
cp.bp=0;
cp.rp=0;
cp.Vmin=0;
cp.Vmax=0;
cp.ref_cpm = 0;
cp.truncated=false;
cp.singular_min=false;
cp.singular_max=false;
switch nargin
 case 0
    % if no input arguments, create a default object
   parent = cpm(schrod('x',0,1),10^(-5));
   cp = class(cp,'cpm18_16',parent);
case 1   
    % copy-constructor
   if isa(varargin{1},'cpm18_16')
     cp = varargin{1};
   else
     disp('Input argument is not a cpm18_16 object')
   end
case 2
    if isa(varargin{1},'slp')
       tr = Liouvilletransform(varargin{1});
       parent = cpm(tr,varargin{2});
    elseif isa(varargin{1},'schrod')
       parent = cpm(varargin{1},varargin{2});
    else 
       error('first argument must be schrod- or slp-object')
    end
    cp.ref_cpm = cpm16_14; 
    cp = class(cp,'cpm18_16',parent);
    [cp.bp,cp.rp,cp.Vmin,cp.Vmax]= get_ppm(cp,'partitions');
otherwise
    error('cpm18_16: Wrong number of input arguments')
end
