function varargout = get_ppm(varargin)
%LPM\GET 
% get(cpm_child,prop_name,additional input arguments)
global lpm_child schrod_object
lpm_child=varargin{1};
schrod_object=get(lpm_child,'schrod');
prop_name=varargin{2};
switch prop_name 
case 'prufer'
    varargout{1}=locate_eigenvalue(varargin{3:end});     
case 'eigenvalues'    
    varargout{1} = calculate_eigenvalues(varargin{3:end});
case 'partitions'
    [varargout{1},varargout{2},varargout{3},varargout{4}]=calculate_partitions(lpm_child,varargin{3:end});
case 'partition' 
    varargout{1} = get_partition(varargin{3:end});
case 'propagation_matrices'
    if nargout == 2
    [varargout{1},varargout{2}]=get_propagation_matrices(varargin{3:end});    
    else
     varargout{1}=get_propagation_matrices(varargin{3:end});       
    end
case 'regular_problem'
    varargout{1}=get_regular_problem(lpm_child,varargin{3:end}); 
case 'partition_plot' 
    plot_partition;  
case 'init_conditions' 
    if nargout==2
        [varargout{1},varargout{2}]=get_initConditions(varargin{3:end});     
    elseif nargout==5
        [varargout{1},varargout{2},varargout{3},varargout{4},varargout{5}]=get_initConditions(varargin{3:end});     
    else
        [varargout{1},varargout{2},varargout{3},varargout{4},varargout{5},varargout{6}]=get_initConditions(varargin{3:end});     
    end    
otherwise
    error([prop_name,' Is not a valid property of a lpm-object'])
end