function sch = lpm(varargin)
%LPM class constructor
% sch = lpm(schrod/slp,tol)
%
% schrod/slp    - Schrod_object or slp-object
% tol           - positive DP constant representing the accuracy requested
%
% LPM is a parent class. The user should use the derived classes 
sch=struct([]);
switch nargin
case 0
    % if no input arguments, create a default object
   parent = ppm(schrod,10^(-5));
   sch = class(sch,'lpm',parent);
case 1  
    %copy-constructor
 if isa(varargin{1},'lpm')
     sch  = varargin{1};
 else
     disp('Input argument is not a lpm-object')
 end
case 2
    parent = ppm(varargin{1},varargin{2});
    sch = class(sch,'lpm',parent);
otherwise
    error('Wrong number of input arguments')
end;