function [h,V0,V] = get_step(xmin,trial_h,hmax,tol)
% @LPM\GET_STEP
% for give_n xmin, an upper limit for the stepsize (hmax),
% this calculates the stepsize h consistent with the tolerance tol
% and also furnishes the values of Vbar_i on the interval [xmin,xmin+h].

global lpm_child

delta = 1; 
h = trial_h;
prev_h = 0;
it = 0;
while delta > 0.1 && it < 20
    it = it +1;
    h = min(h,hmax);
    if h==hmax && prev_h==hmax
        break;
    end
    [V0,V] = calculate_V(xmin,h);
    if isinf(V0)
      error('This problem can''t be solved: The intervals can''t be taken small enough');
    end
    prev_h = h;
    z=pi^2/h^2;
    [e_loc,m] = get_error(lpm_child,V,h,z); 
    hnew = 10*h;
    if(e_loc > eps) 
        hnew = h * (tol / e_loc)^(1/m);
    end
    quo = hnew/h;
    h = hnew;
    delta = abs(quo - 1);
end
if it<20 
  h = prev_h;
elseif h<prev_h
  [V0,V] = calculate_V(xmin,h);  
else
  h = prev_h;
end