function plot_partition
%makes a plot of the partition
global lpm_child
schrod=get(lpm_child,'schrod');
a=get(schrod,'min');
b=get(schrod,'max');
if isinf(a) || isinf(b)
    error('PLOT_PARTITION: Sorry, the partition can not be plotted for a problem with an infinite integration interval');
end
V=get(schrod,'V');
step = min(abs(b-a)/100,0.05);
while (b-a)/step >10000
     step=step*2;
end
w = a:step:b;
if isa(schrod,'transformed_slp')
    r = x2r(schrod,w);
    Y= V(r);
else
  Y = V(w);  
end
YY=Y;
bp=get(lpm_child,'bp');
v0=bp.V0;
v=bp.V;
f0=v0-v(1,:).*bp.h;
f1=2*v(1,:);
x = [a a + cumsum(bp.h)];
legendStr{1} = 'meshpoints';
my=min(YY);
figure;
phandles= plot(x,my*ones(1,length(x)),'bo','MarkerSize',5,'MarkerFaceColor','b');
hold on;
legendStr{2} = 'x_{match}';
phandles = [phandles plot(x(bp.imatch+1),my,'rs','MarkerSize',5,'MarkerFaceColor','r')];
phandles = [phandles plot(w,YY,'k:')];
legendStr{3} = 'V(x)';
legendStr{4} = 'V_{ref}';
xs=[a];
ys=[f0(1)];
for i=1:length(bp.h)-1
   xe=xs(end)+bp.h(i); 
   y=f0(i)+f1(i)*bp.h(i); 
   xs=[xs xe];
   ys=[ys y];
    y=f0(i+1); 
    xs=[xs xe];
    ys=[ys y];
end
xe=xs(end)+bp.h(end); 
y=f0(end)+f1(end)*bp.h(end); 
xs=[xs xe];
ys=[ys y];
phandles= [phandles plot(xs,ys,'b')];
hold off;
legend(phandles(1:end),legendStr,'Location','Best');
xlabel('x');
if isa(schrod,'transformed_slp');
    title('The reference potential function of the associated Schrodinger problem');
else
  title('The reference potential function + the meshpoints of the partition');
end
axis 'tight'; 