function lp = lpm10(varargin)
%LPM10 class constructor
% lp = lpm10(slp/regular_schrod,tol)
% lp = lpm10(distorted_coulomb,tol,rmax)
lp.N=4;
lp.Q=2;
lp.bp=0;
lp.rp=0;
lp.Vmin=0;
lp.Vmax=0;
lp.emin=0;
lp.emax=0;
lp.truncated=false;
lp.schrod=[];
switch nargin
 case 0
    % if no input arguments, create a default object
   parent = lpm(schrod('x',0,1),10^(-5));
   lp = class(lp,'lpm10',parent);
case 1   
    % copy-constructor
   if isa(varargin{1},'lpm10')
     lp = varargin{1};
   else
     disp('Input argument is not a lpm42 object')
   end
case 2
    var1=varargin{1};
    if isa(var1,'slp')
       tr = Liouvilletransform(varargin{1});
       var1=tr;
       parent = lpm(tr,varargin{2});
    elseif isa(var1,'schrod')
       parent = lpm(varargin{1},varargin{2});
    else 
       error('first argument must be schrod- or slp-object')
    end
    lp = class(lp,'lpm10',parent);
    a=get(var1,'min');
    b=get(var1,'max');
    V=get(var1,'V');
    va=V(a);
    vb=V(b);
    vc=V((a+b)/2);
    vd=V((a+b)*0.25);
    ve=V((a+b)*0.75);
    lp.emin=min([va,vb,vc,vd,ve]); 
    lp.emax=max([va,vb,vc,vd,ve]); 
    try
     c=get(var1,'classification');
     lp.emax=max(lp.emax,c.cutoff);
    catch
    end
    [lp.bp,lp.rp,lp.Vmin,lp.Vmax] = get_ppm(lp,'partitions');
case 3
    if ~isa(varargin{1},'distorted_coulomb')
        error('lpm42: distorted_coulomb expected')
    end
    c = distorted_coulomb_cpm(varargin{1},varargin{3},15); 
    parent = lpm(c,varargin{2});
    lp = class(cp,'lpm10',parent);
    [lp.bp,lp.rp,lp.Vmin,lp.Vmax] = get_ppm(lp,'partitions');
otherwise
    error('lpm42: Wrong number of input arguments')
end
