function p = ppm(varargin)
%PPM class constructor
% p = ppm(schrod/slp,tol)
%
% schrod/slp    - Schrod_object or slp-object
% tol           - positive DP constant representing the accuracy requested
%
% PPM is a parent class. The user should use the derived classes (cpm12_10, cpm14_12, ...lpm10)

switch nargin
case 0
    % if no input arguments, create a default object
   p.schrod = schrod;
   p.tol = 10^(-8);
   p= class(sch,'ppm');
case 1  
    %copy-constructor
 if isa(varargin{1},'ppm')
     p  = varargin{1};
 else
     disp('Input argument is not a ppm-object')
 end
case 2
    p.schrod = varargin{1};
    p.tol = varargin{2};
    p = class(p,'ppm');
otherwise
    error('Wrong number of input arguments')
end;