function [s]=print_endpoint_info(c,a,b)
%returns classification information
n=sprintf('\n');
switch c.category
    case 1
        s=['The spectrum is simple, purely discrete and bounded below.'];
        s=[s n 'There is no continuous spectrum.'];
        s= [s n n 'At endpoint A'];
        if c.err(1)==1
            s=[s n ' classification of the endpoint is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        if c.regular(1)
           s= [s n '   The problem is regular.'];
        else
           s= [s n '   The problem is singular.'];
           s=[s n '   It is nonoscillatory for all eigenvalues.'];
           if c.limit_circle(1)>-1 
             if c.limit_circle(1)
              s= [s n '   It is limit circle.'];
             else
              s= [s n '   It is limit point.']; 
             end
           end
           s =[s n '   The Friedrichs boundary conditions are ' num2str(c.bcs(1)) 'y(a)+ ' num2str(c.bcs(2)) 'y''(a)=0'];
           %friedrichs c.bcs
        end
        s= [s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        if c.regular(2)
           s= [s n '   The problem is regular.'];
        else
           s= [s n '   The problem is singular.'];
           s=[s n '   It is nonoscillatory for all eigenvalues.'];
           if c.limit_circle(2)>-1 
             if c.limit_circle(2)
              s= [s n '   It is limit circle.'];
             else
               s= [s n '   It is limit point.']; 
             end
           end
           s =[s n '   The Friedrichs boundary conditions are ' num2str(c.bcs(3)) 'y(b)+ ' num2str(c.bcs(4)) 'y''(b)=0'];
        end
           %friedrichs c.bcs
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 2
        s='The spectrum is simple and bounded below.';
        s=[s n 'There is a continuous spectrum in [' num2str(c.cutoff) ', infinity].'];
        if c.lastev == -5
            s=[s n 'There appear to be infinitely many eigenvalues below the start of the continuous spectrum.'];
        elseif c.lastev == 0
            s =[s n 'There appear to be no eigenvalues below the start of the continuous spectrum.'];
        elseif c.lastev == 1
            s=[s n 'There appears to be 1 eigenvalue below the start of the continuous spectrum.'];
        else
            s=[s n 'There appear to be ' num2str(c.lastev) ' eigenvalues below the start of the continuous spectrum.'];
        end
        s= [s n n  'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        if c.regular(1)
           s= [s n '   The problem is regular.'];
        else
           s= [s n '   The problem is singular.'];
           if c.cont_spectrum(1)
               s=[s n '   It is nonoscillatory for eigenvalues < ' num2str(c.cev(1)) ' and oscillatory otherwise.'];
           else
               s=[s n '   It is nonoscillatory for all eigenvalues.'];
               s =[s n '   The Friedrichs boundary conditions are ' num2str(c.bcs(1)) 'y(a)+ ' num2str(c.bcs(2)) 'y''(a)=0'];
           end
           if c.limit_circle(1)>-1 
            if c.limit_circle(1)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
           end
        end
        s= [s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification of the endpoint is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        if c.regular(2)
           s= [s n '   The problem is regular.'];
        else
           s= [s n '   The problem is singular.'];
           if c.cont_spectrum(2)
               s=[s n '   It is nonoscillatory for eigenvalues < ' num2str(c.cev(2)) ' and oscillatory otherwise.'];
           else
               s=[s n '   It is nonoscillatory for all eigenvalues.'];
               s =[s n '   The Friedrichs boundary conditions are ' num2str(c.bcs(3)) 'y(b)+ ' num2str(c.bcs(4)) 'y''(b)=0'];
           end
           if c.limit_circle(2)>-1 
            if c.limit_circle(2)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
           end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 3
        s='The spectrum is simple';
        s= [s n 'There are infinitely many negative and infinitely many positive eigenvalues.'];
        s=[s n 'There is no continuous spectrum'];
        s= [s n n  'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification of the endpoint is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        if c.regular(1)
           s= [s n '   The problem is regular.'];
        else
           s= [s n '   The problem is singular.'];
           if c.oscillatory(1)
               s=[s n '   It is oscillatory for all eigenvalues.'];
           else
               s=[s n '   It is nonoscillatory for all eigenvalues.'];
           end
           if c.limit_circle(1)>-1 
            if c.limit_circle(1)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
           end
        end
        s= [s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        if c.regular(2)
           s= [s  n '   The problem is regular.'];
        else
           s= [s n '   The problem is singular.'];
           if c.oscillatory(2)
               s=[s n '   It is oscillatory for all eigenvalues.'];
           else
               s=[s n '   It is nonoscillatory for all eigenvalues.'];
           end
           if c.limit_circle(2)>-1 
            if c.limit_circle(2)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
           end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
    case 4
        s='The spectrum is simple.';
        s=[s n 'There is a continuous spectrum consisting of the entire real line.'];
        s= [s n n  'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        if c.regular(1)
           s= [s  n '   The problem is regular.'];
        else
           s= [s n '   The problem is singular.'];
           if c.oscillatory(1)
               s=[s n '   It is oscillatory for all eigenvalues.'];
           else
               s=[s n '   It is nonoscillatory for all eigenvalues.'];
           end
           if c.limit_circle(1)>-1 
            if c.limit_circle(1)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
           end
        end
        s= [s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        if c.regular(2)
           s= [s  n '   The problem is regular.'];
        else
           s= [s n '   The problem is singular.'];
           if c.oscillatory(2)
               s=[s n '   It is oscillatory for all eigenvalues.'];
           else
               s=[s n '   It is nonoscillatory for all eigenvalues.'];
           end
           if c.limit_circle(2)>-1 
            if c.limit_circle(2)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
           end
        end 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 5
        s='The spectrum is simple.';
        s=[s n 'There are infinitely many negative and infinitely many positive eigenvalues.'];
        s=[s n 'There is no continuous spectrum'];
        s= [s n n  'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s= [s n '   The problem is singular.'];
        s=[s n '   It is oscillatory for all eigenvalues.'];
        s= [s n '   It is limit circle.'];
        s= [s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s= [s n '   The problem is singular.'];
        s=[s n '   It is oscillatory for all eigenvalues.'];
        s= [s n '   It is limit circle.'];
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 6
        s='The nature of the spectrum is unknown. There is likely to be a continuous spectrum.';
        s= [s n n  'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s= [s n '   The problem is singular.'];
        s=[s n '   It is oscillatory for all eigenvalues.'];
        s= [s n '   It is limit point.'];
        s= [s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s= [s n '   The problem is singular.'];
        s=[s n '   It is oscillatory for all eigenvalues.'];
        s= [s n '   It is limit point.'];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 7
        s=['There is a continuous spectrum consisting of the entire real line'];
        s= [s n n  'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s= [s n '   The problem is singular.'];
        s=[s n '   It is oscillatory for all eigenvalues.'];
        if c.limit_circle(1)>-1 
            if c.limit_circle(1)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
        end
        s= [s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s= [s n '   The problem is singular.'];
        s=[s n '   It is oscillatory for all eigenvalues.'];
        if c.limit_circle(2)>-1 
            if c.limit_circle(2)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
        end
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 8
        s='The spectrum is simple.';
        s=[s n 'There is a continuous spectrum in [' num2str(c.cutoff) ', infinity].'];
        s=[s n 'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s=[s n '   The problem is singular.'];
        if c.cont_spectrum(1)
            s=[s n '   It is nonoscillatory for eigenvalues < ' num2str(c.cev(1)) ' and oscillatory otherwise.'];
        else
            s=[s n '   It is oscillatory for all eigenvalues.'];
        end
        if c.limit_circle(1)>-1 
            if c.limit_circle(1)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
        end
        s=[s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s=[s n '   The problem is singular.'];
        if c.cont_spectrum(2)
            s=[s n '   It is nonoscillatory for eigenvalues < ' num2str(c.cev(2)) ' and oscillatory otherwise.'];
        else
            s=[s n '   It is oscillatory for all eigenvalues.'];
        end
        if c.limit_circle(2)>-1 
            if c.limit_circle(2)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 9
        s='This problem may have non-simple spectrum.';
        s=[s n 'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s=[s n '   The problem is singular.'];
        if c.cont_spectrum(1)
            s=[s n '   It is nonoscillatory for eigenvalues < ' num2str(c.cev(1)) ' and oscillatory otherwise.'];
        else
            s=[s n '   It is oscillatory for all eigenvalues.'];
        end
        if c.limit_circle(1)>-1 
            if c.limit_circle(1)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
        end
        s=[s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end 
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s=[s n '   The problem is singular.'];
        if c.cont_spectrum(2)
            s=[s n '   It is nonoscillatory for eigenvalues < ' num2str(c.cev(2)) ' and oscillatory otherwise.'];
        else
            s=[s n '   It is oscillatory for all eigenvalues.'];
        end
        if c.limit_circle(2)>-1 
            if c.limit_circle(2)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 10
        s='This problem may have non-simple spectrum';
        s=[s n 'There is a continuous spectrum in [' num2str(c.cutoff) ', infinity].'];
        if c.lastev == -5
            s=[s n 'There appear to be infinitely many eigenvalues below the start of the continuous spectrum.'];
        elseif c.lastev == 0
            s =[s n 'There appear to be no eigenvalues below the start of the continuous spectrum.'];
        elseif c.lastev == 1
            s=[s n 'There appears to be 1 eigenvalue below the start of the continuous spectrum.'];
        else
            s=[s n 'There appear to be ' num2str(c.lastev) ' eigenvalues below the start of the continuous spectrum.'];
        end
        s=[s n 'At endpoint A'];
        if c.err(1)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(a)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(1)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(1)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(1)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(1)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s=[s n '   The problem is singular.'];
        s=[s n '   It is nonoscillatory for eigenvalues < ' num2str(c.cev(1)) ' and oscillatory otherwise.'];
        if c.limit_circle(1)>-1 
            if c.limit_circle(1)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
        end
        s=[s n 'At endpoint B'];
        if c.err(2)==1
            s=[s n '   Warning: q(x) is not well approximated by a power potential, classification is uncertain!'];
            if isinf(b)
              s=[s n '   Oscillatory potential function'];
            end
        end
        if c.err(2)==2
            s=[s n ' Warning: borderline nonoscillatory/oscillatory classification.'];
        end
        if c.err(2)==3
            s=[s n ' Warning: borderline Lc/Lp classification.'];
        end
        if c.err(2)==4
            s=[s n ' No information on Lc/Lp classification.'];
        end
        if c.err(2)==5
            s=[s n ' No information on Osc/Nonosc classification.'];
        end
        s=[s n '   The problem is singular.'];
        s=[s n '   It is nonoscillatory for eigenvalues < ' num2str(c.cev(2)) ' and oscillatory otherwise.'];
        if c.limit_circle(2)>-1 
            if c.limit_circle(2)
              s= [s n '   It is limit circle.'];
            else
              s= [s n '   It is limit point.']; 
            end
        end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end
s=[s n n];