function sch = set(sch,varargin)
% SCHROD\SET Set properties and return the updated  
% Schrodinger-object
property_argin = varargin;
while length(property_argin) >= 2,
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    switch prop
    case 'V'
        if isa(val,'inline')
          sch.V= val;  
        else
          error('please pass an inline object with symbolic variable x')    
        end
    case 'min'
        sch.min = val;
    case 'max'
        sch.max = val;
    case 'a0'
        sch.a0 = val;
    case 'a1'
        sch.a1 = val;
    case 'b0'
        sch.b0 = val;
    case 'b1'
        sch.b1 = val;  
    case 'singularities'
        sch.singularities = val;
    otherwise
        error('Schrodinger properties: V, min, max, a0, b0, a1, b1, singularities')
    end
end