function sl = set(sl,varargin)
% @SLP\SET Set properties and return the updated Sturm-Liouville-object
property_argin = varargin;
while length(property_argin) >= 2,
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    switch prop
    case 'p'
        sl.p = val;
    case 'q'
        sl.q = val;
    case 'w'
        sl.w = val;
    case 'min'
        sl.min = val;
    case 'max'
        sl.max = val;
    case 'a0'
        sl.a0 = val;
    case 'a1'
        sl.a1 = val;
    case 'b0'
        sl.b0 = val;
    case 'b1'
        sl.b1 = val;   
    otherwise
        error('Sturm-Liouville properties: p, q, w, min, max, a0, b0, a1, b1')
    end
end