function x = r2x(transf_slp,r)
% x = r2x(transf_slp,r)
%R2X For input r (Sturm-Liouville) this returns the corresponding 
% value of x (schrodinger).
% r can be a vector

fcn = get(transf_slp,'fcn');
rG = get(transf_slp,'rG');
Q = get(transf_slp,'Q');

lenr=length(r);
x = zeros(lenr,1);
for j = 1:lenr   
  %determination of the interval:
  for i = 1:length(rG)-1
   if ((r(j)-rG(i))*(r(j)-rG(i+1)) <= 0) 
     break; 
   else
     x(j) = x(j) + Q(i);   
   end
  end  

  %only the integral from rG(i) up to r is evaluated
  x(j) = x(j) + gauss(fcn,rG(i),r(j));     
end
 