function tr = transformed_slp(varargin)
%TRANSFORMED_SLP class constructor
% tr = transformed_slp(schrod,sl,rG,xG,Q)
%
% V = V(r), 
% to obtain V(x) of the corresponding schrodinger-object: 
%        first apply r=x2r(fcn,rG,xG,x).
% xmin,xmax, a0, b0, a1, b1: associated to the schrodinger-object

switch nargin
case 0
    % if no input arguments, create a default object
   parent = schrod('x',0,1);
   tr.fcn = inline('1');
   tr.rG = 0;
   tr.xG = 0;
   tr.Q = 0;
   tr.sl = slp('1','x','1',0,1);
   tr = class(tr,'transformed_slp',parent);
case 1    
 if isa(varargin{1},'transformed_slp')
     tr = varargin{1};
 else
     error('transformed_slp constructor: Input argument is not a transformed_slp object')
 end
case 5
  parent = varargin{1};    
  fcn = char(simple(sym(sprintf('sqrt((%s)/(%s))',char(get(varargin{2},'w')),char(get(varargin{2},'p'))))));
  fcn= vectorize([fcn '+0*x']); % makes it possible to do fcn(X) where X is a vector
  fcni = inline(fcn);
  tr.fcn = fcni;
  tr.sl = varargin{2};
  tr.rG = varargin{3};
  tr.xG = varargin{4};
  tr.Q = varargin{5};
  tr = class(tr,'transformed_slp',parent);
otherwise
    error('transformed_slp: Wrong number of input arguments')
end;
